/*

 COM_1251.PRG

 23-11-2019 // tips-and-tricks kod latin-to-cyrilic:
            // dupla latinina slova: lj,nj,dj,d,
            // prevode se u latinina slova: lj->q, nj->w, dj->, d->x
            // a ova latinina slova
            // prevode se u irilina slova q->lj, w->nj, ->, x->d

 15-11-2019 do 20-11-2019  // sutinske izmene i korekcije
 ========================
 14-07-2019
 10-05-2004

  COBA Systems Software
 BAST Open Source Project
 Business Account Software Technology
 www.cobasystems.com
 Program: Alaska Xbase++ 1.90.355 sl1
          XbTools, ADSDBE, eXpress++







 1. KONVERZIJA LATINICE 238/1250 U IRILICU 204/1251
 -----------------------------------------------------------------------
 FUNCTION Latin1250_TO_Cyrilic1251(cLatString) -> cCyrString
 -----------------------------------------------------------------------


 2. KONVERZIJA IRILICE 204/1251 U LATINICU 238/1250
 -----------------------------------------------------------------------
 FUNCTION Cyrilic1251_TO_Latin1250(cCyrString) -> cLatString
 -----------------------------------------------------------------------


 3. KONVERZIJA UTF-8 I UTF-16 U IRILICU 204/1251 I U LATINICU 238/1250
 -----------------------------------------------------------------------
 FUNCTION UTF8_TO_Cyrilic1251_Latin1250(cUnicodeString) -> cCyrLatString
 -----------------------------------------------------------------------
 Ne koristi se ili se retko koristi jer kod meanih slova odnosno kodnih
 strana u istom stringu ili tekstu - jedna od kodnih strana ne moe da se
 ispravno prikae u Alaska Xbase++ aplikaciji. Ispravan prikaz je mogu
 samo sa unicode slovima, ali Alaska Xbase++ jo ne podrava unicode na
 tom nivou. Iz tog razloga koriste se sledee dve funkcije: 4. i 5.


 4. KONVERZIJA UTF-8 I UTF-16 U LATINICU 238/1250
 -----------------------------------------------------------------------
 FUNCTION UTF8_TO__Latin1250(cUnicodeString) -> cLatString
 -----------------------------------------------------------------------


 5. KONVERZIJA UTF-8 I UTF-16 U IRILICU 204/1251
 -----------------------------------------------------------------------
 FUNCTION UTF8_TO__Cyrilic1251(cUnicodeString) -> cCyrString
 -----------------------------------------------------------------------




 6. Serbian Latin Font
 ------------------------------
 FUNCTION Fo_lat(nFsize,cfname)  // Fo_lat(11,"Consolas") // Serbian cp238
 ------------------------------


 7. Serbian Cyrilic Font
 ------------------------------
 FUNCTION Fo_Cyr(nFsize,cfname)  // Fo_Cyr(11,"Consolas") // Serbian cp204
 ------------------------------


 8. Serbian Latin to Serbian Cyrilic and Serbian Cyrilic to Serbian latin
 ------------------------------------------------------------------------
 FUNCTION test_cirilica_vidi(;     // prikaz 4 stringa u dialog boxu:
 cString_ASCIII_latin, cirilica,;  // string latinice i prevod u irilicu
 cString_ASCIII_cyril, latinica)   // string irilice i prevod u latinicu
 ------------------------------------------------------------------------


 9. Unicode to Serbian Latin and Unicode to Serbian Cyrilic
 -------------------------------------------
 FUNCTION test_unicode__to_cyr_lat(cUnicode)
 -------------------------------------------




  Izmene: 20.11.2019

  preraen i popravljen program com_1251.prg iz 2004 godine:
  ----------------------------------------------------------
  korigovano 16-11-2019 sa sledeim izmenama
  u odnosu na staru verziju od 25.07.2019:

  Konverziona tabela za funkcije:
  FUNCTION Latin1250_TO_Cyrilic1251(cLatString)
  FUNCTION Cyrilic1251_TO_Latin1250(cCyrString)
  prebaena sa chr kodova na hexadecimalne kodove

  FUNCTION UTF8_TO_Cyrilic1251_Latin1250(cString_UTF8)
  Optimizovana je ova funkcija i poboljan je algoritam

  FUNCTION Table_Convert_UTF8_TO_Cyrilic1251_Latin1250()
  uinjene su temeljne izmene u konverzionim tabelama

  Testirano:
  ----------
  Alaska Xbase++ ima funkcije za UTF-16
  IsUnicode()    ----------------------
  Str2Unicode()  // testirano i ne radi ili ne umem da je upotrebim
  Unicode2Str()  // testirano i ne radi ili ne umem da je upotrebim

  Dodato:
  -----------
  FUNCTION UTF8_TO__Latin1250(cUnicodeString)
  FUNCTION UTF8_TO__Cyrilic1251(cUnicodeString)



*/



#include "Appevent.ch"
#include "Xbp.ch"
#include "Gra.ch"
#include "Font.ch"
#include "color.ch"
#include "common.ch"

#include "xbtsys.ch"
#include "dcdialog.ch"
#include "dcgra.ch"


* TEST PROGRAM 1
// hardkodovani demo primer translacije; LAT-CYR CYR-LAT
// koji koristi funkciju: test_cirilica_vidi()
* FUNCTION test_cirilica()
*
* Funkcija koja se moe koristiti iz aplikacije:
*-----------------------------------------------
* FUNCTION test_cirilica_vidi(;     // prikaz 4 stringa u dialog boxu:
* cString_ASCIII_latin, cirilica,;  // string latinice i prevod u irilicu
* cString_ASCIII_cyril, latinica)   // string irilice i prevod u latinicu

* TEST PROGRAM 2
// hardkodovani demo primer translacije UNICODE TO LAT i UNICODE TO CYR
// koji koristi funkciju: test_unicode__to_cyr_lat()
* FUNCTION _test_unicode__to_cyr_lat()

* Funkcija koja se moe koristiti iz aplikacije:
*-----------------------------------------------
* FUNCTION test_unicode__to_cyr_lat(cUnicode)
// string unicode prevodi se u irilicu i u latinicu i prikazuje se



*************************************************************************
FUNCTION test_cirilica()
*************************************************************************
LOCAL cString_ASCIII_latin := "",;
      cString_ASCIII_cyril := "",;
      xcirilica := "",;
      xlatinica := ""

* Prevoenje stringa latinice u string irilice
*----------------------------------------------
// kodirani ASCIII string Serbian Latin 238/1250
// upisan u program preko latinine tastature - Serbian Latin
 cString_ASCIII_latin := "Ǝ  QWX Y qwx y COBA Ll"

// taj string latinice preveden na string irilicu 204/1251:
 **************************************************************
 xcirilica   :=  Latin1250_TO_Cyrilic1251(cString_ASCIII_latin)
 **************************************************************


* Prevoenje stringa irilice u string latinice
*----------------------------------------------

// kodirani ASCIII string Serbian Cyrilic 204/1251
// upisan u program preko iriline tastature - Serbian Cyrilic
 cString_ASCIII_cyril := "؀׎       "

* stop( strtohex(substr(cString_ASCIII_cyril,16,1)),1)

// ili preizeti string irilice iz varijable dobijene prevoenjem
// stringa latinice u string irilice
* cString_ASCIII_cyril := xcirilica

// string irilica 204/1251 preveden na string latinicu 238/1250
 ***************************************************************
 xlatinica   :=  Cyrilic1251_TO_Latin1250(cString_ASCIII_cyril)
 ***************************************************************


// Nain istovremenog prikazivanja i irilice i latinice u Xbase++
 test_cirilica_vidi(cString_ASCIII_latin, xcirilica,;
                    cString_ASCIII_cyril, xlatinica)

RETURN NIL



*************************************************************************
FUNCTION test_cirilica_vidi(cString_ASCIII_latin, cirilica,;
                            cString_ASCIII_cyril, latinica)
*************************************************************************
// Nain istovremenog prikazivanja i irilice i latinice u Xbase++

LOCAL GetList := {}, GetOptions, oDlg , oTxtl, oTxtc, oTxtcc

* ovo je po defaultu za setup windowsa na Serbian Latin pa se
* tada ne mora (kao ovde) setovati font na codepage 238
* "LATIN SERBIAN (font object)
*--------------------------------
oFontl := Fo_lat(14,"Consolas") // ovde
*--------------------------------

* da bi se videla irilica mora se setovati Cyrilic font objekta
* na codepage 204
* "CYRILIC SERBIAN (font object)
*--------------------------------
oFontc := Fo_cyr(14,"Consolas") // ovde
*--------------------------------

@ 2,2 DCSAY "LATINICA PREVEDENA U IRILICU" SAYSIZE 0 FONT "10.Helv"
@ 3,2 DCSAY "u kodu napisano Serbian Latin tastaturom:" SAYSIZE 0 FONT "10.Helv"
@ 4,2 DCSAY  cString_ASCIII_latin   SAYSIZE 60,2 OBJECT oTxto
@ 6,2 DCSAY "u kodu konvertovano u Serbian Cyrilic:" SAYSIZE 0 FONT "10.Helv"
@ 7,2 DCSAY  cirilica               SAYSIZE 60,2 OBJECT oTxtc
@ 8,2 DCSAY "cString_cyrilic := Latin1250_TO_Cyrilic1251(cString_latin)" SAYSIZE 0 FONT "10.Consolas" COLOR GRA_CLR_BLUE

@ 10,2 DCSAY "IRILICA PREVEDENA U LATINICU" SAYSIZE 0 SAYCOLOR GRA_CLR_DARKRED FONT "10.Helv"
@ 11,2 DCSAY "u kodu napisano Serbian Cyrilic tastaturom:" SAYSIZE 0 FONT "10.Helv"
@ 12,2 DCSAY  cString_ASCIII_cyril  SAYSIZE 60,2 OBJECT oTxtx   SAYCOLOR GRA_CLR_DARKRED
@ 14,2 DCSAY "u kodu konvertovano u Serbian Latin:" SAYSIZE 0 FONT "10.Helv"
@ 15,2 DCSAY  latinica              SAYSIZE 60,2 OBJECT oTxtl   SAYCOLOR GRA_CLR_DARKRED
@ 16,2 DCSAY "cString_latin := Latin1250_TO_Cyrilic1251(cString_cyrilic)" SAYSIZE 0 FONT "10.Consolas" COLOR GRA_CLR_BLUE


@ 18,2 DCSAY " "
@ 19,2 DCSAY "Da bi ovaj demo ispravno radio Windows mora biti podeen"   SAYSIZE 0 FONT "10.Helv"
@ 20,2 DCSAY "u delu za regionalno setovanje na Serbian Latin code page." SAYSIZE 0 FONT "10.Helv"
@ 21,2 DCSAY " "

DCGETOPTIONS ICON 1

DCREAD GUI OPTIONS GetOptions TITLE "DEMO :: LATINICA U IRILICU - IRILICA U LATINICU" ;
   FIT ;
   PARENT @oDlg ;
   EVAL {|o| SetAppWindow(o), ;
   oTxto:setfont(oFontl), ;
   oTxtc:setfont(oFontc), ;
   oTxtx:setfont(oFontc), ;
   oTxtl:setfont(oFontl) } ;
   MODAL

RETURN NIL


***************************************************************
FUNCTION Fo_lat(nFsize,cfname)
***************************************************************
* ovo je po defaultu za setup windowsa na Serbian Latin pa se
* tada ne mora (kao ovde) setovati font na codepage 238
* "LATIN SERBIAN (font object)
*--------------------------------
oFontl := XbpFont():new()
oFontl:familyName := cFname // 'Consolas' //'Arial'
oFontl:nominalPointSize := nFsize // 14
oFontl:bold := .t.
//oFontl:italic := .t.
//oFontl:underScore := .t.
oFontl:codePage := 238 // CodePage Serbian latin=238/1250
oFontl:create()// L A T I N I C A
RETURN oFontl

***************************************************************
FUNCTION Fo_cyr(nFsize,cfname)
***************************************************************
* da bi se videla irilica mora se setovati Cyrilic font objekta
* na codepage 204
* "CYRILIC SERBIAN (font object)
*--------------------------------
oFontc := XbpFont():new()
oFontc:familyName := cFname //'Consolas' // 'Arial'
oFontc:nominalPointSize := nFsize //14
oFontc:bold := .t.
//oFontc:italic := .t.
//oFontc:underScore := .t.
oFontc:codePage := 204 // CodePage Serbian cyrilic=204/1251
oFontc:create() //  I R I L I C A
RETURN oFontc










*########################################################################
 STATIC FUNCTION test_unicode__to_cyr_lat_help()
*########################################################################
LOCAL txt := "", cr := chr(13)+chr(10)
TEXT INTO txt WRAP cr //TRIMMED
Alaska Xbase++ i njena baza podataka DBFNTX, FOXCDX i ADSDBE nemaju
mehanizam za rad sa unicode fontovima, a esto postoji potreba za tim,
pa se to mora reavati po metodi: kako-se-ko-snae.
Ovaj program demonstrira jedan od naina za operativni rad sa unicode
UTF-8 i UTF-16 fontovima u Alaska Xbase++ aplikaciji.

Primer: String: QWERTZUIOPASDFGHJKLƎYXCVBNM
upisan je kao irilica (Serbian cyrilic) preko iriline tastature
u TEXT polje kodirano sa UTF-8 i UTF-16 u SQL tablu (SQLite databaze)
Ovaj tekst treba iz Xbase++ aplikacije preuzeti iz SQLite database
table i upisati ga u DBF tablu odnosno u DBFNTX database Alaska Xbase++
aplikacije, u kojoj se TEXT podaci uvaju kao ANSI Serbian Latin cp238.
To se ovde izvodi na sledei nain:

 1. Iz Database table preuzme se UNICODE string u UNICODE varijablu
    UNICODE string moe biti ili irilica ili latinica nevano je
    ali se mora znati da li se konvertuje u irilicu ili u latinicu
 2. Iz UNICODE varijable se izvri konverzija u ANSI varijablu koja
    je ili irilica ili latinica u zavisnosti od upotrebljene funkcije
    za konverziju.
 3. Kada se konverzija vri radi dobijanja ANSI latinice za upis u DBF
    fajl koristi se funkcija za konverziju unicode u latinicu.
    Dobijeni string ANSI latinica se upie (REPLACE) u DBF tablu.
 4. Kada se konverzija vri radi dobijanja ANSI irilice za potrebe u
    aplikaciji ili (prikaz, pregled, tampa) koristi se funkcija za
    konverziju unicode u irilicu.

COBA 16.11.2019 (Alaska Xbase++ 1.9.355.sl1/eXpress++)
ENDTEXT
 c__procitaj(txt,"TA OVAJ PROGRAM RADI",,"V","B")
 CLEAR TYPEAHEAD
* Kada je txt = string u memoriji
*  TxtFile:=cTxt()
*  MEMOWRIT(TxtFile,txt)
*  *******************************************
*  off := Font_codepage(10,"Consolas",238,.f.)
*  C_EDIT(TxtFile,,,,,,,,off) // baznex.dll
*  *******************************************
RETURN NIL

*#############################################################
 FUNCTION _test_unicode__to_cyr_lat()
*#############################################################

test_unicode__to_cyr_lat_help()


// preuzimanje unicode stringa iz neke od SQL database
// * c:\utf__cyrilic_string.xpf - "QWERTZUIOPASDFGHJKLƎYXCVBNMqwertzuiopasdfghjklyxcvbnm" irilica
// * preuzeto iz UTF8 polja SQLite tabele
// * snimljeno u fajl: c:\utf__cyrilic_string.xpf
// * kao varijabla: utf_cyrilic_string
//
// RESTORE FROM utf__cyrilic_string.xpf ADDITIVE
//
// * dobijena varijabla je: utf_cyrilic_string
//
// UTF :=  utf_cyrilic_string
//br1:=var2char(len(UTF))
//
// xxx:=""
// FOR i=1 to len(UTF)
//     ii:=substr(UTF,i,1)
//     xxx:=xxx+ii
// NEXT i
// MEMOWRIT("T.TXT",xxx)
// preuzimanje unicode stringa iz neke od SQL database

* preuzeto iz UTF-8 polja SQLite table i iz UTF-16 polja SQLite table i ovde hardkodovano:

 UTF8a := "ЉЊЕРТЗУИОПШЂАСДФГХЈКЛ"+;
        "ЧЋЖЅЏЦВБНМљњертзуиопшђасд"+;
        "фгхјклчћжѕџцвбнм"   // utf-8 abeceda i irilica

//
// UTF8   := "(UTF-8) ŠĐČĆŽ - QWXY --- ШЂЧЋЖ - ЉЊЏЅ"  // UTF-8
// UTF16 := "(UTF-16) ŠĐČĆŽ - QWXY --- ШЂЧЋЖ - ЉЊЏЅ"       // utf-16
//

 // UTF-8 string uzet iz SQL database i prekodiran u HEX kodove kako na nnjega ne bi imao uticaja editor teksta (koda)
 hexUTF8 := "285554462D382920C5A0C490C48CC486C5BD202D2051575859202D2D2D20D0A8D082D0A7D08BD096202D20D089D08AD08FD085"
    UTF8 := hextostr(hexUTF8) // vraanje UTF-8 stringa u ASC kodove

 // UTF-16 string uzet iz SQL database i prekodiran u HEX kodove kako na nnjega ne bi imao uticaja editor teksta (koda)
 hexUTF16:= "2855544631362920C5A0C490C48CC486C5BD202D2051575859202D2D2D20D0A8D082D0A7D08BD096202D20D089D08AD08FD085202020"
    UTF16 := hextostr(hexUTF16) // vraanje UTF-16 stringa u ASC kodove

  *unicodeslika := 3990
  unicodeslika := XbpBitmap():new():create()
  unicodeslika:Load("CSYSTEMSU.DLL",3990)
  test_unicode__to_cyr_lat(UTF8a)

  *unicodeslika := 3991
  unicodeslika := XbpBitmap():new():create()
  unicodeslika:Load("CSYSTEMSU.DLL",3991)
  test_unicode__to_cyr_lat(UTF8)

  *unicodeslika := 3992
  unicodeslika := XbpBitmap():new():create()
  unicodeslika:Load("CSYSTEMSU.DLL",3992)
  test_unicode__to_cyr_lat(UTF16)

RETURN NIL


*#############################################################
 FUNCTION test_unicode__to_cyr_lat(cUnicode)
*#############################################################
* cUnicode = unicode UTF-8 ili UTF-16 string (karakteri a ne
* asc karakteri a ne chr ili hex ili ostali kodovi

LOCAL GetList := {}, GetOptions, oDlg, br1, br2, br3
LOCAL UTF, LAT, CYR


 DEFAULT cUnicode TO ""


 UTF := cUnicode
 br1 := len(UTF) // broj znakova u stringu


 * Varijabla: UTF
 * treba je prikazati na ekranu kao UTF string
 * treba je prikazati na ekranu kao ANSI cyrilic string
 * treba je prikazati na ekranu kao ANSI latin string
   oFontLat := Fo_lat(12,"Consolas") // COM_1251.PRG
   oFontCyr := Fo_cyr(12,"Consolas") // COM_1251.PRG


//stop(unicodeslika,1)
IF TYPE("unicodeslika")=="O" // ako postoji varijabla unicodeslika
//IF unicodeslika > 0          // i ako je zadat broj BMP resursa 3990, 3991, 3992
@ 5,2 DCSAY "Prikaz UTF-8/UTF-16 stringa u polju SQL database: " SAYSIZE 0 FONT "10.Helv"
@ 6,2 DCSTATIC TYPE XBPSTATIC_TYPE_BITMAP SIZE 80,2 CAPTION unicodeslika
//ENDIF
ENDIF



@ 10,2 DCSAY "Prikaz UTF-8/UTF-16 stringa preuzetog iz SQL database: "+var2char(br1)+" char" SAYSIZE 0 FONT "10.Helv"
IF br1>60
@ 11.3,2 DCSAY " "+alltrim(substr(UTF,1,(br1/2))) SAYSIZE 100,2 OBJECT oUtf1        // txt object codepage 238
@ 12.3,2 DCSAY " "+alltrim(substr(UTF,(br1/2)+1,100)) SAYSIZE 100,2 OBJECT oUtf2    // txt object codepage 238
ELSE
@ 11.3,2 DCSAY " "+alltrim(substr(UTF,1,(br1))) SAYSIZE 100,2 OBJECT oUtf1        // txt object codepage 238
@ 12.3,2 DCSAY " "+"" SAYSIZE 100,2 OBJECT oUtf2    // txt object codepage 238
ENDIF

  // konverzija UTF-8 u irilicu
  // CYR  := UTF8_TO_Cyrilic1251_Latin1250(UTF)  // COM1251.PRG
  // ne koristi se jer se ovoj funkciji mora poslati irilini string
  ************************************
    CYR  := UTF8_TO__Cyrilic1251(UTF) // COM1251.PRG
  ************************************
  * ova funkcija bilo kakav unicode string konvertuje u irilini string
    br2:=var2char(len(CYR)) // broj znakova u stringu


@ 14,2 DCSAY "Posle konverzije UTF-8/UTF-16 stringa u Serbian Cyrilic: "+br2+" char" SAYSIZE 0 FONT "10.Helv"   // codepage 238
@ 15.3,2 DCSAY  " "+CYR SAYSIZE 100,2 OBJECT oCyr COLOR GRA_CLR_DARKRED // txt object codepage 204
@ 16.4,2 DCSAY "cCYR := UTF8_TO__Cyrilic1251(cUTF)" SAYSIZE 0 FONT "10.Consolas" COLOR GRA_CLR_BLUE

  // konverzija UTF-8 u latinicu
  // LAT  := UTF8_TO_Cyrilic1251_Latin1250(UTF)  // COM1251.PRG
  // ne koristi se jer se ovoj funkciji mora poslati latinini string
  ************************************
    LAT  := UTF8_TO__Latin1250(UTF) // COM1251.PRG
  ************************************
  * ova funkcija bilo kakav unicode string konvertuje u latinini string
    br3:=var2char(len(LAT)) // broj znakova u stringu


@ 18,2 DCSAY "Posle konverzije UTF-8/UTF-16 stringa u Serbian Latin: "+br3+" char" SAYSIZE 0 FONT "10.Helv"   // codepage 238
@ 19.3,2 DCSAY " "+LAT SAYSIZE 100,2 OBJECT oLat  // txt object codepage 204
@ 20.4,2 DCSAY "cLAT := UTF8_TO__Latin1250(cUTF)" SAYSIZE 0 FONT "10.Consolas" COLOR GRA_CLR_BLUE


@ 22,2 DCSAY " "
@ 23,2 DCSAY "Da bi ovaj demo ispravno radio Windows moe biti podeen u delu za regionalno setovanje"   SAYSIZE 0 FONT "10.Helv"
@ 24,2 DCSAY "na bilo koju kodnu stranu: na Serbian Latin ili Serbian Cyrilic ili bilo koju postojeu code page."  SAYSIZE 0 FONT "10.Helv"
@ 25,2 DCSAY " "

DCGETOPTIONS ICON 1

DCREAD GUI OPTIONS GetOptions TITLE "UTF8-TO-Serbian Cyrilic and UTF-8-TO-Serbian Latin" ;
   FIT ;
   PARENT @oDlg ;
   EVAL {|o| SetAppWindow(o), ;
   oUtf1:setfont(oFontLat), ;
   oUtf2:setfont(oFontLat), ;
   oCyr:setfont(oFontCyr) , ;
   oLat:setfont(oFontLat)}  ;
   MODAL

RETURN NIL



























*"======================"
*"FUNKCIJE ZA BIBLIOTEKU
*"======================"



//#######################################################################
//
//                               20.11.2019
//
//          KONVERZIJA IRILICE U LATINICU I LATINICE U IRILICU
//                 UPOTREBA U Alaska Xbase++ APLIKACIJAMA
//
//                         testirano i provereno
//       sva slova se konvertuju u irilicu i u latinicu ispravno
//
// posebno reen problem sa tasterom Yy na irilinoj tastaturi gde daje
// na irilici slova S i s sa hex kodom BD i BE (to nisu slova S i s)
// na latinici slova Y i y sa hex kodom 59 i 79
// Posebno reeni problemi sa konverzijom Q,W,X (lj,nj,d) iz irilice
// u latinicu gde se jedno slovo konvertuje u dva slova
//
//#######################################################################

* U aplikaciji se upotrebljavaju samo ove dve funkcije:

* FUNCTION Latin1250_TO_Cyrilic1251(cString_ASCIII)
* "ta radi ova funkcija:
* "String Latinice cp238/1250 prevodi se u string irilice cp204/1251

* FUNCTION Cyrilic1251_TO_Latin1250(cString_1251)
* "ta radi ova funkcija:
* "String irilice cp204/1251 prevodi se u string Latinice cp238/1250




* Sistem rada ( funkcija i pomone funkcije):
* FUNCTION Latin1250_TO_Cyrilic1251(cString_ASCIII)
*   FUNCTION Table_Convert_Latin1250_TO_Cyrilic1251("L2C")
*   FUNCTION Char_Latin1250_TO_Cyrilic1251(cChar)


* FUNCTION Cyrilic1251_TO_Latin1250(cString_1251)
*   FUNCTION Table_Convert_Latin1250_TO_Cyrilic1251("C2L")
*   FUNCTION Char_Cyrilic1251_TO_Latin1250(cChar)





******************************************************************* LATINICA U IRILICU"
FUNCTION Latin1250_TO_Cyrilic1251(cString_ASCIII)
*******************************************************************
* String Latinice 238/1250 prevodi se u string irilice 204/1251
*---------------------------------------------------------------

LOCAL jj,;
 nString_Duzina := LEN(cString_ASCIII) ,; // duzina stringa
 cString_1251 := ""                    ,;
 cXhar := ""                           ,;
 cChar := ""                           ,;
 cChar1 := "", cChar2 := ""

 DECLARE a_lat[62], a_cir[62]
 ***********************************************
 Table_Convert_Latin1250_TO_Cyrilic1251("L2C")   // tabela za konverziju latinica-u-irilicu i obrnuto
 ***********************************************
 * formirani nizovi a_lat, a_cir


 FOR jj = 1 To nString_Duzina

         // kod latinice se uvek uitavaju 2 karaktera zbog slova: lj, nj, dj, d
         cChar1 := SUBSTR(cString_ASCIII,jj,1)    // izdvoji karakter
         cChar2 := SUBSTR(cString_ASCIII,jj+1,1)  // izdvoji njegov sledei karakter


         cChar := cChar1 // inicijalno prevodi se prvi izdvojeni karakter


         //----------------------------------------------------------- 23.11.2019
         // sledi provera da li su prvi i drugi karakter duplo slovo:

         IF cChar1$"L" .and. cChar2$"Jj"
            cChar := "Q"  // samo ako su dva karaktera duplo slovo, saimaju se u jedan karakter
            jj:=jj+1        // uvea se broja da u novom krugu ne uzme ponovo sledei karakter
         ENDIF
         IF cChar1$"l" .and. cChar2$"j"
            cChar := "q"
            jj:=jj+1
         ENDIF
         IF cChar1$"N" .and. cChar2$"Jj"
            cChar := "W"
            jj:=jj+1
         ENDIF
         IF cChar1$"n" .and. cChar2$"j"
            cChar := "w"
            jj:=jj+1
         ENDIF
         IF cChar1$"D" .and. cChar2$""
            cChar := "X"
            jj:=jj+1
         ENDIF
         IF cChar1$"d" .and. cChar2$""
            cChar := "x"
            jj:=jj+1
         ENDIF
         IF cChar1$"D" .and. cChar2$"Jj"
            cChar := ""
            jj:=jj+1
         ENDIF
         IF cChar1$"d" .and. cChar2$"j"
            cChar := ""
            jj:=jj+1
         ENDIF
         //----------------------------------------------------------- 23.11.2019

         *********************************************
         cXhar := Char_Latin1250_TO_Cyrilic1251(cChar)
         *********************************************
         cString_1251 := cString_1251 + cXhar

 NEXT jj

RETURN(cString_1251)

******************************************************************** LATINICA U IRILICU"
 FUNCTION Char_Latin1250_TO_Cyrilic1251(cChar)
********************************************************************
* Karakter Latinice 238/1250 prevodi se u karakter irilice 204/1251
*-------------------------------------------------------------------
// Prevodjenje KONVERZIJA primljenog ASCIII znaka (karaktera) 1250
// (latinica) u karakter po kodnoj strani 1251 (Windows cirilica) i
// vracanje tog novog karaktera u glavni program.

LOCAL jj, nn, nChar, nXhar, cXhar

 * cChar // PRIMLJENI znak koji se iz ansi ASCIII prevodi u 1251

// nChar  := ASC(cChar)   // numerik: CHR kod PRIMLJENOG znaka
// nXhar  := nChar        // numerik: inicijalno
// nn     := LEN(a_lat)

 nChar  := StrToHex(cChar)   // numerik: HEX kod PRIMLJENOG znaka
 nXhar  := nChar             // numerik: inicijalno
 nn     := LEN(a_lat)

 ***************************** prima se a_lat[] vraa se aCyr[]
 FOR jj = 1 to nn

     IF a_lat[jj] == nChar   // ako nadjes u tabeli isti ansi ASC kod...
        nXhar := a_cir[jj]   // uzmi iz tabele odgovarajuci 1251 ASC kod
        EXIT                 // prekini dalje trazenje
     ENDIF

 NEXT jj
 ***************************** prima se a_lat[] vraa se aCyr[]

 // cXhar := CHR(nXhar)    // string: 1251 ASC kod PRIMLJENOG znaka prevedi u znak
 cXhar := HexToStr(nXhar)    // string: ANSI HEX kod PRIMLJENOG znaka prevedi u znak

RETURN(cXhar)










****************************************************************  IRILICA U LATINICU
FUNCTION Cyrilic1251_TO_Latin1250(cString_1251)
****************************************************************
* String irilice 204/1251 prevodi se u string latinice 238/1250
*---------------------------------------------------------------

 LOCAL jj ,;
 nString_Duzina := LEN(cString_1251) ,;// duzina stringa
 cString_ASCIII := ""                ,;
 cXhar := ""                         ,;
 cChar := ""

 DECLARE a_lat[62], a_cir[62]
 **********************************************
 Table_Convert_Latin1250_TO_Cyrilic1251("C2L")    // tabela za konverziju latinica-u-irilicu i obrnuto
 **********************************************
 * formirani nizovi a_lat, a_cir


 FOR jj = 1 To nString_Duzina

         cChar := SUBSTR(cString_1251,jj,1)  // izdvoji karakter
         *********************************************
         cXhar := Char_Cyrilic1251_TO_Latin1250(cChar)
         *********************************************
         cString_ASCIII := cString_ASCIII + cXhar

 NEXT jj

RETURN (cString_ASCIII)

******************************************************************** IRILICA U LATINICU
 FUNCTION Char_Cyrilic1251_TO_Latin1250(cChar)
********************************************************************
* Karakter irilice 204/1251 prevodi se u karakter latinice 238/1250
*-------------------------------------------------------------------
// Prevodjenje KONVERZIJA primljenog ASCIII znaka (karaktera) 1251
// (cirilica) u karakter po kodnoj strani 1250 (Windows latinica) i
// vracanje tog novog karaktera u glavni program.



LOCAL jj, nn, nChar,nXhar,cXhar

 * cChar                // PRIMLJENI znak koji se iz ansi1251 prevodi u 1250

// nChar  := ASC(cChar)   // numerik: CHR kod PRIMLJENOG znaka
// nXhar  := nChar        // numerik: - inicijalno
// nn     := LEN(a_cir)

 nChar  := StrToHex(cChar)   // numerik: HEX kod PRIMLJENOG znaka
 nXhar  := nChar             // numerik: inicijalno
 nn     := LEN(a_lat)


 ***************************** prima se a_cyr[] vraa se aLat[]
 FOR jj=1 to nn

     IF a_cir[jj] == nChar   // ako nadjes u tabeli isti ansi ASC kod...
        nXhar := a_lat[jj]   // uzmi iz tabele odgovarajuci 1250 ASC kod
        EXIT                 // prekini dalje trazenje
     ENDIF

 NEXT jj
 ***************************** prima se a_cyr[] vraa se aLat[]

 //cXhar := CHR(nXhar)    // string: 1250 ASC kod PRIMLJENOG znaka prevedi u znak
 cXhar := HexToStr(nXhar)    // string: ANSI HEX kod PRIMLJENOG znaka prevedi u znak

RETURN(cXhar)






* 14-07-2019   // tabela za konverziju latinica-u-irilicu i obrnuto
********************************************************************  LATINICA U IRILICU
FUNCTION Table_Convert_Latin1250_TO_Cyrilic1251(cc)
********************************************************************  IRILICA U LATINICU
* Karakter Latinice 238/1250 prevodi se u karakter irilice 204/1251
*-------------------------------------------------------------------
// Tabela za Prevodjenje KONVERZIJU ASCIII znaka 238/1250 (latinica)
// u ASCIII znak po kodnoj strani 204/1251 (irilica)
// koristi CHR kodove znakova, a formira PUBLIC array:
// a_lat - sa 1 do 62 znaka latinice i
// a_cir - sa odgovarajuih 1 do 62 znaka irilice

* LOCAL nn := 62
* DECLARE a_lat[nn], a_cir[nn]



/*
*----------------------------------------------- ENG LATINICA VELIKA SLOVA START
 a_lat[61]  := "41"   // A  1250 latinica (hex)
 a_lat[62]  := "42"   // B
 a_lat[63]  := "43"   // C
 a_lat[64]  := "44"   // D
 a_lat[65]  := "45"   // E
 a_lat[66]  := "46"   // F
 a_lat[67]  := "47"   // G
 a_lat[68]  := "48"   // H
 a_lat[69]  := "49"   // I
 a_lat[70]  := "4A"   // J
 a_lat[71]  := "4B"   // K
 a_lat[72]  := "4C"   // L
 a_lat[73]  := "4D"   // M
 a_lat[74]  := "4E"   // N
 a_lat[75]  := "4F"   // O
 a_lat[76]  := "50"   // P
 a_lat[77]  := "51"   // Q
 a_lat[78]  := "52"   // R
 a_lat[79]  := "53"   // S
 a_lat[80]  := "54"   // T
 a_lat[81]  := "55"   // U
 a_lat[82]  := "56"   // V
 a_lat[83]  := "57"   // W
 a_lat[84]  := "58"   // X
 a_lat[85]  := "59"   // Y
 a_lat[86]  := "5A"   // Z
*----------------------------------------------- ENG LATINICA VELIKA SLOVA END

*---------------------------------------------- ENG LATINICA-MALA-SLOVA-START

 a_lat[87]  := "61"   // a  1250 latinica (hex)
 a_lat[88]  := "62"   // b
 a_lat[89]  := "63"   // c
 a_lat[90]  := "64"   // d
 a_lat[91]  := "65"   // e
 a_lat[92]  := "66"   // f
 a_lat[93]  := "67"   // g
 a_lat[94]  := "68"   // h
 a_lat[95]  := "69"   // i
 a_lat[96]  := "6A"   // j
 a_lat[97]  := "6B"   // k
 a_lat[98]  := "6C"   // l
 a_lat[99]  := "6D"   // m
 a_lat[100] := "6E"   // n
 a_lat[101] := "6F"   // o
 a_lat[102] := "70"   // p
 a_lat[103] := "71"   // q
 a_lat[104] := "72"   // r
 a_lat[105] := "73"   // s
 a_lat[106] := "74"   // t
 a_lat[107] := "75"   // u
 a_lat[108] := "76"   // v
 a_lat[109] := "77"   // w
 a_lat[110] := "78"   // x
 a_lat[111] := "79"   // y
 a_lat[112] := "7A"   // z

*---------------------------------------------- ENG LATINICA-MALA-SLOVA-END

*---------------------------------------------- LATINICA-SERBIAN-SLOVA-START
*     

 a_lat[113] := "8A"   //   1250 latinica (hex)
 a_lat[114] := "9A"   // 

 a_lat[115] := "D0"   // 
 a_lat[116] := "F0"   // 

 a_lat[117] := "C8"   // 
 a_lat[118] := "E8"   // 

 a_lat[119] := "C6"   // 
 a_lat[120] := "E6"   // 

 a_lat[121] := "8E"   // 
 a_lat[122] := "9E"   // 

*---------------------------------------------- LATINICA-SERBIAN-SLOVA-END

*---------------------------------------------- IRILICA-VELIKA-SLOVA-START
 a_cir[1]   := "C0"     //   A  1251 irilica (hex)
 a_cir[2]   := "C1"     //   B
 a_cir[3]   := "C2"     //   V
 a_cir[4]   := "C3"     //   G
 a_cir[5]   := "C4"     //   D
 a_cir[6]   := "C5"     //   E
 a_cir[7]   := "C6"     //   
 a_cir[8]   := "C7"     //   Z se dobija i na Y
 a_cir[9]   := "C8"     //   I
 a_cir[10]  := "CA"     //   K
 a_cir[11]  := "CB"     //   L
 a_cir[12]  := "CC"     //   M
 a_cir[13]  := "CD"     //   N
 a_cir[14]  := "CE"     //   O
 a_cir[15]  := "CF"     //   P
 a_cir[16]  := "D0"     //   R
 a_cir[17]  := "D1"     //   S
 a_cir[18]  := "D2"     //   T
 a_cir[19]  := "D3"     //   U
 a_cir[20]  := "D4"     //   F
 a_cir[21]  := "D5"     //   H
 a_cir[22]  := "D6"     //   C
 a_cir[23]  := "D7"     //   
 a_cir[24]  := "D8"     //   
 a_cir[25]  := "80"     //   
 a_cir[26]  := "A3"     //   J
 a_cir[27]  := "8A"     //   LJ
 a_cir[28]  := "8C"     //   NJ
 a_cir[29]  := "8E"     //   
 a_cir[30]  := "8F"     //   D
*---------------------------------------------- IRILICA-VELIKA-SLOVA-END

*---------------------------------------------- IRILICA-MALA-SLOVA-START

 a_cir[31]  := "E0"     //   a  1251 irilica (hex)
 a_cir[32]  := "E1"     //   b
 a_cir[33]  := "E2"     //   v
 a_cir[34]  := "E3"     //   g
 a_cir[35]  := "E4"     //   d
 a_cir[36]  := "E5"     //   e
 a_cir[37]  := "E6"     //   
 a_cir[38]  := "E7"     //   z
*a_cir[38]  := "E7"     //   y
 a_cir[39]  := "E8"     //   i
 a_cir[40]  := "EA"     //   k
 a_cir[41]  := "EB"     //   l
 a_cir[42]  := "EC"     //   m
 a_cir[43]  := "ED"     //   n
 a_cir[44]  := "EE"     //   o
 a_cir[45]  := "EF"     //   p
 a_cir[46]  := "F0"     //   r
 a_cir[47]  := "F1"     //   s
 a_cir[48]  := "F2"     //   t
 a_cir[49]  := "F3"     //   u
 a_cir[50]  := "F4"     //   f
 a_cir[51]  := "F5"     //   h
 a_cir[52]  := "F6"     //   c
 a_cir[53]  := "F7"     //   
 a_cir[54]  := "F8"     //   
 a_cir[55]  := "90"     //   
 a_cir[56]  := "BC"     //   j
 a_cir[57]  := "9A"     //   lj
 a_cir[58]  := "9C"     //   nj
 a_cir[59]  := "9E"     //   
 a_cir[60]  := "9F"     //   d


*---------------------------------------------- IRILICA-MALA-SLOVA-END
*/


***********************************************
*     K O N V E R Z I J A  S T A R T
***********************************************
* KONVERZIJA LAT-CYR CYR-LAT ZA VELIKA SLOVA
***********************************************

 a_lat[1]   := "41"   // A  1250 latinica (hex)
 a_cir[1]   := "C0"   // A  1251 irilica (hex)

 a_lat[2]   := "42"   // B
 a_cir[2]   := "C1"   // B

 a_lat[3]   := "43"   // C
 a_cir[3]   := "D6"   // C

 a_lat[4]   := "44"   // D
 a_cir[4]   := "C4"   // D

 a_lat[5]   := "45"   // E
 a_cir[5]   := "C5"   // E

 a_lat[6]   := "46"   // F
 a_cir[6]   := "D4"   // F

 a_lat[7]   := "47"   // G
 a_cir[7]   := "C3"   // G

 a_lat[8]   := "48"   // H
 a_cir[8]   := "D5"   // H

 a_lat[9]   := "49"   // I
 a_cir[9]   := "C8"   // I

 a_lat[10]  := "4A"   // J
 a_cir[10]  := "A3"   // J

 a_lat[11]  := "4B"   // K
 a_cir[11]  := "CA"   // K

 a_lat[12]  := "4C"   // L
 a_cir[12]  := "CB"   // L

 a_lat[13]  := "4D"   // M
 a_cir[13]  := "CC"   // M

 a_lat[14]  := "4E"   // N
 a_cir[14]  := "CD"   // N

 a_lat[15]  := "4F"   // O
 a_cir[15]  := "CE"   // O

 a_lat[16]  := "50"   // P
 a_cir[16]  := "CF"   // P

IF cc == "C2L"
 a_lat[17]  := "4C4A" // Q --- L+J  ---> izlaz dva slova
 a_cir[17]  := "8A"   //   --- LJ   <--- ulaz
ELSE
 a_lat[17]  := "51"   // Q --- Q    <--- ulaz
 a_cir[17]  := "8A"   //   --- LJ   ---> izlaz
ENDIF

 a_lat[18]  := "52"   // R
 a_cir[18]  := "D0"   // R

 a_lat[19]  := "53"   // S
 a_cir[19]  := "D1"   // S

 a_lat[20]  := "54"   // T
 a_cir[20]  := "D2"   // T

 a_lat[21]  := "55"   // U
 a_cir[21]  := "D3"   // U

 a_lat[22]  := "56"   // V
 a_cir[22]  := "C2"   // V

IF cc == "C2L"
 a_lat[23]  := "4E4A" // W --- N+J ---> izlaz dva slova
 a_cir[23]  := "8C"   //   --- NJ  <--- ulaz
ELSE
 a_lat[23]  := "57"   // W --- W   <--- ulaz
 a_cir[23]  := "8C"   //   --- NJ  ---> izlaz
ENDIF

IF cc == "C2L"
 a_lat[24]  := "448E" // X --- D+ ---> izlaz dva slova
 a_cir[24]  := "8F"   //   --- D  <--- ulaz
ELSE
 a_lat[24]  := "58"   // X --- X  <--- ulaz
 a_cir[24]  := "8F"   //   --- D ---> izlaz
ENDIF

IF cc == "C2L"
 a_lat[25]  := "59"   // Y ---> izlaz
 a_cir[25]  := "BD"   // Y --- isto je i u latinici i u irilici <--- ulaz
ELSE
 a_lat[25]  := "59"   // Y ---
 a_cir[25]  := "59"   // Y --- isto je i u latinici i u irilici
ENDIF

 a_lat[26]  := "5A"   // Z
 a_cir[26]  := "C7"   // Z

***********************************************
* KONVERZIJA LAT-CYR CYR-LAT ZA MALA SLOVA
***********************************************

 a_lat[27]  := "61"   // a  1250 latinica (hex)
 a_cir[27]  := "E0"   // a  1251 irilica (hex)

 a_lat[28]  := "62"   // b
 a_cir[28]  := "E1"   // b

 a_lat[29]  := "63"   // c
 a_cir[29]  := "F6"   // c

 a_lat[30]  := "64"   // d
 a_cir[30]  := "E4"   // d

 a_lat[31]  := "65"   // e
 a_cir[31]  := "E5"   // e

 a_lat[32]  := "66"   // f
 a_cir[32]  := "F4"   // f

 a_lat[33]  := "67"   // g
 a_cir[33]  := "E3"   // g

 a_lat[34]  := "68"   // h
 a_cir[34]  := "F5"   // h

 a_lat[35]  := "69"   // i
 a_cir[35]  := "E8"   // i

 a_lat[36]  := "6A"   // j
 a_cir[36]  := "BC"   // j

 a_lat[37]  := "6B"   // k
 a_cir[37]  := "EA"   // k

 a_lat[38]  := "6C"   // l
 a_cir[38]  := "EB"   // l

 a_lat[39]  := "6D"   // m
 a_cir[39]  := "EC"   // m

 a_lat[40]  := "6E"   // n
 a_cir[40]  := "ED"   // n

 a_lat[41]  := "6F"   // o
 a_cir[41]  := "EE"   // o

 a_lat[42]  := "70"   // p
 a_cir[42]  := "EF"   // p


IF cc == "C2L"
 a_lat[43]  := "6C6A" // q  l+j ------->
 a_cir[43]  := "9A"   // lj <-------
ELSE
 a_lat[43]  := "71"   // q
 a_cir[43]  := "9A"   // lj
ENDIF


 a_lat[44]  := "72"   // r
 a_cir[44]  := "F0"   // r

 a_lat[45]  := "73"   // s
 a_cir[45]  := "F1"   // s

 a_lat[46]  := "74"   // t
 a_cir[46]  := "F2"   // t

 a_lat[47]  := "75"   // u
 a_cir[47]  := "F3"   // u

 a_lat[48]  := "76"   // v
 a_cir[48]  := "E2"   // v


IF cc == "C2L"
 a_lat[49]  := "6E6A" // w  n+j ------>
 a_cir[49]  := "9C"   // nj <---------
ELSE
 a_lat[49]  := "77"   // w
 a_cir[49]  := "9C"   // nj
ENDIF


IF cc == "C2L"
 a_lat[50]  := "649E"   // x  d+ ------>
 a_cir[50]  := "9F"   // d <---------
ELSE
 a_lat[50]  := "78"   // x
 a_cir[50]  := "9F"   // d
ENDIF


IF cc == "C2L"
 a_lat[51]  := "79"   // y ------>
 a_cir[51]  := "BE"   // y <---------
ELSE
 a_lat[51]  := "79"   // y <---------
 a_cir[51]  := "79"   // y ------>
ENDIF


 a_lat[52]  := "7A"   // z
 a_cir[52]  := "E7"   // z

****************************************************
* KONVERZIJA LAT-CYR CYR-LAT ZA SERBIAN LATIN SLOVA
****************************************************

*     

 a_lat[53]  := "8A"   //   1250 latinica (hex)
 a_cir[53]  := "D8"   //   1251 irilica (hex)

 a_lat[54]  := "9A"   // 
 a_cir[54]  := "F8"   // 

 a_lat[55]  := "D0"   // 
 a_cir[55]  := "80"   // 

 a_lat[56]  := "F0"   // 
 a_cir[56]  := "90"   // 

 a_lat[57]  := "C8"   // 
 a_cir[57]  := "D7"   // 

 a_lat[58]  := "E8"   // 
 a_cir[58]  := "F7"   // 

 a_lat[59]  := "C6"   // 
 a_cir[59]  := "8E"   // 

 a_lat[60]  := "E6"   // 
 a_cir[60]  := "9E"   // 

 a_lat[61]  := "8E"   // 
 a_cir[61]  := "C6"   // 

 a_lat[62]  := "9E"   // 
 a_cir[62]  := "E6"   // 


***********************************************
*     K O N V E R Z I J A  E N D
***********************************************



RETURN NIL










//#######################################################################
//
//                               20.11.2019
//
//           UNICODE I UPOTREBA U Alaska Xbase++ APLIKACIJAMA
//
//                         testirano i provereno
// sva slova utf-8 i utf-16 konvertuju se u irilicu i latinicu ispravno
// i na identian nain - bez obzira da li je u pitanju utf-8 ili utf-16
//
// posebno reen problem sa tasterom Yy na irilinoj tastaturi gde daje
// na irilici slova S i s sa hex kodom BD i BE (to nisu slova S i s)
// na latinici slova Y i y sa hex kodom 59 i 79
// a unicode UTF-8 i UTF-16 za slovo Y i y ima hex kodove D085 i D195
//
//#######################################################################

* U aplikaciji se upotrebljava samo ova funkcija:
* FUNCTION UTF8_TO_Cyrilic1251_Latin1250(cString_UTF8)


* Sistem rada ( funkcija i pomone funkcije):
* FUNCTION UTF8_TO_Cyrilic1251_Latin1250(cString_UTF8)
*   FUNCTION Char_UTF8_TO_Cyrilic1251_Latin1250(cChar)
*   FUNCTION Table_Convert_UTF8_TO_Cyrilic1251_Latin1250()


* "ta radi ova funkcija:
* "----------------------
* "Iz unicode stringa UTF-8 ili UTF-16 prevodi slova u string
* "koji istovremeno ima slova irilice i latinice:
* "Serbian latin cp238/1250 i Serbian Cyrilic cp204/1251 slova
* "onako kako su bila data i u unicode stringu.
*
* Ako je windows postavljen na Serbian latin 238/1250 code page
* tada je latinica itljiva a irilica nije itljiva
* Ako je windows postavljen na Serbian cyrilic 204/1251 code page
* tada je irilica itljiva a latinica nije itljiva
*
* Iz tog razloga ova funkcija nema upotrebu za prevoenje stringova
* odnosno tekstova sa meovitim slovima latinice i irilice, ve
* rezultate daje samo kada joj se poalje string sa istim slovima
* ili samo latinica ili samo irilica. A za takve poslove postoje
* elegantnije i tanije funkcije razvijene iz ove funkcije:
*     UTF8_TO__Cyrilic1251(cUTF)
*     UTF8_TO__Latin1250(cUTF)
*



* korigovano 20-11-2019
*******************************************************************
FUNCTION UTF8_TO_Cyrilic1251_Latin1250(cString_UTF8)
*******************************************************************
* String UTF8 prevodi se u string irilice 204/1251
* String UTF8 prevodi se u string latinice 238/1250
*---------------------------------------------------------------

LOCAL jj,;
 nString_Duzina := LEN(cString_UTF8) ,; // duzina stringa
 cString_cirilica_latinica := ""     ,;
 cString_cirilica          := ""     ,;
 cXhar := ""                         ,;
 cChar := ""

 DECLARE a_utf[126], a_cir[126]
 *********************************************
 Table_Convert_UTF8_TO_Cyrilic1251_Latin1250()      // tabela za konverziju UTF8 u
 *********************************************      // irilicu i latinicu
 * formirani nizovi a_utf, a_cir



* ali kada se ne zna da li je irilica ili latinica, jer u UTF8 mogu da budu
* zajedno i rei sa irilicom i rei sa latinicom, tada treba izvriti kontrolu
* hexkoda znaka (slova) i ako hexkod pripada skupu UTF8 latinice bez Ǝ
* (u tom skupu svaki UTF8 znak (slovo) ima jedan karakter isti kao i ANSI karakter)
* tada se iz stringa uzima jedan karakter - u protivnom uzimaju se dva karaktera

//--- slui za test ---//
// xx:="";cr:=chr(13)+chr(10)
//--- slui za test ---//

 FOR jj = 1 To nString_Duzina step 1  // kontrolie se svaki karakter UTF8 stringa



         cChar := SUBSTR(cString_UTF8,jj,1)  // izdvoji jedan karakter iz UTF8 stringa


         ******************************************** 15-11-2019 START
         IF ASC(cChar) >= 0 .and. ASC(cChar) <= 127   // ne konvertuje se (isto je u UTF8 i ANSI)
         ******************************************** // VELIKA I MALA SLOVA LATINICE BEZ Ǝ I ZNAKOVI

               nChar  := StrToHex(cChar)  // numerik: HEX kod izdvojenog karaktera - ne koristi se
               cXhar  := cChar            // nema prevoenja karaktera iz UTF8 u ANSI karakter cXhar
               cString_cirilica_latinica := cString_cirilica_latinica + cXhar

         *****
         ELSE  // sve iznad 127 se konvertuje jer nije isto u UTF8 i u ANSI
         *****


             * iz UTF8 stringa se kao UTF8 slovo uzimaju dva karaktera - ovaj i sledei karakter
             * i ta dva karaktera se prevode iz UTF8 u ANSI karakter cXhar

                  cChar := SUBSTR(cString_UTF8,jj,2)  // izdvoji DVA UTF8 karaktera iz stringa
                  **************************************************
                  cXhar := Char_UTF8_TO_Cyrilic1251_Latin1250(cChar)
                  **************************************************
                  cString_cirilica_latinica := cString_cirilica_latinica + cXhar

                  jj:=jj+1  // nastavi brojanje posle dva karaktera (step 2) !


         *****************************************
         ENDIF // IF ASC(cChar) >= 0 .and. <= 127
         ***************************************** 15-11-2019 END



 NEXT jj

//--- slui za test ---//
// ctxt:="txt.txt"
// memowrit(ctxt,xx)
// listaj(ctxt)
//--- slui za test ---//


RETURN(cString_cirilica_latinica)

********************************************************************
 FUNCTION Char_UTF8_TO_Cyrilic1251_Latin1250(cChar)
********************************************************************
* Karakter UTF8 prevodi se u karakter irilice 204/1251
* Karakter UTF8 prevodi se u karakter latinice 238/1250
*-------------------------------------------------------------------
// Prevodjenje KONVERZIJA primljenog UTF8 znaka (karaktera)
// u ANSI karakter po kodnoj strani 1251 (Windows cirilica) i
// vracanje tog novog karaktera u glavni program.

// Prevodjenje KONVERZIJA primljenog UTF8 znaka (karaktera)
// u ANSI karakter po kodnoj strani 1250 (Windows latinica) i
// vracanje tog novog karaktera u glavni program.


LOCAL jj, nn, nChar, nXhar, cXhar

 * cChar // PRIMLJENI znak koji se iz UTF8 prevodi u ANSI

 nChar  := StrToHex(cChar)   // numerik: HEX kod PRIMLJENOG znaka
 nXhar  := nChar             // numerik: inicijalno
 nn     := LEN(a_utf)


*** STOP("nChar",nChar,1)  // HEXADECIMALNOI UTF8 --- TEST

 FOR jj = 1 to nn

     IF a_utf[jj] == nChar   // ako nadjes u tabeli isti UTF8 HEX kod...
        nXhar := a_cir[jj]   // uzmi iz tabele odgovarajuci ANSI HEX kod
        EXIT                 // prekini dalje trazenje
     ENDIF

 NEXT jj

*** STOP("nXhar",nXhar,1)  // HEXADECIMALNO ANSI --- TEST

 cXhar := HexToStr(nXhar)    // string: ANSI HEX kod PRIMLJENOG znaka prevedi u znak


//--- slui za test ---//
// xx:=xx +"UTF = "+cChar + cr
// xx:=xx +"HEX = "+var2char(nChar) + cr
// xx:=xx +"CYR = "+var2char(nXhar) + cr
// xx:=xx +"CYR = "+cXhar + cr
// xx:=xx +" " + cr
//--- slui za test ---//

RETURN(cXhar)



* 16.11.2019
* 14-07-2019
* // tabela koja prevodi utf8 u irilicu i latinicu i obrnuto
********************************************************************
FUNCTION Table_Convert_UTF8_TO_Cyrilic1251_Latin1250()
********************************************************************
* Karakter UTF8 prevodi se u karakter irilice 204/1251 --- napisana tabela
* Karakter UTF8 prevodi se u karakter latinice 238/1250 --- napisati tabelu
*-------------------------------------------------------------------

/*

***************************************************
 Tabela za Prevodjenje KONVERZIJU UTF8 KARAKTERA
 u ASCIII znak po kodnoj strani 204/1251 (irilica)
 koristi HEX kodove znakova, a formira PUBLIC array:
 a_utf - sa 1 do 60 znaka unicode utf8 i
 a_cir - sa odgovarajuih 1 do 60 znaka irilice



*********************************************************************** 16-11-2019
//--- 16.11.2019 testiranje radi ispravke bagova:
//--- uitan iz txt UTF8 polja SQLITE tabele irilicom napisan string:
//--- QWERTZUIOPASDFGHJKLƎYXCVBNMqwertzuiopasdfghjklyxcvbnm
//--- koji ima kuke i verige i ukupno 36 znakova
//--- svaka 2 znaka tog stringa konvertovana su u hex cod
//--- i dobijena je tabela:

----------- velika slova tabela 16.11.2019
Q = D089
W = D08A
E = D095
R = D0A0
T = D0A2
Z = D097
U = D0A3
I = D098
O = D09E
P = D09F
 = D0A8
 = D082

A = D090
S = D0A1
D = D094
F = D0A4
G = D093
H = D0A5
J = D088
K = D09A
L = D09B
 = D0A7
 = D08B
 = D096

Y = D085
X = D08F
C = D0A6
V = D092
B = D091
N = D09D
M = D09C

------------- mala slova tabela 16.11.2019
q = D199
w = D19A
e = D0B5
r = D180
t = D182
z = D0B7
u = D183
i = D0B8
o = D0BE
p = D0BF
 = D188
 = D192

a = D0B0
s = D181
d = D0B4
f = D184
g = D0B3
h = D185
j = D198
k = D0BA
l = D0BB
 = D187
 = D19B
 = D0B6

y = D195
x = D19F
c = D186
v = D0B2
b = D0B1
n = D0BD
m = D0BC

PANJA !
izmeu ove tabele gore (tabela 16.11.2019) i tabela datih na nie (UTF HEX kodovi)
ima razlike: kod velikih slova kod Z i Y, a kod malih kod z i y i kod dosta drugih...
Konverziona tabela koju koristi aplikacija uraena je po tabeli (tabela 16.11.2019)

*********************************************************************** 16-11-2019

Velika irilina slova UTF8
------------------------------------------------------
UTF8   CHAR     HEX              OCT            DEC
------------------------------------------------------
U+0410	A	0xD0 0x90	\320\220	&#1040;
U+0411	B	0xD0 0x91	\320\221	&#1041;
U+0412	V	0xD0 0x92	\320\222	&#1042;
U+0413	G	0xD0 0x93	\320\223	&#1043;
U+0414	D	0xD0 0x94	\320\224	&#1044;
U+0415	E	0xD0 0x95	\320\225	&#1045;
U+0416		0xD0 0x96	\320\226	&#1046;
U+0417	Z	0xD0 0x97	\320\227	&#1047;
U+0418	I	0xD0 0x98	\320\230	&#1048;
U+041A	K	0xD0 0x9A	\320\232	&#1050;
U+041B	L	0xD0 0x9B	\320\233	&#1051;
U+041C	M	0xD0 0x9C	\320\234	&#1052;
U+041D	N	0xD0 0x9D	\320\235	&#1053;
U+041E	O	0xD0 0x9E	\320\236	&#1054;
U+041F	P	0xD0 0x9F	\320\237	&#1055;
U+0420	R	0xD0 0xA0	\320\240	&#1056;
U+0421	S	0xD0 0xA1	\320\241	&#1057;
U+0422	T	0xD0 0xA2	\320\242	&#1058;
U+0423	U	0xD0 0xA3	\320\243	&#1059;
U+0424	F	0xD0 0xA4	\320\244	&#1060;
U+0425	H	0xD0 0xA5	\320\245	&#1061;
U+0426	C	0xD0 0xA6	\320\246	&#1062;
U+0427		0xD0 0xA7	\320\247	&#1063;
U+0428		0xD0 0xA8	\320\250	&#1064;
U+0402		0xD0 0x82	\320\202	&#1026;
U+0408	J	0xD0 0x88	\320\210	&#1032;
U+0409	LJ	0xD0 0x89	\320\211	&#1033;
U+040A	NJ	0xD0 0x8A	\320\212	&#1034;
U+040B		0xD0 0x8B	\320\213	&#1035;
U+040F	D	0xD0 0x8F	\320\217	&#1039;


Mala irilina slova UTF8
------------------------------------------------------
UTF8   CHAR     HEX              OCT            DEC
------------------------------------------------------
U+0430	a	0xD0 0xB0	\320\260	&#1072;
U+0431	b	0xD0 0xB1	\320\261	&#1073;
U+0432	v	0xD0 0xB2	\320\262	&#1074;
U+0433	g	0xD0 0xB3	\320\263	&#1075;
U+0434	d	0xD0 0xB4	\320\264	&#1076;
U+0435	e	0xD0 0xB5	\320\265	&#1077;
U+0436		0xD0 0xB6	\320\266	&#1078;
U+0437	z	0xD0 0xB7	\320\267	&#1079;
U+0438	i	0xD0 0xB8	\320\270	&#1080;
U+043A	k	0xD0 0xBA	\320\272	&#1082;
U+043B	l	0xD0 0xBB	\320\273	&#1083;
U+043C	m	0xD0 0xBC	\320\274	&#1084;
U+043D	n	0xD0 0xBD	\320\275	&#1085;
U+043E	o	0xD0 0xBE	\320\276	&#1086;
U+043F	p	0xD0 0xBF	\320\277	&#1087;
U+0440	r	0xD0 0xC0	\320\280	&#1088;
U+0441	s	0xD0 0xC1	\320\281	&#1089;
U+0442	t	0xD0 0xC2	\320\282	&#1090;
U+0443	u	0xD0 0xC3	\320\283	&#1091;
U+0444	f	0xD0 0xC4	\320\284	&#1092;
U+0445	h	0xD0 0xC5	\320\285	&#1093;
U+0446	c	0xD0 0xC6	\320\286	&#1094;
U+0447		0xD0 0xC7	\320\287	&#1095;
U+0448		0xD0 0xC8	\320\290	&#1096;
U+0458	j	0xD1 0x98	\321\230	&#1112;
U+0459	lj	0xD1 0x99	\321\231	&#1113;
U+045A	nj	0xD1 0x9A	\321\232	&#1114;
U+045B		0xD1 0x9B	\321\233	&#1115;
U+045F	d	0xD1 0x9F	\321\237	&#1119;
U+0452		0xD1 0x92	\321\222	&#1106;



Velika irilina slova 204/1251
-------------------------------
A  C0
B  C1
V  C2
G  C3
D  C4
E  C5
  C6
Z  C7
I  C8
K  CA
L  CB
M  CC
N  CD
O  CE
P  CF
R  D0
S  D1
T  D2
U  D3
F  D4
H  D5
C  D6
  D7
  D8
  80
J  A3
LJ 8A
NJ 8C
  8E
D 8F

mala irilina slova 204/1251
-------------------------------
a  E0
b  E1
v  E2
g  E3
d  E4
e  E5
  E6
z  E7
i  E8
k  EA
l  EB
m  EC
n  ED
o  EE
p  EF
r  F0
s  F1
t  F2
u  F3
f  F4
h  F5
c  F6
  F7
  F8
j  BC
lj 9A
nj 9C
  9E
d 9F
  90


***************************************************
 Tabela za Prevodjenje KONVERZIJU UTF8 KARAKTERA
 u ASCIII znak po kodnoj strani 238/1250 (latinica)
 koristi HEX kodove znakova, a formira PUBLIC array:
 a_utf - sa 1 do 60 znaka unicode utf8 i
 a_cir - sa odgovarajuih 1 do 60 znaka latinice



Velika latinina slova UTF8
--------------------------------------
UTF8   CHAR     HEX     OCT     DEC
--------------------------------------
U+0041	A	0x41	\101	&#65;  ili CHR(65)
U+0042	B	0x42	\102	&#66;
U+0043	C	0x43	\103	&#67;
U+0044	D	0x44	\104	&#68;
U+0045	E	0x45	\105	&#69;
U+0046	F	0x46	\106	&#70;
U+0047	G	0x47	\107	&#71;
U+0048	H	0x48	\110	&#72;
U+0049	I	0x49	\111	&#73;
U+004A	J	0x4A	\112	&#74;
U+004B	K	0x4B	\113	&#75;
U+004C	L	0x4C	\114	&#76;
U+004D	M	0x4D	\115	&#77;
U+004E	N	0x4E	\116	&#78;
U+004F	O	0x4F	\117	&#79;
U+0050	P	0x50	\120	&#80;
U+0051	Q	0x51	\121	&#81;
U+0052	R	0x52	\122	&#82;
U+0053	S	0x53	\123	&#83;
U+0054	T	0x54	\124	&#84;
U+0055	U	0x55	\125	&#85;
U+0056	V	0x56	\126	&#86;
U+0057	W	0x57	\127	&#87;
U+0058	X	0x58	\130	&#88;
U+0059	Y	0x59	\131	&#89;
U+005A	Z	0x5A	\132	&#90;

Mala latinina slova UTF8
--------------------------------------
UTF8   CHAR     HEX     OCT     DEC
--------------------------------------
U+0061	a	0x61	\141	&#97;
U+0062	b	0x62	\142	&#98;
U+0063	c	0x63	\143	&#99;
U+0064	d	0x64	\144	&#100;
U+0065	e	0x65	\145	&#101;
U+0066	f	0x66	\146	&#101;
U+0067	g	0x67	\147	&#103;
U+0068	h	0x68	\150	&#104;
U+0069	i	0x69	\151	&#105;
U+006A	j	0x6A	\152	&#106;
U+006B	k	0x6B	\153	&#107;
U+006C	l	0x6C	\154	&#108;
U+006D	m	0x6D	\155	&#109;
U+006E	n	0x6E	\156	&#110;
U+006F	o	0x6F	\157	&#111;
U+0070	p	0x70	\160	&#112;
U+0071	q	0x71	\161	&#113;
U+0072	r	0x72	\162	&#114;
U+0073	s	0x73	\163	&#115;
U+0074	t	0x74	\164	&#116;
U+0075	u	0x75	\165	&#117;
U+0076	v	0x76	\166	&#118;
U+0077	w	0x77	\167	&#119;
U+0078	x	0x78	\170	&#120;
U+0079	y	0x79	\171	&#121;
U+007A	z	0x7A	\172	&#122;

Naa dodatna latinina slova UTF8
------------------------------------------------------
UTF8   CHAR     HEX              OCT            DEC
------------------------------------------------------
U+0160		0xC5 0xA0	\305\240	&#352;
U+0161		0xC5 0xA1	\305\241	&#353;
U+0110		0xC4 0x90	\304\220	&#272;
U+0111		0xC4 0x91	\304\221	&#273;
U+010C		0xC4 0x8C	\304\214	&#268;
U+010D		0xC4 0x8D	\304\215	&#269;
U+0106		0xC4 0x86	\304\206	&#262;
U+0107		0xC4 0x87	\304\207	&#263;
U+017D		0xC5 0xBD	\305\275	&#381;
U+017E		0xC5 0xBE	\305\276	&#382;


velika latinina slova 238/1250
-------------------------------
A  41
B  42
C  43
D  44
E  45
F  46
G  47
H  48
I  49
J  4A
K  4B
L  4C
M  4D
N  4E
O  4F
P  50
Q  51
R  52
S  53
T  54
U  55
V  56
W  57
X  58
Y  59
Z  5A


mala latinina slova 238/1250
-------------------------------
a  61
b  62
c  63
d  64
e  65
f  66
g  67
h  68
i  69
j  6A
k  6B
l  6C
m  6D
n  6E
o  6F
p  70
q  71
r  72
s  73
t  74
u  75
v  76
w  77
x  78
y  79
z  7A


serbian latinina slova 238/1250
--------------------------------
* 掞

  8A
  9A
  D0
  F0
  C8
  E8
  C6
  E6
  8E
  9E

*/


* LOCAL nn := 126               // postavlja se u glavnom programu
* DECLARE a_utf[nn], a_cir[nn]  // postavlja se u glavnom programu

*---------------------------
*---VELIKA IRILINA SLOVA
*---------------------------
/*
Ovde ima jedan izuzetak:
kod UTF8 slovo Y (veliko i malo) kucano na irilinoj tastaturi
daje UTF8 kod ( D085 i D195 )  koji u mojoj tabeli ASC-UTF nema
odgovarajui ASC kod (jer irilica nema slovo Y)
pa se konverzijom preko te moje tabele dobije Y='R...' y='C*'
odnosno ostane UTF8 kod.

Ako se UTF8 slovo Yy ignorie u irilici (ne vri se konverzija unicode u asc kod)
tada se slovo Zz prikazuje ispravno. Ako se UTF slovo Yy konvertuje u bilo koji
drugi znak tada se na Yy dobije taj znak a slovo Zz se prikazuje kao Z='R-' z='R*'
to znai da ako se Yy zameni sa irilinim asc znakovima za Zz dobie se svuda gde
je ukucano Yy slo Zz, ali tada slova Zz budu konvertovana u Z='R-' z='R*'

Dakle, kod irilice se u zavisnosti od tastature koriste ili Y umesto Z ili
Z umesto Y (a Y se ne prikazuje)

------------- velika slova usaglaeno sa dokumentacijom (coba-blagoje) 16-11-2019
Q = D089
W = D08A
E = D095
R = D0A0
T = D0A2
Z = D097 --- Z/Y
U = D0A3 ---
I = D098
O = D09E
P = D09F
 = D0A8
 = D082

A = D090
S = D0A1
D = D094
F = D0A4
G = D093
H = D0A5
J = D088
K = D09A
L = D09B
 = D0A7
 = D08B
 = D096

Y = D085 --- Y/Z
X = D08F
C = D0A6
V = D092
B = D091
N = D09D
M = D09C
------------- usaglaeno sa dokumentacijom (coba-blagoje) 16-11-2019
*/

*---------------------------------------------- IRILICA-VELIKA-SLOVA-START
 a_utf[1]   := "D090"   // A  UTF8 irilica
 a_cir[1]   := "C0"     // A  1251 irilica
 a_utf[2]   := "D091"   // B
 a_cir[2]   := "C1"
 a_utf[3]   := "D092"   // V
 a_cir[3]   := "C2"
 a_utf[4]   := "D093"   // G
 a_cir[4]   := "C3"
 a_utf[5]   := "D094"   // D
 a_cir[5]   := "C4"
 a_utf[6]   := "D095"   // E
 a_cir[6]   := "C5"
 a_utf[7]   := "D096"   // 
 a_cir[7]   := "C6"
 a_utf[8]   := "D097"   // Z se dobija i na Y
 a_cir[8]   := "C7"
 a_utf[9]   := "D098"   // I
 a_cir[9]   := "C8"
 a_utf[10]  := "D09A"   // K
 a_cir[10]  := "CA"
 a_utf[11]  := "D09B"   // L
 a_cir[11]  := "CB"
 a_utf[12]  := "D09C"   // M
 a_cir[12]  := "CC"
 a_utf[13]  := "D09D"   // N
 a_cir[13]  := "CD"
 a_utf[14]  := "D09E"   // O
 a_cir[14]  := "CE"
 a_utf[15]  := "D09F"   // P
 a_cir[15]  := "CF"
 a_utf[16]  := "D0A0"   // R
 a_cir[16]  := "D0"
 a_utf[17]  := "D0A1"   // S
 a_cir[17]  := "D1"
 a_utf[18]  := "D0A2"   // T
 a_cir[18]  := "D2"
 a_utf[19]  := "D0A3"   // U
 a_cir[19]  := "D3"
 a_utf[20]  := "D0A4"   // F
 a_cir[20]  := "D4"
 a_utf[21]  := "D0A5"   // H
 a_cir[21]  := "D5"
 a_utf[22]  := "D0A6"   // C
 a_cir[22]  := "D6"
 a_utf[23]  := "D0A7"   // 
 a_cir[23]  := "D7"
 a_utf[24]  := "D0A8"   // 
 a_cir[24]  := "D8"
 a_utf[25]  := "D082"   // 
 a_cir[25]  := "80"
 a_utf[26]  := "D088"   // J
 a_cir[26]  := "A3"
 a_utf[27]  := "D089"   // LJ
 a_cir[27]  := "8A"
 a_utf[28]  := "D08A"   // NJ
 a_cir[28]  := "8C"
 a_utf[29]  := "D08B"   // 
 a_cir[29]  := "8E"
 a_utf[30]  := "D08F"   // D
 a_cir[30]  := "8F"


 // utf8 to cyrilic:
 // ako je utf irilica utf  hex kod za Y = D085
 // zamenjuje se sa irilica hex kod za Y = BD

 a_utf[123]  := "D085" // PRIMI SE Y irilica
 a_cir[123]  := "BD"   // dobija se Y irilica


*---------------------------------------------- IRILICA-VELIKA-SLOVA-END

*---------------------------
*---MALA IRILINA SLOVA
*---------------------------
/*
------------- mala slova usaglaeno sa dokumentacijom (coba-blagoje) 16-11-2019
q = D199
w = D19A
e = D0B5
r = D180
t = D182
z = D0B7  z/y
u = D183
i = D0B8
o = D0BE
p = D0BF
 = D188
 = D192

a = D0B0
s = D181
d = D0B4
f = D184
g = D0B3
h = D185
j = D198
k = D0BA
l = D0BB
 = D187
 = D19B
 = D0B6

y = D195  y/z
x = D19F
c = D186
v = D0B2
b = D0B1
n = D0BD
m = D0BC

------------- mala slova usaglaeno sa dokumentacijom (coba-blagoje) 16-11-2019
*/
*---------------------------------------------- IRILICA-MALA-SLOVA-START

 a_utf[31]  := "D0B0"   // a  UTF8 irilica
 a_cir[31]  := "E0"     // a  1251 irilica
 a_utf[32]  := "D0B1"   // b
 a_cir[32]  := "E1"
 a_utf[33]  := "D0B2"   // v
 a_cir[33]  := "E2"
 a_utf[34]  := "D0B3"   // g
 a_cir[34]  := "E3"
 a_utf[35]  := "D0B4"   // d
 a_cir[35]  := "E4"
 a_utf[36]  := "D0B5"   // e
 a_cir[36]  := "E5"
 a_utf[37]  := "D0B6"   // 
 a_cir[37]  := "E6"
 a_utf[38]  := "D0B7"   // z  se dobija na y
 a_cir[38]  := "E7"
*a_utf[38]  := "D195"   // y  se dobija na z
*a_cir[38]  := "E7"     //
 a_utf[39]  := "D0B8"   // i
 a_cir[39]  := "E8"
 a_utf[40]  := "D0BA"   // k
 a_cir[40]  := "EA"
 a_utf[41]  := "D0BB"   // l
 a_cir[41]  := "EB"
 a_utf[42]  := "D0BC"   // m
 a_cir[42]  := "EC"
 a_utf[43]  := "D0BD"   // n
 a_cir[43]  := "ED"
 a_utf[44]  := "D0BE"   // o
 a_cir[44]  := "EE"
 a_utf[45]  := "D0BF"   // p
 a_cir[45]  := "EF"
 a_utf[46]  := "D180"   // r
 a_cir[46]  := "F0"
 a_utf[47]  := "D181"   // s
 a_cir[47]  := "F1"
 a_utf[48]  := "D182"   // t
 a_cir[48]  := "F2"
 a_utf[49]  := "D183"   // u
 a_cir[49]  := "F3"
 a_utf[50]  := "D184"   // f
 a_cir[50]  := "F4"
 a_utf[51]  := "D185"   // h
 a_cir[51]  := "F5"
 a_utf[52]  := "D186"   // c
 a_cir[52]  := "F6"
 a_utf[53]  := "D187"   // 
 a_cir[53]  := "F7"
 a_utf[54]  := "D188"   // 
 a_cir[54]  := "F8"
 a_utf[55]  := "D198"   // j
 a_cir[55]  := "BC"
 a_utf[56]  := "D199"   // lj
 a_cir[56]  := "9A"
 a_utf[57]  := "D19A"   // nj
 a_cir[57]  := "9C"
 a_utf[58]  := "D19B"   // 
 a_cir[58]  := "9E"
 a_utf[59]  := "D19F"   // d
 a_cir[59]  := "9F"
 a_utf[60]  := "D192"   // 
 a_cir[60]  := "90"

 // utf8 to cyrilic:
 // ako je utf irilica utf  hex kod za y = D195
 // zamenjuje se sa irilica hex kod za y = BE

 a_utf[124]  := "D195" // primi se y irilica
 a_cir[124]  := "BE"   // dobija se Y irilica

*---------------------------------------------- IRILICA-MALA-SLOVA-END


*---------------------------
*---VELIKA LATININA SLOVA
*---------------------------

*---------------------------------------------- LATINICA-VELIKA-SLOVA-START
 a_utf[61]  := "41"   // A  UTF8 latinica
 a_cir[61]  := "41"   // A  1250 latinica

 a_utf[62]  := "42"   // B
 a_cir[62]  := "42"   //

 a_utf[63]  := "43"   // C
 a_cir[63]  := "43"   //

 a_utf[64]  := "44"   // D
 a_cir[64]  := "44"   //

 a_utf[65]  := "45"   // E
 a_cir[65]  := "45"   //

 a_utf[66]  := "46"   // F
 a_cir[66]  := "46"   //

 a_utf[67]  := "47"   // G
 a_cir[67]  := "47"   //

 a_utf[68]  := "48"   // H
 a_cir[68]  := "48"   //

 a_utf[69]  := "49"   // I
 a_cir[69]  := "49"   //

 a_utf[70]  := "4A"   // J
 a_cir[70]  := "4A"   //

 a_utf[71]  := "4B"   // K
 a_cir[71]  := "4B"   //

 a_utf[72]  := "4C"   // L
 a_cir[72]  := "4C"   //

 a_utf[73]  := "4D"   // M
 a_cir[73]  := "4D"   //

 a_utf[74]  := "4E"   // N
 a_cir[74]  := "4E"   //

 a_utf[75]  := "4F"   // O
 a_cir[75]  := "4F"   //

 a_utf[76]  := "50"   // P
 a_cir[76]  := "50"   //

 a_utf[77]  := "51"   // Q
 a_cir[77]  := "51"   //

 a_utf[78]  := "52"   // R
 a_cir[78]  := "52"   //

 a_utf[79]  := "53"   // S
 a_cir[79]  := "53"   //

 a_utf[80]  := "54"   // T
 a_cir[80]  := "54"   //

 a_utf[81]  := "55"   // U
 a_cir[81]  := "55"   //

 a_utf[82]  := "56"   // V
 a_cir[82]  := "56"   //

 a_utf[83]  := "57"   // W
 a_cir[83]  := "57"   //

 a_utf[84]  := "58"   // X
 a_cir[84]  := "58"   //

 a_utf[85]  := "59"   // Y
 a_cir[85]  := "59"   //

 a_utf[86]  := "5A"   // Z
 a_cir[86]  := "5A"   //




*---------------------------------------------- LATINICA-VELIKA-SLOVA-END

*---------------------------
*---MALA LATININA SLOVA
*---------------------------

*---------------------------------------------- LATINICA-MALA-SLOVA-START

 a_utf[87]  := "61"   // a  UTF8 latinica
 a_cir[87]  := "61"   // a  1250 latinica

 a_utf[88]  := "62"   // b
 a_cir[88]  := "62"   //

 a_utf[89]  := "63"   // c
 a_cir[89]  := "63"   //

 a_utf[90]  := "64"   // d
 a_cir[90]  := "64"   //

 a_utf[91]  := "65"   // e
 a_cir[91]  := "65"   //

 a_utf[92]  := "66"   // f
 a_cir[92]  := "66"   //

 a_utf[93]  := "67"   // g
 a_cir[93]  := "67"   //

 a_utf[94]  := "68"   // h
 a_cir[94]  := "68"   //

 a_utf[95]  := "69"   // i
 a_cir[95]  := "69"   //

 a_utf[96]  := "6A"   // j
 a_cir[96]  := "6A"   //

 a_utf[97]  := "6B"   // k
 a_cir[97]  := "6B"   //

 a_utf[98]  := "6C"   // l
 a_cir[98]  := "6C"   //

 a_utf[99]  := "6D"   // m
 a_cir[99]  := "6D"   //

 a_utf[100]  := "6E"   // n
 a_cir[100]  := "6E"   //

 a_utf[101]  := "6F"   // o
 a_cir[101]  := "6F"   //

 a_utf[102]  := "70"   // p
 a_cir[102]  := "70"   //

 a_utf[103]  := "71"   // q
 a_cir[103]  := "71"   //

 a_utf[104]  := "72"   // r
 a_cir[104]  := "72"   //

 a_utf[105]  := "73"   // s
 a_cir[105]  := "73"   //

 a_utf[106]  := "74"   // t
 a_cir[106]  := "74"   //

 a_utf[107]  := "75"   // u
 a_cir[107]  := "75"   //

 a_utf[108]  := "76"   // v
 a_cir[108]  := "76"   //

 a_utf[109]  := "77"   // w
 a_cir[109]  := "77"   //

 a_utf[110]  := "78"   // x
 a_cir[110]  := "78"   //

 a_utf[111]  := "79"   // y
 a_cir[111]  := "79"   //

 a_utf[112]  := "7A"   // z
 a_cir[112]  := "7A"   //



*---------------------------------------------- LATINICA-MALA-SLOVA-END

*------------------------------
* SERBIAN LATIN SLOVA 238/1250
*------------------------------

*---------------------------------------------- LATINICA-SERBIAN-SLOVA-START
* 掞

 a_utf[113]  := "C5A0" // 
 a_cir[113]  := "8A"   //
 a_utf[114]  := "C5A1" // 
 a_cir[114]  := "9A"   //


 a_utf[115]  := "C490" // 
 a_cir[115]  := "D0"   //
 a_utf[116]  := "C491" // 
 a_cir[116]  := "F0"   //


 a_utf[117]  := "C48C" // 
 a_cir[117]  := "C8"   //
 a_utf[118]  := "C48D" // 
 a_cir[118]  := "E8"   //


 a_utf[119]  := "C486" // 
 a_cir[119]  := "C6"   //
 a_utf[120]  := "C487" // 
 a_cir[120]  := "E6"   //


 a_utf[121]  := "C5BD" // 
 a_cir[121]  := "8E"   //
 a_utf[122]  := "C5BE" // 
 a_cir[122]  := "9E"   //

*---------------------------------------------- LATINICA-SERBIAN-SLOVA-END


 **********************************************************************
 *                                                  
 * IF AT(char,"C5A0,C5A1,C490,C491,C48C,C48D,C486,C487,C5BD,C5BE") > 0
 *   // ako je UTF8 Serbian Latin character Ǝ   - uvek ima dva znaka
 *   // ako je UTF8 ostali serbian latin character < 128 - uvek ima jedan znak klasian ASC kod.

 *   // ako je UTF8 Serbian Cyrilic karakter bilo koji - uvek ima dva znaka

 *   // samo ako je UTF8 Latin engleski character      - uvek ima jedan znak chr < 128
 *   // U skladu sa svakim ide druga akcija...

 * ENDIF
 *
 **********************************************************************

RETURN NIL






*************************************************************************
FUNCTION dobijanje_hex_kodova_ansi_slova()
*************************************************************************
aHex := {}
* velika slova irilice
*           "ABVGDEZIKLMNOPRSTUFHCȊJQWX"
* string := "؀"
* broj := 30

* mala slova irilice
*           "abvgdeziklmnoprstufhcjqwx"
* string := ""
* broj := 30

* velika slova latinice
*           "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
* string := "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
* broj := 26

* mala slova latinice
*           "abcdefghijklmnopqrstuvwxyz"
* string := "abcdefghijklmnopqrstuvwxyz"
* broj := 26

* Naa dodatna latinina slova
*           "掞"
 string := "掞"
 broj := 10


nn:=len(string)

for i=1 to broj
    znak:=substr(string,i,1)
    hex:=strtohex(znak)
    aadd(aHex,hex)
next i

STAMPAJ()

RETURN NIL

FUNCTION STAMPAJ()

LOCAL ctxt := ctxt()
DELETE FILE (ctxt)
SET PRINTER TO (ctxt)
SET PRINT ON
SET CONSOLE OFF
SET MARGIN TO 2

? " "
for i=1 to broj
    ? aHex[i]
next i
? " "

SET PRINTER TO
SET PRINT OFF
SET CONSOLE ON
SET MARGIN TO 0
LISTAJ(ctxt,,.f.)

RETURN NIL




























//#######################################################################
//
//                               20.11.2019
//
//           UNICODE I UPOTREBA U Alaska Xbase++ APLIKACIJAMA
//
//                         testirano i provereno
// sva slova utf-8 i utf-16 konvertuju se u irilicu i latinicu ispravno
// i na identian nain - bez obzira da li je u pitanju utf-8 ili utf-16
//
// posebno reen problem sa tasterom Yy na irilinoj tastaturi gde daje
// na irilici slova S i s sa hex kodom BD i BE (to nisu slova S i s)
// na latinici slova Y i y sa hex kodom 59 i 79
// a unicode UTF-8 i UTF-16 za slovo Y i y ima hex kodove D085 i D195
//
//#######################################################################

* U aplikaciji se upotrebljavaju samo ove dve funkcije:

*  FUNCTION UTF8_TO__Latin1250(cString_UTF8)   -> cString_LAT

* "ta radi ova funkcija:
* "----------------------
* "Vri konverziju unicode stringa UTF-8 i UTF-16 u Serbian Latin
* "string - odnosno u karakter set cp 238/1250

*  FUNCTION UTF8_TO__Cyrilic1251(cString_UTF8) -> cString_CYR

* "ta radi ova funkcija:
* "----------------------
* "Vri konverziju unicode stringa UTF-8 i UTF-16 u Serbian Cyrilic
* "string - odnosno u karakter set cp 204/1251





*  Sistem rada ( funkcija i pomone funkcije):
*
*  FUNCTION UTF8_TO__Latin1250(cString_UTF8) -> cString_LAT
*    FUNCTION Char_UTF8_TO__Latin1250(cChar)
*    FUNCTION Table_Convert_UTF8_TO__Latin1250()

*  FUNCTION UTF8_TO__Cyrilic1251(cString_UTF8) -> cString_CYR
*    FUNCTION Char_UTF8_TO__Cyrilic1251(cChar)
*    FUNCTION Table_Convert_UTF8_TO__Cyrilic1251()





*------------------------------------------------------------------------- 18-11-2019 START
* UNICODE UTF-8 I UTF-16 STRING I NJEGOV UPIS U DBF FAJL
*-------------------------------------------------------------------------
* Varijabla: cUnicode, moe biti unicode string napisan
* u latinici ili u irilici ili meano: da ima i slova
* latinice i slova irilice (i kineska slova i slino)
*
* Funkcijom:
*--------------------------------------------------------
* UTF8_TO_Cyrilic1251_Latin1250(cUnicode) // COM1251.PRG
*--------------------------------------------------------
*
* vri se translacija svakog slova tog UNICODE stringa u ANSI slovo ili
* irilice ili latinice. Svako slovo posle te translacije bude ili
* irilica ili latinica kako je i u unicode stringu.
* Dobije se ili string irilica cp1251 ili string latinica cp1250 ili pak
* string sa meavinom irilice i latinice (iji prikaz iz Xbase++ je lo)
*
* Kako ova funkcija radi:
*
* Ova funkcija za svako slovo iz unicode stringa nae UNICODE HEX COD
* a zatim u translacionoj tabeli nae taj isti HEX COD i naspram njega
* nae upisani ANSI HEX COD za cp1250 latinicu ili cp1251 irilicu i
* uzme ga kao HEX KOD za ansi slovo latinice ili irilice od koga formira
* string za ispis.
*
* Nain izvoenja translacije:
*
* cUnicode moe biti string napisan u latinici ili u irilici:
*    latinino unicode slovo A=41 ; irilino unicode slovo A=D090
*
*    u translacionoj tabeli u koju se slovo A alje, za slovo A postoje
*    dva reda:
*
*    -latinino unicode slovo    latinino ansi slovo
*           hex cod A=41    --->    hex cod A=41
*
*    -irilino unicode slovo    irilino ansi slovo
*           hex cod A=D090  --->    hex cod A=C0
*
* u zavisnosti od toga koje je slovo A poslato ova tabela vraa hex cod:
* ili hex cod = 41 ili hex cod = C0 i po njemu formira slovo i string.
* Kada je ovaj string formiran vie nikako ne moemo znati da li je on
* latinica ili irilica.
*
* Problem:
*
* Ako je dobijeni string irilica cp1251 (to sada ne moe da se utvrdi)
* - treba ga prikazati na monitoru kao irilicu (treba zadati cp204)
* - treba ga pretvoriti u latinicu cp238 radi upisa u DBF fajl koristei
*   funkciju: Cyrilic1251_TO_Latin1250(CYR) // COM1251.PRG
* ali mi neznamo ta je dobijeni string !
*
* Ako je dobijeni string latinica cp1250 (to sada ne moe da se utvrdi)
* - treba ga prikazati na monitoru kao latinicu (treba zadati cp238)
* - ne treba ga pretvoriti u latinicu cp238 radi upisa u DBF fajl
* ali mi neznamo ta je dobijeni string !
*
* Reenje:
*
* Da bi se ovaj problem prevaziao mora se korisnik odluiti ta hoe da
* dobije kao krajnji rezultat translacije unicode stringa koji je ili
* irilica ili latinica ili meano. Hoe li kao krajnji rezultat:
*  - latinini string cp 238/1250 ili
*  - irilini string cp 204/1251, meano ne moe (suvie komplikovano)!
*
* Ako se korisnik odlui za finalni latinini string
* tada se modifikuje translaciona tabela:
*    u translacionoj tabeli u koju se slovo A alje, za slovo A postoje
*    dva reda:
*
*    -latinino unicode slovo    latinino ansi slovo
*           hex cod A=41    --->    hex cod A=41
*
*    -irilino unicode slovo    irilino ansi slovo
*           hex cod A=D090  --->    hex cod A=41 // MODIFIKACIJA
*
* i na ovaj nain se odmah u translacionoj tabeli izvri translacija unicode
* latinice i unicode irilice u ansi Serbian Latin cp238/1250 ime se uvek
* dobije ispravan ansi latinini string bez obzira da li je unocode string
* bio napisan latinicom ili irilicom.
*-----------------------------------------------------------------------
* OVO JE REENO FUNKCIJOM: UTF8_TO__Latin1250(cUnicode)  // COM1251.PRG
*-----------------------------------------------------------------------
*
* Ako se korisnik odlui za finalni irilini string
* tada se modifikuje translaciona tabela:
*    u translacionoj tabeli u koju se slovo A alje, za slovo A postoje
*    dva reda:
*
*    -latinino unicode slovo    latinino ansi slovo
*           hex cod A=41    --->    hex cod A=C0  // MODIFIKACIJA
*
*    -irilino unicode slovo    irilino ansi slovo
*           hex cod A=D090  --->    hex cod A=C0
*
* i na ovaj nain se odmah u translacionoj tabeli izvri translacija unicode
* latinice i unicode irilice u ansi Serbian Cyrilic cp204/1251 ime se uvek
* dobije ispravan ansi irilini string bez obzira da li je unocode string
* bio napisan latinicom ili irilicom.
*-------------------------------------------------------------------------
* OVO JE REENO FUNKCIJOM: UTF8_TO__Cyrilic1251(cUnicode)  // COM1251.PRG
*-------------------------------------------------------------------------
*



* String UTF-8 bez obzira da li je latinica ili irilica
* prevodi se u string latinice Serbian Latin cp 238/1250
*
* Za ta se koristi:
*
* (1)
* U Xbase++ DBF fajlove upisuje se tekst kodiran kao ANSI Serbian
* Latin cp 238/1250 i ovaj karakter set Xbase++ moe da tumai i
* ispravno prikae bez ikakve konverzije ako je kao regionalno
* podeavanje Windowsa postavljeno podeavanje: Serbian Latin
*
* (2)
* U Xbase++ DBF fajlove upisuje se tekst kodiran kao ANSI Serbian
* Cyrilic cp 204/1251 i ovaj karakter set Xbase++ moe da tumai i
* ispravno prikae bez ikakve konverzije ako je kao regionalno
* podeavanje Windowsa postavljeno podeavanje: Serbian Cyrilic
*
* (3)
* U Xbase++ DBF fajlove upisuje se tekst kodiran kao UTF-8 ili
* UTF-16 i kao Serbian Cyrilic i kao Serbian Latin istovremeno
* i ovaj karakter set Xbase++ NE MOE da tumai i ispravno prikae
* bez prethodne konverzije u:
* - Serbian Latin cp 238/1250 i Serbian Cyrilic 2014/1251 meano
* - samo u Serbian Latin 238/1250 bez obzira ta je u unicode
* - samo u Serbian Cyrilic 204/1251 bez obzira ta je u unicode
* I ovde posle obavljene konverzije prikaz slova zavisie od
* regionalnog podeavanja windowsa na: Serbian Latin ili na Serbian
* Cyrilic. Ako je podeeno na Serbian Latin slova irilice bie
* neitka, a ako je podeeno na Serbian Cyrilic slova latinice bie
* neitka.
*
* (4)
* U aplikacijama COBA Systems koristi se Serbian Latin cp 238/1250
* pa preuzimanje UTF-8 ili UTF-16 stringova u aplikaciju iz drugih
* baza podataka (Oracle, PgSql, SQLite...) zahteva konverziju tih
* stringova u Serbian Latin, bez obzira da li su ti stringovi pisani
* kao unicode latinica ili irilica.
*
* Funkcija ovog programa je konverzija unicode stringa u Serbian
* Latin string - odnosno u karakter set cp 238/1250
*
*---------------------------------------------------------------


*-------------------------------------------------------------------------
* UNICODE UTF-8 I UTF-16 STRING I NJEGOV UPIS U DBF FAJL
*------------------------------------------------------------------------- 18-11-2019 END








//#################################################################

*                FUNCTION UTF8_TO__Latin1250(cString_UTF8)
*           FUNCTION Char_UTF8_TO__Latin1250(cChar)
*  FUNCTION Table_Convert_UTF8_TO__Latin1250()

* "ta radi ova funkcija:
* "----------------------
* "Vri konverziju unicode stringa UTF-8 i UTF-16 u Serbian Latin
* "string - odnosno u karakter set cp 238/1250




*"18-11-2019
*******************************************************************
FUNCTION UTF8_TO__Latin1250(cString_UTF8)
*******************************************************************


LOCAL jj,;
 nString_Duzina := LEN(cString_UTF8) ,; // duzina stringa
 cString_cirilica_latinica := ""     ,;
 cString_cirilica          := ""     ,;
 cXhar := ""                         ,;
 cChar := ""

 DECLARE a_utf[126], a_cir[126]
 *********************************************
 Table_Convert_UTF8_TO__Latin1250()            // tabela za konverziju
 ********************************************* // UTF-8 u latinicu
 * formirani nizovi a_utf, a_cir

//--- slui za test ---//
// xx:="";cr:=chr(13)+chr(10)
//--- slui za test ---//

 FOR jj = 1 To nString_Duzina step 1  // kontrolie se svaki karakter UTF8 stringa



         cChar := SUBSTR(cString_UTF8,jj,1)  // izdvoji jedan karakter iz UTF8 stringa


         ******************************************** 15-11-2019 START
         IF ASC(cChar) >= 0 .and. ASC(cChar) <= 127   // ne konvertuje se (isto je u UTF8 i ANSI)
         ******************************************** // VELIKA I MALA SLOVA LATINICE BEZ Ǝ I ZNAKOVI

               nChar  := StrToHex(cChar)  // numerik: HEX kod izdvojenog karaktera - ne koristi se
               cXhar  := cChar            // nema prevoenja karaktera iz UTF8 u ANSI karakter cXhar
               cString_cirilica_latinica := cString_cirilica_latinica + cXhar

         *****
         ELSE  // sve iznad 127 se konvertuje jer nije isto u UTF8 i u ANSI
         *****


             * iz UTF8 stringa se kao UTF8 slovo uzimaju dva karaktera - ovaj i sledei karakter
             * i ta dva karaktera se prevode iz UTF8 u ANSI karakter cXhar

                  cChar := SUBSTR(cString_UTF8,jj,2)  // izdvoji DVA UTF8 karaktera iz stringa
                  **************************************************
                  cXhar := Char_UTF8_TO__Latin1250(cChar)
                  **************************************************
                  cString_cirilica_latinica := cString_cirilica_latinica + cXhar

                  jj:=jj+1  // nastavi brojanje posle dva karaktera (step 2) !


         *****************************************
         ENDIF // IF ASC(cChar) >= 0 .and. <= 127
         ***************************************** 15-11-2019 END

 NEXT jj

//--- slui za test ---//
// ctxt:="txt.txt"
// memowrit(ctxt,xx)
// listaj(ctxt)
//--- slui za test ---//

RETURN(cString_cirilica_latinica)


*"18-11-2019
********************************************************************
 FUNCTION Char_UTF8_TO__Latin1250(cChar)
********************************************************************
* Slovo UTF-8 bez obzira da li je latinica ili irilica
* prevodi se u slovo latinice Serbian Latin cp 238/1250
*---------------------------------------------------------------
// Prevodjenje KONVERZIJA primljenog UTF-8 znaka (karaktera)
// u ANSI karakter po kodnoj strani 1250 (Windows latinica) i
// vracanje tog novog karaktera u glavni program.


LOCAL jj, nn, nChar, nXhar, cXhar

 * cChar // PRIMLJENI znak koji se iz UTF8 prevodi u ANSI

 nChar  := StrToHex(cChar)   // numerik: HEX kod PRIMLJENOG znaka
 nXhar  := nChar             // numerik: inicijalno
 nn     := LEN(a_utf)


*** STOP("nChar",nChar,1)  // HEXADECIMALNOI UTF8 --- TEST

 FOR jj = 1 to nn

     IF a_utf[jj] == nChar   // ako nadjes u tabeli isti UTF8 HEX kod...
        nXhar := a_cir[jj]   // uzmi iz tabele odgovarajuci ANSI HEX kod
        EXIT                 // prekini dalje trazenje
     ENDIF

 NEXT jj

*** STOP("nXhar",nXhar,1)  // HEXADECIMALNO ANSI --- TEST

 cXhar := HexToStr(nXhar)    // string: ANSI HEX kod PRIMLJENOG znaka prevedi u znak


//--- slui za test ---//
// xx:=xx +"UTF = "+cChar + cr
// xx:=xx +"HEX = "+var2char(nChar) + cr
// xx:=xx +"CYR = "+var2char(nXhar) + cr
// xx:=xx +"CYR = "+cXhar + cr
// xx:=xx +" " + cr
//--- slui za test ---//

RETURN(cXhar)


*"18-11-2019
********************************************************************
FUNCTION Table_Convert_UTF8_TO__Latin1250()
********************************************************************
* Slovo UTF-8 bez obzira da li je latinica ili irilica
* prevodi se u slovo latinice Serbian Latin cp 238/1250
*---------------------------------------------------------------
* Karakter UTF8 prevodi se u karakter latinice 238/1250
*
* - Ako je UTF-8 napisan kao latinica, za HEX kod tog UTF8 nalazi se
*   odgovarajui HEX kod cp1250 latinice i vraa se kao rezultat.
*
* - Ako je UTF-8 napisan kao irilica, za HEX kod tog UTF8 nalazi se
*   odgovarajui HEX kod cp1251 irilice, s tim to je ovde svaki
*   HEX kod cp1251 irilice zamenjen sa HEX kodom cp1250 latinice
*   za to slovo, pa je odmah izvrena konverzija UTF-8 irilice u
*   cp1250 latinicu koja se upisuje u DBF fajlove od strane Xbase++
*-------------------------------------------------------------------


* LOCAL nn := 126               // postavlja se u glavnom programu
* DECLARE a_utf[nn], a_cir[nn]  // postavlja se u glavnom programu

*---------------------------------------
*---VELIKA IRILINA UTF-8 SLOVA
* imaju umesto koda za 1251 irilica
* ubaen kod za isto slovo 1250 latinica
*---------------------------------------

 a_utf[1]   := "D090"   // A  UTF8 irilica
 a_cir[1]   := "41"     // A  1250 latinica
 a_utf[2]   := "D091"   // B
 a_cir[2]   := "42"
 a_utf[3]   := "D092"   // V
 a_cir[3]   := "56"
 a_utf[4]   := "D093"   // G
 a_cir[4]   := "47"
 a_utf[5]   := "D094"   // D
 a_cir[5]   := "44"
 a_utf[6]   := "D095"   // E
 a_cir[6]   := "45"
 a_utf[7]   := "D096"   // 
 a_cir[7]   := "8E"
 a_utf[8]   := "D097"   // Z se dobija i na Y
 a_cir[8]   := "5A"
 a_utf[9]   := "D098"   // I
 a_cir[9]   := "49"
 a_utf[10]  := "D09A"   // K
 a_cir[10]  := "4B"
 a_utf[11]  := "D09B"   // L
 a_cir[11]  := "4C"
 a_utf[12]  := "D09C"   // M
 a_cir[12]  := "4D"
 a_utf[13]  := "D09D"   // N
 a_cir[13]  := "4E"
 a_utf[14]  := "D09E"   // O
 a_cir[14]  := "4F"
 a_utf[15]  := "D09F"   // P
 a_cir[15]  := "50"
 a_utf[16]  := "D0A0"   // R
 a_cir[16]  := "52"
 a_utf[17]  := "D0A1"   // S
 a_cir[17]  := "53"
 a_utf[18]  := "D0A2"   // T
 a_cir[18]  := "54"
 a_utf[19]  := "D0A3"   // U
 a_cir[19]  := "55"
 a_utf[20]  := "D0A4"   // F
 a_cir[20]  := "46"
 a_utf[21]  := "D0A5"   // H
 a_cir[21]  := "48"
 a_utf[22]  := "D0A6"   // C
 a_cir[22]  := "43"
 a_utf[23]  := "D0A7"   // 
 a_cir[23]  := "C8"
 a_utf[24]  := "D0A8"   // 
 a_cir[24]  := "8A"
 a_utf[25]  := "D082"   // 
 a_cir[25]  := "D0"
 a_utf[26]  := "D088"   // J
 a_cir[26]  := "4A"
 a_utf[27]  := "D089"   // LJ
 a_cir[27]  := "4C4A"
 a_utf[28]  := "D08A"   // NJ
 a_cir[28]  := "4E4A"
 a_utf[29]  := "D08B"   // 
 a_cir[29]  := "C6"
 a_utf[30]  := "D08F"   // D
 a_cir[30]  := "448E"


 // utf8 to latin:
 // ako je utf irilica utf  hex kod za taster Y = D085
 // zamenjuje se sa latinica hex kod za taster Y = 59

 a_utf[123]  := "D085" // PRIMI SE Y IRILICA
 a_cir[123]  := "59"   // dobija se Y latinica

*---------------------------------------
*---MALA IRILINA UTF-8 SLOVA
* imaju umesto koda za 1251 irilica
* ubaen kod za isto slovo 1250 latinica
*---------------------------------------

 a_utf[31]  := "D0B0"   // a  UTF8 irilica
 a_cir[31]  := "61"     // a  1250 latinica
 a_utf[32]  := "D0B1"   // b
 a_cir[32]  := "62"
 a_utf[33]  := "D0B2"   // v
 a_cir[33]  := "76"
 a_utf[34]  := "D0B3"   // g
 a_cir[34]  := "67"
 a_utf[35]  := "D0B4"   // d
 a_cir[35]  := "64"
 a_utf[36]  := "D0B5"   // e
 a_cir[36]  := "65"
 a_utf[37]  := "D0B6"   // 
 a_cir[37]  := "9E"
 a_utf[38]  := "D0B7"   // z  se dobija na y
 a_cir[38]  := "7A"
 a_utf[39]  := "D0B8"   // i
 a_cir[39]  := "69"
 a_utf[40]  := "D0BA"   // k
 a_cir[40]  := "6B"
 a_utf[41]  := "D0BB"   // l
 a_cir[41]  := "6C"
 a_utf[42]  := "D0BC"   // m
 a_cir[42]  := "6D"
 a_utf[43]  := "D0BD"   // n
 a_cir[43]  := "6E"
 a_utf[44]  := "D0BE"   // o
 a_cir[44]  := "6F"
 a_utf[45]  := "D0BF"   // p
 a_cir[45]  := "70"
 a_utf[46]  := "D180"   // r
 a_cir[46]  := "72"
 a_utf[47]  := "D181"   // s
 a_cir[47]  := "73"
 a_utf[48]  := "D182"   // t
 a_cir[48]  := "74"
 a_utf[49]  := "D183"   // u
 a_cir[49]  := "75"
 a_utf[50]  := "D184"   // f
 a_cir[50]  := "66"
 a_utf[51]  := "D185"   // h
 a_cir[51]  := "68"
 a_utf[52]  := "D186"   // c
 a_cir[52]  := "63"
 a_utf[53]  := "D187"   // 
 a_cir[53]  := "E8"
 a_utf[54]  := "D188"   // 
 a_cir[54]  := "9A"
 a_utf[55]  := "D198"   // j
 a_cir[55]  := "6A"
 a_utf[56]  := "D199"   // lj
 a_cir[56]  := "6C6A"
 a_utf[57]  := "D19A"   // nj
 a_cir[57]  := "6E6A"
 a_utf[58]  := "D19B"   // 
 a_cir[58]  := "E6"
 a_utf[59]  := "D19F"   // d
 a_cir[59]  := "649E"
 a_utf[60]  := "D192"   // 
 a_cir[60]  := "F0"

 // utf8 to latin:
 // ako je utf irilica utf hex kod za Y = D195
 // zamenjuje se sa latinica kodom  za Y = 79
 a_utf[124]  := "D195"   // primi se y irilica
 a_cir[124]  := "79"     // dobija se Y latinica


*****************************************************

*---------------------------
*---VELIKA LATININA SLOVA
*---------------------------

*---------------------------------------------- LATINICA-VELIKA-SLOVA-START

 a_utf[61]  := "41"   // A  UTF8 latinica
 a_cir[61]  := "41"   // A  1250 latinica
 a_utf[62]  := "42"   // B
 a_cir[62]  := "42"   //
 a_utf[63]  := "43"   // C
 a_cir[63]  := "43"   //
 a_utf[64]  := "44"   // D
 a_cir[64]  := "44"   //
 a_utf[65]  := "45"   // E
 a_cir[65]  := "45"   //
 a_utf[66]  := "46"   // F
 a_cir[66]  := "46"   //
 a_utf[67]  := "47"   // G
 a_cir[67]  := "47"   //
 a_utf[68]  := "48"   // H
 a_cir[68]  := "48"   //
 a_utf[69]  := "49"   // I
 a_cir[69]  := "49"   //
 a_utf[70]  := "4A"   // J
 a_cir[70]  := "4A"   //
 a_utf[71]  := "4B"   // K
 a_cir[71]  := "4B"   //
 a_utf[72]  := "4C"   // L
 a_cir[72]  := "4C"   //
 a_utf[73]  := "4D"   // M
 a_cir[73]  := "4D"   //
 a_utf[74]  := "4E"   // N
 a_cir[74]  := "4E"   //
 a_utf[75]  := "4F"   // O
 a_cir[75]  := "4F"   //
 a_utf[76]  := "50"   // P
 a_cir[76]  := "50"   //
 a_utf[77]  := "51"   // Q
 a_cir[77]  := "51"   //
 a_utf[78]  := "52"   // R
 a_cir[78]  := "52"   //
 a_utf[79]  := "53"   // S
 a_cir[79]  := "53"   //
 a_utf[80]  := "54"   // T
 a_cir[80]  := "54"   //
 a_utf[81]  := "55"   // U
 a_cir[81]  := "55"   //
 a_utf[82]  := "56"   // V
 a_cir[82]  := "56"   //
 a_utf[83]  := "57"   // W
 a_cir[83]  := "57"   //
 a_utf[84]  := "58"   // X
 a_cir[84]  := "58"   //

 a_utf[85]  := "59"   // Y
 a_cir[85]  := "59"   //

 a_utf[86]  := "5A"   // Z
 a_cir[86]  := "5A"   //

 // utf8 to latin:
 // ako je utf latinica utf hex kod za Y = 59
 // zamenjuje se sa latinica kodom  za Y = 59
 a_utf[125]  := "59"   // prima se Y latinica
 a_cir[125]  := "59"   // dobija se Y latinica

*---------------------------------------------- LATINICA-VELIKA-SLOVA-END

*---------------------------
*---MALA LATININA SLOVA
*---------------------------

*---------------------------------------------- LATINICA-MALA-SLOVA-START

 a_utf[87]  := "61"   // a  UTF8 latinica
 a_cir[87]  := "61"   // a  1250 latinica
 a_utf[88]  := "62"   // b
 a_cir[88]  := "62"   //
 a_utf[89]  := "63"   // c
 a_cir[89]  := "63"   //
 a_utf[90]  := "64"   // d
 a_cir[90]  := "64"   //
 a_utf[91]  := "65"   // e
 a_cir[91]  := "65"   //
 a_utf[92]  := "66"   // f
 a_cir[92]  := "66"   //
 a_utf[93]  := "67"   // g
 a_cir[93]  := "67"   //
 a_utf[94]  := "68"   // h
 a_cir[94]  := "68"   //
 a_utf[95]  := "69"   // i
 a_cir[95]  := "69"   //
 a_utf[96]  := "6A"   // j
 a_cir[96]  := "6A"   //
 a_utf[97]  := "6B"   // k
 a_cir[97]  := "6B"   //
 a_utf[98]  := "6C"   // l
 a_cir[98]  := "6C"   //
 a_utf[99]  := "6D"   // m
 a_cir[99]  := "6D"   //
 a_utf[100] := "6E"   // n
 a_cir[100] := "6E"   //
 a_utf[101] := "6F"   // o
 a_cir[101] := "6F"   //
 a_utf[102] := "70"   // p
 a_cir[102] := "70"   //
 a_utf[103] := "71"   // q
 a_cir[103] := "71"   //
 a_utf[104] := "72"   // r
 a_cir[104] := "72"   //
 a_utf[105] := "73"   // s
 a_cir[105] := "73"   //
 a_utf[106] := "74"   // t
 a_cir[106] := "74"   //
 a_utf[107] := "75"   // u
 a_cir[107] := "75"   //
 a_utf[108] := "76"   // v
 a_cir[108] := "76"   //
 a_utf[109] := "77"   // w
 a_cir[109] := "77"   //
 a_utf[110] := "78"   // x
 a_cir[110] := "78"   //
 a_utf[111] := "79"   // y
 a_cir[111] := "79"   //
 a_utf[112] := "7A"   // z
 a_cir[112] := "7A"   //

 // utf8 to latin:
 // ako je utf latinica utf hex kod za y = 79
 // zamenjuje se sa latinica kodom  za y = 79
 a_utf[126]  := "79"   // prima se Y latinica
 a_cir[126]  := "79"   // dobija se Y latinica

*---------------------------------------------- LATINICA-MALA-SLOVA-END

*------------------------------
* SERBIAN LATIN SLOVA 238/1250
*------------------------------

*---------------------------------------------- LATINICA-SERBIAN-SLOVA-START
*     

 a_utf[113] := "C5A0" // 
 a_cir[113] := "8A"   //
 a_utf[114] := "C5A1" // 
 a_cir[114] := "9A"   //

 a_utf[115] := "C490" // 
 a_cir[115] := "D0"   //
 a_utf[116] := "C491" // 
 a_cir[116] := "F0"   //

 a_utf[117] := "C48C" // 
 a_cir[117] := "C8"   //
 a_utf[118] := "C48D" // 
 a_cir[118] := "E8"   //

 a_utf[119] := "C486" // 
 a_cir[119] := "C6"   //
 a_utf[120] := "C487" // 
 a_cir[120] := "E6"   //

 a_utf[121] := "C5BD" // 
 a_cir[121] := "8E"   //
 a_utf[122] := "C5BE" // 
 a_cir[122] := "9E"   //

*---------------------------------------------- LATINICA-SERBIAN-SLOVA-END

RETURN NIL













//#################################################################


*                FUNCTION UTF8_TO__Cyrilic1251(cString_UTF8)
*           FUNCTION Char_UTF8_TO__Cyrilic1251(cChar)
*  FUNCTION Table_Convert_UTF8_TO__Cyrilic1251()

* "ta radi ova funkcija:
* "----------------------
* "Vri konverziju unicode stringa UTF-8 i UTF-16 u Serbian Cyrilic
* "string - odnosno u karakter set cp 204/1251




*"18-11-2019
*******************************************************************
FUNCTION UTF8_TO__Cyrilic1251(cString_UTF8)
*******************************************************************

LOCAL jj,;
 nString_Duzina := LEN(cString_UTF8) ,; // duzina stringa
 cString_cirilica_latinica := ""     ,;
 cString_cirilica          := ""     ,;
 cXhar := ""                         ,;
 cChar := ""

 DECLARE a_utf[126], a_cir[126]
 *********************************************
 Table_Convert_UTF8_TO__Cyrilic1250()          // tabela za konverziju
 ********************************************* // UTF-8 u latinicu
 * formirani nizovi a_utf, a_cir

//--- slui za test ---//
// xx:="";cr:=chr(13)+chr(10)
//--- slui za test ---//

 FOR jj = 1 To nString_Duzina step 1  // kontrolie se svaki karakter UTF8 stringa



         cChar := SUBSTR(cString_UTF8,jj,1)  // izdvoji jedan karakter iz UTF8 stringa


         ******************************************** 15-11-2019 START
         IF ASC(cChar) >= 0 .and. ASC(cChar) <= 127   // ne konvertuje se (isto je u UTF8 i ANSI)
         ******************************************** // VELIKA I MALA SLOVA LATINICE BEZ Ǝ I ZNAKOVI

               nChar  := StrToHex(cChar)  // numerik: HEX kod izdvojenog karaktera - ne koristi se
               cXhar  := cChar            // nema prevoenja karaktera iz UTF8 u ANSI karakter cXhar
               cString_cirilica_latinica := cString_cirilica_latinica + cXhar

         *****
         ELSE  // sve iznad 127 se konvertuje jer nije isto u UTF8 i u ANSI
         *****


             * iz UTF8 stringa se kao UTF8 slovo uzimaju dva karaktera - ovaj i sledei karakter
             * i ta dva karaktera se prevode iz UTF8 u ANSI karakter cXhar

                  cChar := SUBSTR(cString_UTF8,jj,2)  // izdvoji DVA UTF8 karaktera iz stringa
                  **************************************************
                  cXhar := Char_UTF8_TO__Cyrilic1251(cChar)
                  **************************************************
                  cString_cirilica_latinica := cString_cirilica_latinica + cXhar

                  jj:=jj+1  // nastavi brojanje posle dva karaktera (step 2) !


         *****************************************
         ENDIF // IF ASC(cChar) >= 0 .and. <= 127
         ***************************************** 15-11-2019 END

 NEXT jj

//--- slui za test ---//
// ctxt:="txt.txt"
// memowrit(ctxt,xx)
// listaj(ctxt)
//--- slui za test ---//

RETURN(cString_cirilica_latinica)


*"18-11-2019
********************************************************************
 FUNCTION Char_UTF8_TO__Cyrilic1251(cChar)
********************************************************************
* Slovo UTF-8 bez obzira da li je latinica ili irilica
* prevodi se u slovo irilice Serbian Cyrilic cp 204/1251
*---------------------------------------------------------------
// Prevodjenje KONVERZIJA primljenog UTF-8 znaka (karaktera)
// u ANSI karakter po kodnoj strani 1251 (Windows irilica) i
// vracanje tog novog karaktera u glavni program.


LOCAL jj, nn, nChar, nXhar, cXhar

 * cChar // PRIMLJENI znak koji se iz UTF8 prevodi u ANSI

 nChar  := StrToHex(cChar)   // numerik: HEX kod PRIMLJENOG znaka
 nXhar  := nChar             // numerik: inicijalno
 nn     := LEN(a_utf)


*** STOP("nChar",nChar,1)  // HEXADECIMALNOI UTF8 --- TEST

 FOR jj = 1 to nn

     IF a_utf[jj] == nChar   // ako nadjes u tabeli isti UTF8 HEX kod...
        nXhar := a_cir[jj]   // uzmi iz tabele odgovarajuci ANSI HEX kod
        EXIT                 // prekini dalje trazenje
     ENDIF

 NEXT jj

*** STOP("nXhar",nXhar,1)  // HEXADECIMALNO ANSI --- TEST

 cXhar := HexToStr(nXhar)    // string: ANSI HEX kod PRIMLJENOG znaka prevedi u znak


//--- slui za test ---//
// xx:=xx +"UTF = "+cChar + cr
// xx:=xx +"HEX = "+var2char(nChar) + cr
// xx:=xx +"CYR = "+var2char(nXhar) + cr
// xx:=xx +"CYR = "+cXhar + cr
// xx:=xx +" " + cr
//--- slui za test ---//

RETURN(cXhar)



*"18-11-2019
********************************************************************
FUNCTION Table_Convert_UTF8_TO__Cyrilic1250()
********************************************************************
* Slovo UTF-8 bez obzira da li je latinica ili irilica
* prevodi se u slovo irilice Serbian Cyrilic cp 204/1251
*---------------------------------------------------------------
* Karakter UTF8 prevodi se u karakter irilice 204/1251
*
* - Ako je UTF-8 napisan kao irilica, za HEX kod tog UTF8 nalazi se
*   odgovarajui HEX kod cp1251 irilice i vraa se kao rezultat.
*
* - Ako je UTF-8 napisan kao latinica, za HEX kod tog UTF8 nalazi se
*   odgovarajui HEX kod cp1250 latinice, s tim to je ovde svaki
*   HEX kod cp1250 latinice zamenjen sa HEX kodom cp1251 irilice
*   za to slovo, pa je odmah izvrena konverzija UTF-8 latinice u
*   cp1251 irilicu koja se upisuje u DBF fajlove od strane Xbase++
*-------------------------------------------------------------------


* LOCAL nn := 126               // postavlja se u glavnom programu
* DECLARE a_utf[nn], a_cir[nn]  // postavlja se u glavnom programu

*---------------------------------------
*---VELIKA IRILINA UTF-8 SLOVA
*---------------------------------------

*---------------------------------------------- IRILICA-VELIKA-SLOVA-START
 a_utf[1]   := "D090"   // A  UTF8 irilica
 a_cir[1]   := "C0"     // A  1251 irilica
 a_utf[2]   := "D091"   // B
 a_cir[2]   := "C1"
 a_utf[3]   := "D092"   // V
 a_cir[3]   := "C2"
 a_utf[4]   := "D093"   // G
 a_cir[4]   := "C3"
 a_utf[5]   := "D094"   // D
 a_cir[5]   := "C4"
 a_utf[6]   := "D095"   // E
 a_cir[6]   := "C5"
 a_utf[7]   := "D096"   // 
 a_cir[7]   := "C6"
 a_utf[8]   := "D097"   // Z se dobija i na Y
 a_cir[8]   := "C7"
 a_utf[9]   := "D098"   // I
 a_cir[9]   := "C8"
 a_utf[10]  := "D09A"   // K
 a_cir[10]  := "CA"
 a_utf[11]  := "D09B"   // L
 a_cir[11]  := "CB"
 a_utf[12]  := "D09C"   // M
 a_cir[12]  := "CC"
 a_utf[13]  := "D09D"   // N
 a_cir[13]  := "CD"
 a_utf[14]  := "D09E"   // O
 a_cir[14]  := "CE"
 a_utf[15]  := "D09F"   // P
 a_cir[15]  := "CF"
 a_utf[16]  := "D0A0"   // R
 a_cir[16]  := "D0"
 a_utf[17]  := "D0A1"   // S
 a_cir[17]  := "D1"
 a_utf[18]  := "D0A2"   // T
 a_cir[18]  := "D2"
 a_utf[19]  := "D0A3"   // U
 a_cir[19]  := "D3"
 a_utf[20]  := "D0A4"   // F
 a_cir[20]  := "D4"
 a_utf[21]  := "D0A5"   // H
 a_cir[21]  := "D5"
 a_utf[22]  := "D0A6"   // C
 a_cir[22]  := "D6"
 a_utf[23]  := "D0A7"   // 
 a_cir[23]  := "D7"
 a_utf[24]  := "D0A8"   // 
 a_cir[24]  := "D8"
 a_utf[25]  := "D082"   // 
 a_cir[25]  := "80"
 a_utf[26]  := "D088"   // J
 a_cir[26]  := "A3"
 a_utf[27]  := "D089"   // LJ
 a_cir[27]  := "8A"
 a_utf[28]  := "D08A"   // NJ
 a_cir[28]  := "8C"
 a_utf[29]  := "D08B"   // 
 a_cir[29]  := "8E"
 a_utf[30]  := "D08F"   // D
 a_cir[30]  := "8F"


 // utf8 to cyrilic:
 // ako je utf irilica utf  hex kod za Y = D085
 // zamenjuje se sa irilica hex kod za Y = BD

 a_utf[123]  := "D085" // PRIMI SE Y irilica
 a_cir[123]  := "BD"   // dobija se Y irilica


*---------------------------------------------- IRILICA-VELIKA-SLOVA-END


*---------------------------------------
*---MALA IRILINA UTF-8 SLOVA
*---------------------------------------

*---------------------------------------------- IRILICA-MALA-SLOVA-START

 a_utf[31]  := "D0B0"   // a  UTF8 irilica
 a_cir[31]  := "E0"     // a  1251 irilica
 a_utf[32]  := "D0B1"   // b
 a_cir[32]  := "E1"
 a_utf[33]  := "D0B2"   // v
 a_cir[33]  := "E2"
 a_utf[34]  := "D0B3"   // g
 a_cir[34]  := "E3"
 a_utf[35]  := "D0B4"   // d
 a_cir[35]  := "E4"
 a_utf[36]  := "D0B5"   // e
 a_cir[36]  := "E5"
 a_utf[37]  := "D0B6"   // 
 a_cir[37]  := "E6"
 a_utf[38]  := "D0B7"   // z  se dobija na y
 a_cir[38]  := "E7"
*a_utf[38]  := "D195"   // y  se dobija na z
*a_cir[38]  := "E7"     //
 a_utf[39]  := "D0B8"   // i
 a_cir[39]  := "E8"
 a_utf[40]  := "D0BA"   // k
 a_cir[40]  := "EA"
 a_utf[41]  := "D0BB"   // l
 a_cir[41]  := "EB"
 a_utf[42]  := "D0BC"   // m
 a_cir[42]  := "EC"
 a_utf[43]  := "D0BD"   // n
 a_cir[43]  := "ED"
 a_utf[44]  := "D0BE"   // o
 a_cir[44]  := "EE"
 a_utf[45]  := "D0BF"   // p
 a_cir[45]  := "EF"
 a_utf[46]  := "D180"   // r
 a_cir[46]  := "F0"
 a_utf[47]  := "D181"   // s
 a_cir[47]  := "F1"
 a_utf[48]  := "D182"   // t
 a_cir[48]  := "F2"
 a_utf[49]  := "D183"   // u
 a_cir[49]  := "F3"
 a_utf[50]  := "D184"   // f
 a_cir[50]  := "F4"
 a_utf[51]  := "D185"   // h
 a_cir[51]  := "F5"
 a_utf[52]  := "D186"   // c
 a_cir[52]  := "F6"
 a_utf[53]  := "D187"   // 
 a_cir[53]  := "F7"
 a_utf[54]  := "D188"   // 
 a_cir[54]  := "F8"
 a_utf[55]  := "D198"   // j
 a_cir[55]  := "BC"
 a_utf[56]  := "D199"   // lj
 a_cir[56]  := "9A"
 a_utf[57]  := "D19A"   // nj
 a_cir[57]  := "9C"
 a_utf[58]  := "D19B"   // 
 a_cir[58]  := "9E"
 a_utf[59]  := "D19F"   // d
 a_cir[59]  := "9F"
 a_utf[60]  := "D192"   // 
 a_cir[60]  := "90"

 // utf8 to cyrilic:
 // ako je utf irilica utf  hex kod za y = D195
 // zamenjuje se sa irilica hex kod za y = BE

 a_utf[124]  := "D195" // primi se y irilica
 a_cir[124]  := "BE"   // dobija se Y irilica

*---------------------------------------------- IRILICA-MALA-SLOVA-END


*****************************************************

*---------------------------------------
*---VELIKA LATININA UTF-8 SLOVA
* imaju umesto koda za 1250 latinica
* ubaen kod za isto slovo 1251 irilica
*---------------------------------------

 a_utf[61]  := "41"   // A  UTF8 latinica
 a_cir[61]  := "C0"   // A  1251 irilica
 a_utf[62]  := "42"   // B
 a_cir[62]  := "C1"   //
 a_utf[63]  := "43"   // C
 a_cir[63]  := "D6"   //
 a_utf[64]  := "44"   // D
 a_cir[64]  := "C4"   //
 a_utf[65]  := "45"   // E
 a_cir[65]  := "C5"   //
 a_utf[66]  := "46"   // F
 a_cir[66]  := "D4"   //
 a_utf[67]  := "47"   // G
 a_cir[67]  := "C3"   //
 a_utf[68]  := "48"   // H
 a_cir[68]  := "D5"   //
 a_utf[69]  := "49"   // I
 a_cir[69]  := "C8"   //
 a_utf[70]  := "4A"   // J
 a_cir[70]  := "A3"   //
 a_utf[71]  := "4B"   // K
 a_cir[71]  := "CA"   //
 a_utf[72]  := "4C"   // L
 a_cir[72]  := "CB"   //
 a_utf[73]  := "4D"   // M
 a_cir[73]  := "CC"   //
 a_utf[74]  := "4E"   // N
 a_cir[74]  := "CD"   //
 a_utf[75]  := "4F"   // O
 a_cir[75]  := "CE"   //
 a_utf[76]  := "50"   // P
 a_cir[76]  := "CF"   //

 a_utf[77]  := "51"   // Q --- Q
 a_cir[77]  := "8A"   //   --- LJ

 a_utf[78]  := "52"   // R
 a_cir[78]  := "D0"   //
 a_utf[79]  := "53"   // S
 a_cir[79]  := "D1"   //
 a_utf[80]  := "54"   // T
 a_cir[80]  := "D2 "  //
 a_utf[81]  := "55"   // U
 a_cir[81]  := "D3"   //
 a_utf[82]  := "56"   // V
 a_cir[82]  := "C2"   //
 a_utf[83]  := "57"   // W --- W
 a_cir[83]  := "8C"   //   --- NJ

 a_utf[84]  := "58"   // X --- X
 a_cir[84]  := "8F"   //   --- D

 a_utf[85]  := "59"   // Y ---------------
 a_cir[85]  := "59"   //   --------------- ostaje latinino slovo Y

 a_utf[86]  := "5A"   // Z
 a_cir[86]  := "C7"   //

 // utf8 to latinica:
 // ako je utf latinica utf  hex kod za Y = D085
 // zamenjuje se sa irilica hex kod za Y = BD

 a_utf[125]  := "D085" // PRIMI SE Y latinica
 a_cir[125]  := "BD"   // dobija se Y irilica


*---------------------------------------
*---MALA LATININA UTF-8 SLOVA
* imaju umesto koda za 1250 latinica
* ubaen kod za isto slovo 1251 irilica
*---------------------------------------

 a_utf[87]  := "61"   // a  UTF8 latinica
 a_cir[87]  := "E0"   // a  1251 irilica
 a_utf[88]  := "62"   // b
 a_cir[88]  := "E1"   //
 a_utf[89]  := "63"   // c
 a_cir[89]  := "F6"   //
 a_utf[90]  := "64"   // d
 a_cir[90]  := "E4"   //
 a_utf[91]  := "65"   // e
 a_cir[91]  := "E5"   //
 a_utf[92]  := "66"   // f
 a_cir[92]  := "F4"   //
 a_utf[93]  := "67"   // g
 a_cir[93]  := "E3"   //
 a_utf[94]  := "68"   // h
 a_cir[94]  := "F5"   //
 a_utf[95]  := "69"   // i
 a_cir[95]  := "E8"   //
 a_utf[96]  := "6A"   // j
 a_cir[96]  := "BC"   //
 a_utf[97]  := "6B"   // k
 a_cir[97]  := "EA"   //
 a_utf[98]  := "6C"   // l
 a_cir[98]  := "EB"   //
 a_utf[99]  := "6D"   // m
 a_cir[99]  := "EC"   //
 a_utf[100] := "6E"   // n
 a_cir[100] := "ED"   //
 a_utf[101] := "6F"   // o
 a_cir[101] := "EE"   //
 a_utf[102] := "70"   // p
 a_cir[102] := "EF"   //
 a_utf[103] := "71"   // q ---
 a_cir[103] := "9A"   //   --- lj
 a_utf[104] := "72"   // r
 a_cir[104] := "F0"   //
 a_utf[105] := "73"   // s
 a_cir[105] := "F1"   //
 a_utf[106] := "74"   // t
 a_cir[106] := "F2"   //
 a_utf[107] := "75"   // u
 a_cir[107] := "F3"   //
 a_utf[108] := "76"   // v
 a_cir[108] := "E2"   //
 a_utf[109] := "77"   // w ---
 a_cir[109] := "9C"   //   --- nj
 a_utf[110] := "78"   // x ---
 a_cir[110] := "9F"   //   --- d
 a_utf[111] := "79"   // y -------------
 a_cir[111] := "79"   //   ------------- ostaje latinino slovo y
 a_utf[112] := "7A"   // z
 a_cir[112] := "E7"   //


 // utf8 to latinica:
 // ako je utf latinica utf  hex kod za y = D195
 // zamenjuje se sa irilica hex kod za y = BE

 a_utf[126]  := "D195" // PRIMI SE y latinica
 a_cir[126]  := "BE"   // dobija se y irilica


*---------------------------------------
*---VELIKA I MALA LATININA UTF-8 SLOVA
*---SERBIAN LATIN ZNACI Ǝ
* imaju umesto koda za 1250 latinica
* ubaen kod za isto slovo 1251 irilica
*---------------------------------------

*------------------------------
* SERBIAN LATIN SLOVA 238/1250
*------------------------------
*     

 a_utf[113] := "C5A0" // 
 a_cir[113] := "D8"   //
 a_utf[114] := "C5A1" // 
 a_cir[114] := "F8"   //

 a_utf[115] := "C490" // 
 a_cir[115] := "80"   //
 a_utf[116] := "C491" // 
 a_cir[116] := "90"   //

 a_utf[117] := "C48C" // 
 a_cir[117] := "D7"   //
 a_utf[118] := "C48D" // 
 a_cir[118] := "F7"   //

 a_utf[119] := "C486" // 
 a_cir[119] := "8E"   //
 a_utf[120] := "C487" // 
 a_cir[120] := "9E"   //

 a_utf[121] := "C5BD" // 
 a_cir[121] := "C6"   //
 a_utf[122] := "C5BE" // 
 a_cir[122] := "E6"   //


RETURN NIL

