
/*

 RTF_start.PRG

 23-11-2019

  COBA Systems Software
 BAST Open Source Project
 Business Account Software Technology
 www.cobasystems.com
 Program: Alaska Xbase++ 1.90.355 sl1
          XbTools, ADSDBE, eXpress++


 KORIENJE WORDPROCESSOR-A IZ C_GLAVNI.EXE PROGRAMA
 ===================================================
 WRITE.EXE = windows-ov free WORDPAD.EXE (default)
 WINWORD.EXE (Microsoft Office)
 SWORD.EXE   (Open Office - Free)
 ABIWORD.EXE (www.abisource.com Free)
 Pun path do wordprocessora upisan je u CSYSTEMS.INI

*      RTF\RTF_RICHTEXT.CH
*      RTF\RTF_START.PRG       // #include "RTF_richtext.ch"
*      RTF\RTF_ALASKARTF.PRG   // #include "RTF_richtext.ch"

*/


#include "Xbtsys.ch"   // XbttoolsIII
#include "Appevent.ch"
#include "Common.ch"
#include "Xbp.ch"

#include "Dmlb.ch"
#include "Dbstruct.ch"

#include "RTF_richtext.ch"
#define CRLF chr(13)+chr(10)

************************************************************************
FUNCTION RTF_start(RTFfile)
************************************************************************
SET DATE GERMAN
SET CENTURY ON

PRIVATE RTF_vreme    := dtoc(date())+" "+time()
PRIVATE RTF_program  := "WRITE.EXE" // WRITE.EXE = WORDPAD.EXE
PRIVATE RTF_fajl     := RTFfile


IF FILE(RTF_fajl)=.F.

   // nov RTF fajl: RTF_fajl, bie inicijalno napravljen na irilici
   // ako je u CSYSTEMS.INI upisano:
   //   [SERBIAN]
   //   CYRILIC=YES
   // jer tada je: PUBLIC SERBIANCYRILIC="YES"
      INI_WRITE("C","SERBIAN","CYRILIC","YES",gde_exe()+"\RTF.INI")
      PUBLIC;
      SERBIANCYRILIC := ; // koristi se u RTF_alaska.prg u konverziji lat-cyr
      INI_READ("C","SERBIAN","CYRILIC",gde_exe()+"\RTF.INI") // zbog demo programa
   // ovo upisuje samo startni tekst na irilici, a na dalje upis moe
   // biti i irilica i latinica i meano...
   *******************
   Make_Rtf(RTF_fajl)  // napravi novi RTF fajl
   *******************
   IF FILE(RTF_fajl)=.F.
       c__greska("Nema fajla:;"+RTF_fajl,"Greka",,"G1")
       RETURN NIL
   ENDIF
ENDIF
   ***********************************
   q := RunShell(RTF_fajl,RTF_program)
   ***********************************
RETURN NIL

*************************************************************************
FUNCTION Make_Rtf(cOutFile)  // KREIRANJE RTF FAJLA
*************************************************************************
LOCAL oRTF, n := 0

   // Open the output file & set some defaults
   // Otvorite izlaznu datoteku i postavite neke zadane vrijednosti

   oRTF := Setup_RTF( cOutFile )
   IF oRTF:hFile >= 0  // avoid a crash if the file was already open.
                       // izbjegavajte pad ako je datoteka ve otvorena.
      // Demonstrate basics -- fonts, text appearance, hanging indents, etc.
      // Demonstriraju osnove - fontovi, izgled teksta, visee uvlake itd.
      Cover_Page( oRTF )
      // Close the output file
      CLOSE RTF oRTF
      c__poruka(cOutFile,"Formiran RTF dokument",,"G1")
   ELSE
      c__greska(cOutFile,"Nije Formiran RTF dokument",,"G1")
   ENDIF

RETURN NIL
*************************************************************************
FUNCTION Setup_RTF( cOutFile)
// SETUP RTF FAJLA FONTOVI I NASLOVI, STRANE I SL...
*************************************************************************
LOCAL oRTF

   DEFINE RTF oRTF FILE cOutFile ;
      FONTS "Verdana", "Arial", "Consolas", "Archivo Narrow", "Courier New" ;
      FONTSIZE 12 ;
      TWIPFACTOR 1440 ;
      WARNOVERWRITE ; // Warn if output file already exists
      GETFILENAME FORCEPATH ""

   IF oRTF:hFile >= 0

      // Trim trailing spaces from data, to save file space.
      oRTF:lTrimSpaces := .T.

      DEFINE PAGESETUP oRTF MARGINS 1.75, 1.75, 1, 1 ;
         TABWIDTH .5 ;
         ALIGN CENTER

        * BEGIN HEADER oRTF
        *    NEW PARAGRAPH oRTF TEXT "SPISI STRANKE "+" "+ DTOC(DATE()) ;
        *    FONTSIZE 8 ;
        *    ALIGN CENTER
        * END HEADER oRTF

        * BEGIN FOOTER oRTF
        *    NEW PARAGRAPH oRTF TEXT "strana ." ALIGN CENTER
        *    INSERT PAGENUMBER oRTF
        * END FOOTER oRTF

   ENDIF

RETURN oRTF
*************************************************************************
STATIC FUNCTION Cover_Page( oRTF )  // GENERISANJE NASLOVNE STRANE
*************************************************************************
LOCAL i
LOCAL aTitle[11], aTitle1[5], aBullet[6]

// First, load some text...
  *
  * P_LICE  := "QWERTZUIOPASDFGHJKLCVBNM qwertzuiopasdfghjklcvbnm ƎYX yx"
  * P_MESTO := "գ  ؀׎ƽ 澟"
  *

   aTitle[1] :=  "Dokument: "+CRLF+RTF_fajl
   aTitle[2] :=  "Datum: "+CRLF+dtoc(date()) // +" "+time()
   aTitle[3] :=  "www.cobasystems.com"
   aTitle[4] :=  "cobasystems@gmail.com"
   aTitle[5] :=  "Slobodan M. Stanojevi Coba, dipl.ing. ovlaeni raunovoa"



   text1 := "Ovaj dokument slui za voenje dosijea firme. Dosije firme moe biti bilo ta "      +;
            "to smatrate potrebnim za uvanje u formi RTF tekst fajla zbog naknadne upotrebe "   +;
            "za pregled, tampu i slanje preko interneta, kao i zbog arhiviranja tekstova i "     +;
            "razliitih dokumenata na jedom mestu - u jednom RTF fajlu radi brze pretrage "       +;
            "teksta po zadatoj rei ili po zadatoj sekvenci teksta."                              +;
            " "
   aTitle1[1] := text1




   * koristi se iz tabele za translaciju:
   * METHOD RichText:IntlTranslate()
   * FUNCTION RTF_coba_latin_cyrilic(nCHR)
   ******************************************************************
   * PUBLIC SERBIANCYRILIC := INI_READ("C","SERBIAN","CYRILIC")
   * SERBIANCYRILIC := "YES" or "NO" or "" (default)
   ******************************************************************
   // ZADAJ U MAIN() pre: oRTF:=SetupRTF(cOutFile)
   // ako postoji ova varijabla koristi se irilica
   // tekst koji se upisuje u RTF je tada irilica
   *
   * Latinina slova                   
   * irilina slova LJ R  I      lj r  i    
   *
   * IMAJU ISTE DEC, HEX KODOVE KAO IRILICA
   * PA SE ZBOG TOGA NE MOGU ZAJEDNO UPISATI - MEATI
   * MORA SE UPISATI ILI LATINICA ILI IRILICA
   * ZAJEDNO UPISANA OVA SLOVA E BITI POGRENA
   * ZAJEDNO SE MOGU MOGU UPISATI SAMO KAO UNICODE
   *
   ***************************************
   IF UPPER(SERBIANCYRILIC)=="YES"
   ***************************************

   * 23-11-2019 Latin1250_TO_Cyrilic1251() -- COM_1251.PRG/CSYSTEMSU.DLL
   * testiranje upisa irilice u RTF fajl:
   * aTitle1[1] := "" // napisano preko itiline tastature - funkcionie
   * aTitle1[1] := Latin1250_TO_Cyrilic1251("COBAA") // konvertovano iz latinice u irilicu - funkcionie

   aTitle[1] := Latin1250_TO_Cyrilic1251(aTitle[1])
   aTitle[2] := Latin1250_TO_Cyrilic1251(aTitle[2])
   aTitle[3] := aTitle[3]
   aTitle[4] := aTitle[4]
   aTitle[5] := Latin1250_TO_Cyrilic1251(aTitle[5])

   aTitle1[1] := Latin1250_TO_Cyrilic1251(aTitle1[1])


   ***************************************
   ENDIF
   ***************************************

  // Write the title lines
  NEW PARAGRAPH oRTF TEXT ""

  NEW PARAGRAPH oRTF TEXT aTitle[1] ;
  	FONTNUMBER 1 ;
  	FONTSIZE 18 ;
  	APPEARANCE BOLD_ON ;
  	ALIGN CENTER ;
  	SETDEFAULT
  	//TOCLEVEL 1  // 10/24/97 -- mark this for the Table of Contents.

  NEW PARAGRAPH oRTF TEXT ""

  NEW PARAGRAPH oRTF TEXT aTitle[2] ;
  	FONTNUMBER 1 ;
  	FONTSIZE 14 ;
  	APPEARANCE BOLD_ON ;
  	ALIGN CENTER ;
  	SETDEFAULT
  	//TOCLEVEL 1  // 10/24/97 -- mark this for the Table of Contents.

  NEW PARAGRAPH oRTF TEXT ""

  NEW PARAGRAPH oRTF TEXT aTitle[3] ;
  	FONTNUMBER 1 ;
  	FONTSIZE 14 ;
  	APPEARANCE BOLD_ON ;
  	ALIGN CENTER ;
  	SETDEFAULT
  	//TOCLEVEL 2  // 10/24/97 -- mark this for the Table of Contents.

  * NEW PARAGRAPH oRTF TEXT ""

  NEW PARAGRAPH oRTF TEXT aTitle[4] ;
  	FONTNUMBER 1 ;
  	FONTSIZE 12 ;
  	APPEARANCE BOLD_ON ;
  	ALIGN CENTER ;
  	SETDEFAULT
  	//TOCLEVEL 3  // 10/24/97 -- mark this for the Table of Contents.

  NEW PARAGRAPH oRTF TEXT ""

  NEW PARAGRAPH oRTF TEXT aTitle[5] ;
  	FONTNUMBER 1 ;
  	FONTSIZE 10 ;
  	APPEARANCE BOLD_ON ;
  	ALIGN CENTER ;
  	SETDEFAULT
  	//TOCLEVEL 4  // 10/24/97 -- mark this for the Table of Contents.

  NEW PARAGRAPH oRTF TEXT ""
  NEW PARAGRAPH oRTF TEXT ""


// Write the text items

  NEW PARAGRAPH oRTF TEXT aTitle1[1] ;
        FONTNUMBER 3 ;
  	FONTSIZE 10 ;
  	APPEARANCE BOLD_OFF ;
  	SETDEFAULT

// Write the bullet items

// FOR i := 1 TO LEN( aBullet )
//
//	NEW PARAGRAPH oRTF TEXT aBullet[i] ;
//		FONTNUMBER 2 ;
//		FONTSIZE 11 ;
//		ALIGN LEFT ;
//		INDENT .25 ;
//		FIRSTINDENT -.25 ;
//		BULLETED ;
//		SPACEBEFORE .4 ;
//		SETDEFAULT
//
// NEXT
// NEW PARAGRAPH oRTF TEXT ""

RETURN NIL



