/*

* UNICODE.PRG

16-11-2019
17.10.2011

*  COBA Systems Software
* BAST Open Source Project
* Business Account Software Technology
* www.cobasystems.com
 Program: Alaska Xbase++ 1.90.355 sl1
	  XbTools, ADSDBE, eXpress++

  ===========================
  TEST FUNKCIJE ZA KONVERZIJU
  ===========================

  LATINICE U IRILICU - IRILICE U LATINICU
  UTF8 U IRILICU
  UTF8 U LATINICU

  Sve funkcije za konverziju nalaze se u programu:
  COM_1251.PRG - CSYSTEMSU.LIB/DLL
  --------------------------------


 1. KONVERZIJA LATINICE 238/1250 U IRILICU 204/1251
 -----------------------------------------------------------------------
 FUNCTION Latin1250_TO_Cyrilic1251(cLatString) -> cCyrString
 -----------------------------------------------------------------------


 2. KONVERZIJA IRILICE 204/1251 U LATINICU 238/1250
 -----------------------------------------------------------------------
 FUNCTION Cyrilic1251_TO_Latin1250(cCyrString) -> cLatString
 -----------------------------------------------------------------------


 3. KONVERZIJA UTF-8 I UTF-16 U IRILICU 204/1251 I U LATINICU 238/1250
 -----------------------------------------------------------------------
 FUNCTION UTF8_TO_Cyrilic1251_Latin1250(cUnicodeString) -> cCyrLatString
 -----------------------------------------------------------------------
 Ne koristi se ili se retko koristi jer kod meanih slova odnosno kodnih
 strana u istom stringu ili tekstu - jedna od kodnih strana ne moe da se
 ispravno prikae u Alaska Xbase++ aplikaciji. Ispravan prikaz je mogu
 samo sa unicode slovima, ali Alaska Xbase++ jo ne podrava unicode na
 tom nivou. Iz tog razloga koriste se sledee dve funkcije: 4. i 5.


 4. KONVERZIJA UTF-8 I UTF-16 U LATINICU 238/1250
 -----------------------------------------------------------------------
 FUNCTION UTF8_TO__Latin1250(cUnicodeString) -> cLatString
 -----------------------------------------------------------------------


 5. KONVERZIJA UTF-8 I UTF-16 U IRILICU 204/1251
 -----------------------------------------------------------------------
 FUNCTION UTF8_TO__Cyrilic1251(cUnicodeString) -> cCyrString
 -----------------------------------------------------------------------




 6. Serbian Latin Font
 ------------------------------
 FUNCTION Fo_lat(nFsize,cfname)  // Fo_lat(11,"Consolas") // Serbian cp238
 ------------------------------


 7. Serbian Cyrilic Font
 ------------------------------
 FUNCTION Fo_Cyr(nFsize,cfname)  // Fo_Cyr(11,"Consolas") // Serbian cp204
 ------------------------------


 8. Serbian Latin to Serbian Cyrilic and Serbian Cyrilic to Serbian latin
 ------------------------------------------------------------------------
 FUNCTION test_cirilica_vidi(;	   // prikaz 4 stringa u dialog boxu:
 cString_ASCIII_latin, cirilica,;  // string latinice i prevod u irilicu
 cString_ASCIII_cyril, latinica)   // string irilice i prevod u latinicu
 ------------------------------------------------------------------------


 9. Unicode to Serbian Latin and Unicode to Serbian Cyrilic
 -------------------------------------------
 FUNCTION test_unicode__to_cyr_lat(cUnicode)
 -------------------------------------------














  Alaska Xbase++ ima funkcije za UTF-16
  IsUnicode()
  Str2Unicode()
  Unicode2Str()

  Unicode2Str() Description
  -------------------------
  The function Unicode2Str() converts a Unicode character string to ANSI format.
  The ANSI format is the default format for character strings in Xbase++.

  Note: The format of the ANSI string returned by Unicode2Str() depends on the
  current setting of the SET CHARSET setting. If the application is run in OEM
  mode (SET CHARSET TO OEM, the default), the string returned is OEM-encoded.
  See the SET CHARSET command for more information on character encoding and
  the string format used in Xbase++.

  Note: Windows uses Little Endian UTF-16 encoding for Unicode character strings.
  Unicode2Str() returns an empty string ("") if <cuString> contains a string with
  an incorrect encoding. For example, character strings using UTF-8 encoding or
  Big Endian byte-ordering cannot be converted using the Unicode2Str() function.

  Opis
  Funkcija Unicode2Str () pretvara Unicode znakovni niz u ANSI format.
  ANSI format je zadani format za nizove znakova u Xbase ++.

  Napomena: Format ANSI niza koji je vratio Unicode2Str () ovisi o
  trenutna postavka postavke SET CHARSET. Ako se aplikacija izvodi u OEM-u
  modu (SET CHARSET TO OEM, zadani postavka), vraeni niz je kodiran OEM-om.
  Pogledajte naredbu SET CHARSET za vie informacija o kodiranju znakova i
  format niza koji se koristi u Xbase ++.

  Napomena: Windows koristi Little Endian UTF-16 kodiranje za nizove znakova Unicode.
  Unicode2Str () vraa prazan niz ("") ako <cuString> sadri niz sa pogreno kodiranje.

  Na primjer, nizovi znakova koji koriste UTF-8 kodiranje ili
  -----------------------------------------------------------
  Big Endian byte-ordering ne moe se pretvoriti pomou funkcije Unicode2Str ().
  ------------------------------------------------------------------------------

  Str2Unicode() Description
  -------------------------
  Function Str2Unicode() converts an ANSI character strings to Unicode format.
  Unicode strings are used with certain Win32 API functions, for example.

  Note: Str2Unicode() returns a string in UTF-16 encoding.

  Funkcija Str2Unicode () pretvara nizove znakova ANSI u format Unicode.
  Unicode nizovi se koriste, na primjer, s odreenim Win32 API funkcijama.

  Napomena: Str2Unicode () vraa niz u UTF-16 kodiranju.
  ------------------------------------------------------

*/




#include "Appevent.ch"
#include "Xbp.ch"
#include "Gra.ch"
#include "Font.ch"
#include "color.ch"
#include "common.ch"

#include "xbtsys.ch"
#include "dcdialog.ch"


* test funkcije u ovom programu:
* test_cirilica()	       // nalazi se u COM_1251.PRG
* _test_unicode__to_cyr_lat()  // nalazi se u COM_1251.PRG
* unicode__to_texteditor()     // nalazi se OVDE
* test_hex_latin_cyrilic()     // nalazi se OVDE
* test_utf8_latin_cyrilic()    // nalazi se OVDE





// izmeteno u modul ADS__AppSys.PRG
 PROCEDURE APPSYS()
 RETURN NIL
* PROCEDURE DBESYS()
* RETURN NIL
* PROCEDURE MAIN()
*   GLAVNI_MENI()
* RETURN NIL

*#######################################################################

 PROCEDURE MAIN()

*#######################################################################
    ********************************************************************
    * 1. P O S T A V L J A N J E  S I S T E M S K O G  O K R U  E N J A
    ********************************************************************
    // 1. STAV			   // Ili u APPSYS() ili na startu MAIN()
     nOldIcon := DC_ICONDEFAULT(1) // IKONA BROJ 1
     PUBLIC KORISNIK := 0	   // kada se radi sa Password sistemom
     SET CHARSET TO ANSI	   // ANSI SLOVA
     DC_DotHotKey(180)		   // Prebaci DotPrompt sa Alt+D na ...
     SetCancel(.F.)		   // turn off Alt+C
     SET DATE GERMAN
     SET CENTURY ON


     *================================================================
     * UPOTREBA:
     * BAZNEX.DLL
      PRIVATE co0,co1,co2,co3,co4,of1,of2,of3,of4,aCUR,oCUR
      I2018(@co0,@co1,@co2,@co3,@co4,@of1,@of2,@of3,@of4,@aCUR,@oCUR)
     *================================================================
     * DCPUSHBUTTONXP:
     * CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 FONT of2
     *================================================================
     of1  := Font_codepage(12,"Arial",238,.t.)
     of2  := Font_codepage(10,"Arial",238,.t.)

     MAIN_MENU()

RETURN nil





************************************************************************
PROCEDURE MAIN_MENU()
************************************************************************
LOCAL GetList := {}, GetOptions, oDlg, oGroup, oLogo, oFokus := setappfocus() ,;
		     lHide := .F., lExit := .T.

LOCAL Dduzina, Dsirina, xx , lButton // duina i irina command buttons
LOCAL aCUR    := {"BAZNE.DLL",60,XBPWINDOW_POINTERTYPE_POINTER}

@ 0,0 DCSAY "Library: CSYSTEMSU.LIB/DLL" ;
	     SAYSIZE 0 FONT of1 SAYCOLOR GRA_CLR_DARKRED
@ 1,0 DCSAY "Alaska Xbase++ and Unicode" ;
	     SAYSIZE 0 FONT of1 SAYCOLOR GRA_CLR_DARKRED
@ 2,0 DCSAY "Kodiranje po UTF-8 i UTF-16" ;
	     SAYSIZE 0 FONT of1 SAYCOLOR GRA_CLR_DARKRED
@ 3,0 DCSAY "Serbian Cyrilic 204/1251 and Latin 238/1250" ;
	     SAYSIZE 0 FONT of2 SAYCOLOR GRA_CLR_DARKRED

************************************************************************
*		      M E N U B U T T O N S  M E N I  R E F E R A T A
************************************************************************
* LOCAL Dduzina, Dsirina, Dsirina1, xx
Dduzina  := 40
Dsirina  := 2
Drazmak  := Dsirina //+ 0.1

   xx := 2
   xx := xx + Drazmak + 0.1

   @ xx,0 DCPUSHBUTTONXP CAPTION "Latinica u irilicu i irilica u Latinicu" ;
	  SIZE Dduzina,Dsirina ;
	  ACTION {|a,b,o| test_cirilica()  ,;	// COM_1251.PRG
	  SetAppFocus(o) }  ;
	  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 FONT of2

   xx := xx + Drazmak + 0.1
   @ xx,0 DCPUSHBUTTONXP CAPTION "Unicode u irilicu i Unocode u Latinicu" ;
	  SIZE Dduzina,Dsirina ;
	  ACTION {|a,b,o| _test_unicode__to_cyr_lat()  ,;   // COM_1251.PRG
	  SetAppFocus(o) } ;
	  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 FONT of2

   xx := xx + Drazmak + 0.1
   @ xx,0 DCPUSHBUTTONXP CAPTION "Unicode u text editoru" ;
	  SIZE Dduzina,Dsirina ;
	  ACTION {|a,b,o| unicode__to_texteditor()  ,;	 // OVDE
	  SetAppFocus(o) } ;
	  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 FONT of2


   xx := xx + Drazmak + 0.1

   @ xx,0 DCPUSHBUTTONXP CAPTION "Hex unicode" ;
	  SIZE Dduzina,Dsirina ;
	  ACTION {|a,b,o| test_hex_latin_cyrilic()  ,;	// OVDE
	  SetAppFocus(o) } ;
	  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 FONT of2


   xx := xx + Drazmak + 0.1

   @ xx,0 DCPUSHBUTTONXP CAPTION "Test Xbase++ unicode function" ;
	  SIZE Dduzina,Dsirina ;
	  ACTION {|a,b,o| test_alaska_unicode_function()  ,;	// OVDE
	  SetAppFocus(o) } ;
	  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 FONT of2


   xx := xx + Drazmak + 0.1

   @ xx,0 DCPUSHBUTTONXP CAPTION "Unicode u Xbase++ Browseru" ;
	  SIZE Dduzina,Dsirina ;
	  ACTION {|a,b,o| unicode_u_browseru()  ,;	// OVDE
	  SetAppFocus(o) } ;
	  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 FONT of2


   xx := xx + Drazmak + 0.1

   @ xx,0 DCPUSHBUTTONXP CAPTION "CHR to HEX translacija za RTF" ;
	  SIZE Dduzina,Dsirina ;
	  ACTION {|a,b,o| coba_rtf_trans() ,; // rtf translacija latin/cyrilic ovde
	  SetAppFocus(o) } ;
	  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 FONT of2


   xx := xx + Drazmak + 0.1

   @ xx,0 DCPUSHBUTTONXP CAPTION "Demo za RTF dokument u WordPad.exe" ;
	  SIZE Dduzina,Dsirina ;
	  ACTION {|a,b,o| RTF_start("COBA.RTF") ,; // CSYSTEMSU.DLL
	  SetAppFocus(o) } ;
	  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 FONT of2



   xx := xx + Drazmak + 0.1

   @ xx,0 DCPUSHBUTTONXP CAPTION "Help" ;
	  SIZE Dduzina/2,Dsirina ;
	  ACTION {|a,b,o| help_programa()   ,;
	  SetAppFocus(o) } ;
	  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 FONT of2

   @ xx,0 + Dduzina/2 ;
	  DCPUSHBUTTONXP CAPTION "Exit" ;
	  SIZE Dduzina/2,Dsirina ;
	  ACTION {|a,b,o| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList)   ,;
	  SetAppFocus(o) } ;
	  CURSOR aCUR OUTLINE COLOR co1,co2 CLICKCOLOR co3,co4 FONT of2

************************************************************************
*		   G U I  R E A D E R
************************************************************************



DCGETOPTIONS ;
   NOMAXBUTTON ;
   NOMINBUTTON ;
   NORESIZE ;
   NOESCAPEKEY


DCREAD GUI OPTIONS GetOptions TITLE "Alaska Xbase++ and UNICODE" ;
   FIT ;
   SETFOCUS @oFokus	      ; // startni fokus na objekat oFokus
   PARENT @oDlg 	      ; // definisanje parenta ovog prozora zbog modalnog sledeceg prozora
   EVAL {|o| SetAppWindow(o)} ; // zbog modalnog sledeceg prozora
   MODAL			// modalan je samo ako je u prethodnom zadato:
				// PARENT @oDlg ;
				// EVAL {|oDlg|SetAppWindow(oDlg)}
RETURN



***************************************************************************
STATIC FUNCTION help_programa()
***************************************************************************
LOCAL txt := "", cr := chr(13)+chr(10)
TEXT INTO txt WRAP cr //TRIMMED


  U N I C O D E


  Rad sa UNICODE karakter setom UTF-8 i UTF-16 u Alaska Xbase++
  =============================================================

  Rad sa Serbian Latin cp238/1250 i Serbian Cyrylic cp204/1251
  =============================================================


			================
 Funkcije u biblioteci: CSYSTEMS.LIB/DLL
			================


 1. KONVERZIJA LATINICE 238/1250 U IRILICU 204/1251
    FUNCTION Latin1250_TO_Cyrilic1251(cLatString) -> cCyrString


 2. KONVERZIJA IRILICE 204/1251 U LATINICU 238/1250
    FUNCTION Cyrilic1251_TO_Latin1250(cCyrString) -> cLatString


 3. KONVERZIJA UTF-8 I UTF-16 U IRILICU 204/1251 I U LATINICU 238/1250
    FUNCTION UTF8_TO_Cyrilic1251_Latin1250(cUnicodeString) -> cCyrLatString
    Ne koristi se ili se retko koristi jer kod meanih slova odnosno kodnih
    strana u istom stringu ili tekstu - jedna od kodnih strana ne moe da se
    ispravno prikae u Alaska Xbase++ aplikaciji. Ispravan prikaz je mogu
    samo sa unicode slovima, ali Alaska Xbase++ jo ne podrava unicode na
    tom nivou. Iz tog razloga koriste se sledee dve funkcije: 4. i 5.


 4. KONVERZIJA UTF-8 I UTF-16 U LATINICU 238/1250
    FUNCTION UTF8_TO__Latin1250(cUnicodeString) -> cLatString


 5. KONVERZIJA UTF-8 I UTF-16 U IRILICU 204/1251
    FUNCTION UTF8_TO__Cyrilic1251(cUnicodeString) -> cCyrString


 6. Serbian Latin Font
    FUNCTION Fo_lat(nFsize,cfname)  Fo_lat(11,"Consolas") // Serbian cp238


 7. Serbian Cyrilic Font
    FUNCTION Fo_Cyr(nFsize,cfname)  Fo_Cyr(11,"Consolas") // Serbian cp204


 8. Serbian Latin to Serbian Cyrilic and Serbian Cyrilic to Serbian latin
    FUNCTION test_cirilica_vidi(;     // prikaz 4 stringa u dialog boxu:
    cString_ASCIII_latin, cirilica,;  // string latinice i prevod u irilicu
    cString_ASCIII_cyril, latinica)   // string irilice i prevod u latinicu


 9. Unicode to Serbian Latin and Unicode to Serbian Cyrilic
    FUNCTION test_unicode__to_cyr_lat(cUnicode)







  U V O D


  Alaska Xbase++ verzija 1.9 i 2.0 nemaju ugraenu podrku
  za unicode UTF8 ali se ta podrka moe isprogramirati na
  nivou koji je u veini sluajeva zadovoljavajui - tako
  to se unicode UTF8 karakteri prevedu na Serbian Latin
  code page 238/1250 i Serbian Cyrilic code page 204/1251.

  Ovde je prikazan nain i izvorni kod za tu vrstu podrke.

  Program je primenjen kod aplikacije za itanje podataka
  iz ipa line karte u Srbiji koji sadri i podatke na irilici
  i podatke na latinici kodirane kao UTF-8 unicode. Da bi se ti
  podaci mogli koristiti u bazi podataka i prikazivati/tampati
  u korisnikom interfejsu, moraju se iz UTF-8 prevesti u ANSI
  irilicu ili latinicu za koju postoji podrka u Alaska Xbase++.

  Prevoenje se vri preko tabela za prevoenje koje sadre
  hexadecimalni kod karaktera u UTF-8 i hexadecimalni kod
  odgovarajuih karaktera u ANSI Serbian Latin 238/1250 i
  ANSI Serbian Cyrilic 204/1251 code page.

  Ove tabele date su ovde u programu COM_1251.PRG i sadre
  funkcije za prevoenje ANSI irilice u latinicu i obrnuto,
  i funkcije za prevoenje UTF-8 irilice/latinice u ANSI
  irilicu i ANSI latinicu.

  Svi Serbian Cyrilic karakteri imaju u UTF-8 dva Hex znaka a u
  ANSI 204/1251 jedan Hex znak (Hex cod)

  Serbian Latin karakteri imaju u UTF-8 jedan Hex znak a u
  ANSI 238/1250 jedan Hex znak (Hex cod) isti kao u UTF8,
  izuzev karaktera Ǝ  koji imaju u UTF8 dva Hex
  znaka a u ANSI 238/1250 imaju jedan Hex znak (Hex cod)



  D O K U M E N T A C I J A

  https://www.utf8-chartable.de/
  Unicode/UTF-8-character table
  UTF-8 encoding table and Unicode characters page with code points
  U+0000 to U+00FF We need your support - If you like us - feel free
  to share. help/imprint (Data Protection)
  www.utf8-chartable.de


  https://www.charset.org/utf-8
  UTF-8 code page
  Unicode UTF-8 - characters 0 (U+0000) to 999 (U+03E7) UTF-8 stands
  for Unicode Transformation Format-8. UTF-8 is an octet (8-bit) lossless
  encoding of Unicode characters, one UTF-8 character uses 1 to 4 bytes.
  www.charset.org


  https://www.charset.org/charsets/windows-1250
  Character sets: Windows-1250 (legacy, Central Europe)
  Windows-1250 code page. Windows-1250 (legacy, Central Europe) is a 8-bit
  single-byte coded character set. Hex to decimal converter. The code page
  above has hexadecimal numbers, use this tool to convert to decimal:
  www.charset.org


  https://www.charset.org/charsets/windows-1251
  Character sets: Windows-1251 (legacy, Cyrillic)
  Windows-1251 code page. Windows-1251 (legacy, Cyrillic) is a 8-bit
  single-byte coded character set. Hex to decimal converter. The code page
  above has hexadecimal numbers, use this tool to convert to decimal:
  www.charset.org



	UNICODE
	CODE	CHAR	UTF-8  CP1250
	POINT		(HEX.) (HEX.)	NAME

 -------------------------------------------------------------------------
 1	U+0106		C4 86	C6	LATIN CAPITAL LETTER C WITH ACUTE
 2	U+0107		C4 87	E6	LATIN SMALL LETTER C WITH ACUTE
 3	U+010C		C4 8C	C8	LATIN CAPITAL LETTER C WITH CARON
 4	U+010D		C4 8D	E8	LATIN SMALL LETTER C WITH CARON
 5	U+0110		C4 90	D0	LATIN CAPITAL LETTER D WITH STROKE
 6	U+0111		C4 91	F0	LATIN SMALL LETTER D WITH STROKE
 7	U+0160		C5 A0	8A	LATIN CAPITAL LETTER S WITH CARON
 8	U+0161		C5 A1	9A	LATIN SMALL LETTER S WITH CARON
 9	U+017D		C5 BD	8E	LATIN CAPITAL LETTER Z WITH CARON
 10	U+017E		C5 BE	9E	LATIN SMALL LETTER Z WITH CARON




	 UNICODE
	 CODE	 CHAR	UTF-8  CP1250
	 POINT		 (HEX.) (HEX.)	NAME
 -------------------------------------------------------------------------
 11	U+0402		D0 82	80	CYRILLIC CAPITAL LETTER DJE
 12	U+0408	J	D0 88	A3	CYRILLIC CAPITAL LETTER JE
 13	U+0409	LJ	D0 89	8A	CYRILLIC CAPITAL LETTER LJE
 14	U+040A	NJ	D0 8A	8C	CYRILLIC CAPITAL LETTER NJE
 15	U+040B		D0 8B	8E	CYRILLIC CAPITAL LETTER TSHE
 16	U+040F	D	D0 8F	8F	CYRILLIC CAPITAL LETTER DZHE
 17	U+0410	A	D0 90	C0	CYRILLIC CAPITAL LETTER A
 18	U+0411	B	D0 91	C1	CYRILLIC CAPITAL LETTER BE
 19	U+0412	V	D0 92	C2	CYRILLIC CAPITAL LETTER VE
 20	U+0413	G	D0 93	C3	CYRILLIC CAPITAL LETTER GHE
 21	U+0414	D	D0 94	C4	CYRILLIC CAPITAL LETTER DE
 22	U+0415	E	D0 95	C5	CYRILLIC CAPITAL LETTER IE
 23	U+0416		D0 96	C6	CYRILLIC CAPITAL LETTER ZHE
 24	U+0417	Z	D0 97	C7	CYRILLIC CAPITAL LETTER ZE
 25	U+0418	I	D0 98	C8	CYRILLIC CAPITAL LETTER I
 26	U+041A	K	D0 9A	CA	CYRILLIC CAPITAL LETTER KA
 27	U+041B	L	D0 9B	CB	CYRILLIC CAPITAL LETTER EL
 28	U+041C	M	D0 9C	CC	CYRILLIC CAPITAL LETTER EM
 29	U+041D	N	D0 9D	CD	CYRILLIC CAPITAL LETTER EN
 30	U+041E	O	D0 9E	CE	CYRILLIC CAPITAL LETTER O
 31	U+041F	P	D0 9F	CF	CYRILLIC CAPITAL LETTER PE
 32	U+0420	R	D0 A0	D0	CYRILLIC CAPITAL LETTER ER
 33	U+0421	S	D0 A1	D1	CYRILLIC CAPITAL LETTER ES
 34	U+0422	T	D0 A2	D2	CYRILLIC CAPITAL LETTER TE
 35	U+0423	U	D0 A3	D3	CYRILLIC CAPITAL LETTER U
 36	U+0424	F	D0 A4	D4	CYRILLIC CAPITAL LETTER EF
 37	U+0425	H	D0 A5	D5	CYRILLIC CAPITAL LETTER HA
 38	U+0426	C	D0 A6	D6	CYRILLIC CAPITAL LETTER TSE
 39	U+0427		D0 A7	D7	CYRILLIC CAPITAL LETTER CHE
 40	U+0428		D0 A8	D8	CYRILLIC CAPITAL LETTER SHA
 41	U+0430	a	D0 B0	E0	CYRILLIC SMALL LETTER A
 42	U+0431	b	D0 B1	E1	CYRILLIC SMALL LETTER BE
 43	U+0432	v	D0 B2	E2	CYRILLIC SMALL LETTER VE
 44	U+0433	g	D0 B3	E3	CYRILLIC SMALL LETTER GHE
 45	U+0434	d	D0 B4	E4	CYRILLIC SMALL LETTER DE
 46	U+0435	e	D0 B5	E5	CYRILLIC SMALL LETTER IE
 47	U+0436		D0 B6	E6	CYRILLIC SMALL LETTER ZHE
 48	U+0437	z	D0 B7	E7	CYRILLIC SMALL LETTER ZE
 49	U+0438	i	D0 B8	E8	CYRILLIC SMALL LETTER I
 50	U+043A	k	D0 BA	EA	CYRILLIC SMALL LETTER KA
 51	U+043B	l	D0 BB	EB	CYRILLIC SMALL LETTER EL
 52	U+043C	m	D0 BC	EC	CYRILLIC SMALL LETTER EM
 53	U+043D	n	D0 BD	ED	CYRILLIC SMALL LETTER EN
 54	U+043E	o	D0 BE	EE	CYRILLIC SMALL LETTER O
 55	U+043F	p	D0 BF	EF	CYRILLIC SMALL LETTER PE
 56	U+0440	r	D1 80	F0	CYRILLIC SMALL LETTER ER
 57	U+0441	s	D1 81	F1	CYRILLIC SMALL LETTER ES
 58	U+0442	t	D1 82	F2	CYRILLIC SMALL LETTER TE
 59	U+0443	u	D1 83	F3	CYRILLIC SMALL LETTER U
 60	U+0444	f	D1 84	F4	CYRILLIC SMALL LETTER EF
 61	U+0445	h	D1 85	F5	CYRILLIC SMALL LETTER HA
 62	U+0446	c	D1 86	F6	CYRILLIC SMALL LETTER TSE
 63	U+0447		D1 87	F7	CYRILLIC SMALL LETTER CHE
 64	U+0448		D1 88	F8	CYRILLIC SMALL LETTER SHA
 65	U+0452		D1 92	90	CYRILLIC SMALL LETTER DJE
 66	U+0458	j	D1 98	BC	CYRILLIC SMALL LETTER JE
 67	U+0459	lj	D1 99	9A	CYRILLIC SMALL LETTER LJE
 68	U+045A	nj	D1 9A	9C	CYRILLIC SMALL LETTER NJE
 69	U+045B		D1 9B	9E	CYRILLIC SMALL LETTER TSHE
 70	U+045F	d	D1 9F	9F	CYRILLIC SMALL LETTER DZHE
 -------------------------------------------------------------------






  R A Z J A  N J E N J A

  1. Kod karakter seta eng. latin cp1250 svaki znak ima hexadecimalni
  i decimalni kod koji je jedan znak (bajt) od chr(0) do chr(127)

  2. Kod extended karakter seta cp1250 sa Serbian latin slovima Ǝ
  svako slovo ima hexadecimalni i decimalni kod koji je sastavljen od dva
  znaka (dva bajta) iji kod svakog bajta je vei od chr(127)

  3. Kod karakter seta cp1251 sa Serbian Cyrilic slovima svaki znak (slovo)
  ima hexadecimalni i decimalni kod od dva znaka (dva bajta) iji kod svakog
  bajta je vei od chr(127) a razliit je od kodova iz take 2.


  UNIKOD je univerzalni sistem za kodiranje slova (karaktera).
  Svako ovozemaljsko slovo koje je upisano u Unikod standard ima svoj
  jedinstveni broj. Ovaj broj se zove kodna taka (code point).

  Kodna taka moe da bude u opsegu od 0 pa do 10FFFF(hex) to znai
  da se mogu da katalogizuju 1.114.111 znakova.

  Znai, Unicode se bavi katalogizacijim ovozemaljskih slova, svakom slovu
  oni dodele neki broj i teraju dalje. trenutno su katalogizirali preko
  120.000 slova svih moguih i nemoguih jezika.

  UTF (Unicode transformation format) je algoritam za preslikavanje unikod
  kodne take u jedinstveni niz bajtova. Postoji vie varijanti UTF formata.

  UTF-8 je algoritam za preslikavanje unikod kodne take u jedinstveni niz
  bajtova promenljive duine od jednog do etiri bajta. Za nas su zanimljivi
  oni UTF-8 kodovi duine jedan i dva bajta.

  UNIKOD je karakter set (skup slova i kodne take tog slova) a UTF-8 je jedan
  od naina kodiranja unikod kodne take (slova).

  Unikod karakter set, kodiran po UTF-8 formatu moe da prikae slova latinice,
  irilice i slova ostalih pisama.

  Za nae potrebe, slova e biti kodirana sa jednim ili dva bajta. Slova engleskog
  alfabeta e biti kodirana sa jednim bajtom ija je vrednost od 0 do 127 dekadno
  (0 - 7F hex).

  UTF-8 kodovi ovih slova su isti kao i stari ASCII kodovi ovih slova.
  Naih 10 latininih slova(Ўƚ) koja ne pripadaju engleskom alfabetu e
  biti kodirana sa dva bajta, pri emu je prvi bajt vei od 127.

  Naih 60 irilinih slova e biti kodirana sa dva bajta, pri emu je prvi bajt
  vei od 127.

  Za kodiranje unikoda u utf-8 treba koristiti tabele. Jena od njih je:
  https://www.charset.org/utf-8
  UTF-8 code page
  Unicode UTF-8 - characters 0 (U+0000) to 999 (U+03E7) UTF-8 stands for Unicode
  Transformation Format-8. UTF-8 is an octet (8-bit) lossless encoding of Unicode
  characters, one UTF-8 character uses 1 to 4 bytes.
  www.charset.org


  Istorijski, pre Unicode UTF-8 kodiranja (koje predstavlja slovo sa od jednim do
  etiri bajta, u zavisnosti od slova) na ovim prostorima su se koristile Windows
  CP1250 kodna strana za srpsku latinicu i Windows CP1251 za srpsku irilicu.

  Ove kodne strane su svako slovo kodirale sa po jednim bajtom.
  Za potrebe kompatibilnosti sa ovim kodnim stranama potrebno je i mogue izvriti
  konverziju iz UTF-8 u CP1250 ili CP1251. Pri tom je konverzija iz UTF-8 u CP1250
  ili CP1251 uvek jednoznana dok je konverzija iz CP1250 i CP1251 zavisna od
  konteksta, odnosno moramo unapred znati da li je to to pretvaramo u unicode
  latinica ili irilica.

  UTF-8 nije prvazien standard niti je UTF-16 spektakularno superioran,
  jednostavno to su dva standarda pa kome ta treba neka uzme.



  Alaska Xbase++ ima funkcije za UTF-16 Little endian
  ---------------------------------------------------
  HexToStr( <cHexNumber> ) --> cByteString
  StrToHex( <cByteString> ) --> cHexNumber

  IsUnicode()
  Str2Unicode()
  Unicode2Str()

  Enkodiranje je sa UTF-16le (UTF-16 little endian),
  onako kako trae Alaska Xbase funkcije:

  little endian znai da je bajt najmanje teine upisan prvi (na nioj adresi) .
  Moe da bude i obrnuto odnosno big endian, kada je bajt najvee teine upisan
  prvi (na nioj adresi). E a da bi se znalo koji je poredak upotrebljen,
  dozvoljeno je korienje pomonog podataka, oznake za redosled bajtova:
  (byte order mark - BOM).

  primer:
  Unikod slovo  ima kod C486,
  sa little endian je 86C4 a sa big endian je C486.

  Note:
  Zanimljive su i Koriste se kao pomone i funkcije za baze podataka:

  RandomInt() Calculate a random numeric value

  RandomKey() Calculates a random character string
              values depending on your requirements.
  Char2Hash() Convert a character string to a hash value

  UUIDCreate() Create a Universally Unique IDentifier

  UUIDFromChar() Convert a UUID to its binary representation
  UUIDToChar()   management and create unique identifiers for your data.
                 Convert a UUID to its readable representation



 Pablo Botella
 =========================================
 http://ot4xb.xbwin.com/ot4xb
 http://ot4xb.xbwin.com/ot4xb/home/unicode
 =========================================

  Library: ot4xb.lib, ot4xb.dll
  Pablo Botella

  cAnsiToUtf8( cAnsi ) -> cUtf8
  cUtf8ToAnsi(cUtf8)   -> cAnsi

  cOemToUtf8(cOem)     -> cutf8
  cUtf8ToOem(cUtf8)    -> cOem

  cSzAnsi2Wide( <cAnsiStr> )    -> cUnicodeStr
  cSzWide2Ansi( <cUnicodeStr> ) -> cAnsiStr


 Te following 3 new functions are intended to use specific
 codepages and custom flags to define character composition

 Sledee 3 nove funkcije su namenjene za korienje specifinih
 codepages i korisnikih oznaka (flag) za definiranje sastava
 znakova

 ************************************************************
 _mb2w( str , nCP , nFlags = 0, lNoAddZero = .F. ) ->  wstr
 ************************************************************

   Multibyte to wide char conversion
   str  -> source multibyte string
   nCP  -> codepage used in the source multibyte string
   Unless the param lNoAddZero will be .T.
   the resulting wstr will terminate with Chr(0) + Chr(0)
   even if the source string not terminate with Chr(0)

   Pretvaranje viebajtnih u iroke char
str -> izvorni viebajtni niz
nCP -> kodna stranica koja se koristi u izvornom viebajtnom nizu
       Osim ako param lNoAddZero nee biti .T.
       rezultirajui wstr prestat e s Chr (0) + Chr (0)
       ak i ako izvorni niz ne prestaje s Chr (0)



 *********************************************************
 _w2mb( wstr , nCP , nFlags , lRemoveZero = .F. ) ->  str
 *********************************************************

    Wide char to Multibyte
    nCP -> codepage that will be used in the resulting multibyte string
           If lRemoveZero is .T. the trailing Chr(0) will be removed

    Wide char to Multibyte
 nCP -> kodna stranica koja e se koristiti u rezultirajuem viebajtnom nizu
 Ako je lRemoveZero .T. zadnji Chr (0) bie uklonjen


 *************************************************************************
 _mb2mb( str , nCPFrom = 0, nCPTo = 0, nFlags1 = 0, nFlags2 = 0 ) ->  str2
 *************************************************************************

     Convert a multibyte string using the codepage nCPFrom
     to anothe multibyte string using the codepage nCPTo
     An intermediate wide string will be used, so nFlags1 will be used
     for the first _mb2w() translation and nFlags2 will be used
     for the final _w2mb() translation
     Trailing Chr(0) will be preserved if any.

      Pretvorite viebajtni niz pomou kodne stranice nCPFrom
 to anothe multibyte string koristei kodnu stranicu nCPTo
 Koristie se srednji iroki niz, pa e se koristiti nFlags1
 za prvi prijevod _mb2w () i nFlags2 e se koristiti
 za konani prijevod _w2mb ()
 Zadnji Chr (0) bie sauvan ako ga ima.


      **************************
      Multibyte codepages can be
      **************************
      0  ->  ANSI code page
      1  ->  OEM code page
      65000 -> UTF-7
      65001 -> UTF-8
      Also can be any codepage instaled at the system
      Takoer moe biti bilo koja kodna stranica instalirana u sustavu


      Usually nFlags will not be specified ( DEFAULT 0),
      but can be used to define what to do when a character
      have not a direct translation
      I've put the table below, but you search
      MultibyteToWideChar / WideCharToMultibyte in MSDN
      for more detailed explanation.

       Obino nFlags nee biti specificirani (DEFAULT 0),
 ali se moe koristiti za definiranje ta treba uiniti
       kada character nemaju direktan prijevod
 Stavio sam tabelu ispod, ali vi traite
 MultibyteToWideChar / WideCharToMultibyte
       u MSDN-u za detaljnije objanjenje.


       Multibyte to Wide Flags:

       #define MB_PRECOMPOSED 0x00000001       // use precomposed chars
       #define MB_COMPOSITE 0x00000002         // use composite chars
       #define MB_USEGLYPHCHARS 0x00000004     // use glyph chars, not ctrl chars
       #define MB_ERR_INVALID_CHARS 0x00000008 // error for invalid chars
       #define WC_DEFAULTCHAR 0x00000040       // replace w/ default char
       #define WC_ERR_INVALID_CHARS 0x00000080 // error for invalid chars
       #define WC_NO_BEST_FIT_CHARS 0x00000400 // do not use best fit chars

       Wide to Multibyte Flags:

       #define WC_COMPOSITECHECK 0x00000200    // convert composite to precomposed
       #define WC_DISCARDNS 0x00000010         // discard non-spacing chars
       #define WC_SEPCHARS 0x00000020          // generate separate chars

 *****************************************

  dobijanje unikoda iz xbpslee()
  ------------------------------
  _w2mb( wstr , nAcp , nFlags , lRemoveZero ) -> multibyte string
         utf-8 codepage = 65001
         so
  cUtf8 := _w2mb( cUnicode , 65001 )
  GetWindowTextW()

  ja koristim funkciju:
  ---------------------
  function GetUnicodeText( oXbp ) // oXbp => XbpSle()
     local nRet, cString, cUnicodeBuffer, hWnd := oXbp:getHWND(), nLen := oXbp:bufferLength
     cString := space(nLen)+chr(0)      // ASCIIZ
     msgbox(\"Unicodestring ? \"+YesNo(isUnicode(cString)),\"UNICODE NO / NEIN !\")
     msgbox(\"GetWindowTextLengthA() = \"+var2char( @User32:GetWindowTextLengthA(hWnd) ) + chr(13)+;
            \"GetWindowTextLengthW() = \"+var2char( @User32:GetWindowTextLengthW(hWnd) ) + chr(13)+;
            \"oSle:bufferLength()    = \"+var2char( nLen ) )
     cUnicodeBuffer := cSzAnsi2Wide(cString)
     // NOW it IS unicode !
     msgbox(\"Unicodestring bevor GetWindowTextW ? \"+YesNo(isUnicode(cUnicodeBuffer)),\"UNICODE YES / JA ?\")
     // isUnicode(cUnicodeBuffer) => .t.
     nRet := @User32:GetWindowTextW(hWnd, @cUnicodeBuffer, nLen+1 )  // this don\'t work
     // isUnicode(cUnicodeBuffer) => .f.

  ist there a parameter mismatch ?
  But I will get back the Ansi part of the string.
  What do I want to do ?
  Get UNICODE back of the oSle, transform it directly
  to UDF8 and modify the getData() SetData()
  Part to set/get UTF-8 dataformat. With this it would
  be possibel to use Unicode in Xbase++ controls
  and save it to dbf ... or am I wrong ?
  Hubert


  Izdvajanje ansi dela iz stringa
  ta elim uiniti: Vratite UNICODE natrag na oSle,
  transformiite ga direktno u UTF8 i modificirati
  getData () SetData ()
  Dio za postavljanje / dobivanje UTF8 formata podataka.
  Sa ovim bi bili u mogunosti koristiti Unicode u Xbase++
  kontrolama i snimiti ga ga u dbf ... ili nisam u pravu?
  Hubert
  Odgovor Pablo Bottela:
  ----------------------
  #include "ot4xb.ch"

  function cGetWindowTextW( wnd ) //  -> cWideText // wnd can be xbp or hwnd
  local cc      := @user32:["__sl__hw"]:GetWindowTextLengthW(wnd) + 1
  local buffer  := ChrR(0,(cc * 2) + 2 )
  cc := @user32:["__sl__hw__pt__sl"]:GetWindowTextW( wnd,@buffer,cc)
  return PeekStr(buffer,,cc*2)

  function SetWindowTextW( wnd , cWideText ) // -> lOk
  return @user32:["__bo__hw__pt"]:SetWindowTextW( wnd,__vstr(cWideText,"") + ChrR(0,2) )

  Zaboravi na IsUnicode() funkciju koja je beskorisna.
  Pablo Botela

  Auge
  -----
  i to sve radi ako koristite pravi font i manifest-fajl
  ::oChina:rbDown := {| aPos, uNIL, oSelf | ::ChCopy2CLP(oSelf)  }
     //
     // XP Manifest will cause wrong chinese Output on German OS()
     //
     IF lisTheme
        SetThemesOn(.F.)
     ENDIF
     ::oChina:create()
     ::oChina:setData()
     ::oChina:setfont( oFnt )
     IF lisTheme
        SetThemesOn(.T.)
     ENDIF
  ...

  METHOD ArtClass:ChCopy2CLP(obj)
  LOCAL oClipBoard := XbpClipBoard():new():create()
  LOCAL cText := obj:Editbuffer()
     oClipBoard:open()
     oClipBoard:clear()
     oClipBoard:setBuffer(ConvToAnsiCP(cText),XBPCLPBRD_UNICODE)
     oClipBoard:close()
  RETURN .T.

  /////////////////////////////////////////////////////////////////////
  //  FUNCTION SetThemesOn( lThemes )
  /////////////////////////////////////////////////////////////////////
  //  To disable theming set lThemes to .F.
  //  To re-enable theming set lThemes to .T.
  //  To use just a portion of themes, combine the following values:
  //       #define STAP_ALLOW_NONCLIENT  0x01 // i.e. frame & title bar
  //       #define STAP_ALLOW_CONTROLS   0x02
  //       #define STAP_ALLOW_WEBCONTENT 0x04
  /////////////////////////////////////////////////////////////////////
  #define STAP_ALLOW_NONCLIENT  0x01 // i.e. frame & title bar
  #define STAP_ALLOW_CONTROLS   0x02
  #define STAP_ALLOW_WEBCONTENT 0x04

  FUNCTION SetThemesOn( xThemes )
  LOCAL nFlags, nOldFlags
  LOCAL hDLL := DllLoad("uxtheme.dll")

     IF empty(xThemes)
        nFlags := 0
     ELSEIF valType(xThemes) == 'L'
        nFlags :=
  STAP_ALLOW_NONCLIENT+STAP_ALLOW_CONTROLS+STAP_ALLOW_WEBCONTENT
     ELSE
        nFlags := xThemes
     ENDIF
     IF hDll <> 0
        nOldFlags := DllCall( hDll, DLL_STDCALL, "GetThemeAppProperties" )
        DllCall( hDll, DLL_STDCALL, "SetThemeAppProperties", nFlags )
     ENDIF
  RETURN nOldFlags



  Blagojevi Dragan, dipl.ing.
  Stanojevi Slobodan, dipl.ing.
  BAST Open Source Project, www.cobasystems.com 25.07.2019 - 20.11.2019

ENDTEXT



  TxtFile := "t.txt"
  MEMOWRIT(TxtFile,txt)
  *******************************************
  off := Font_codepage(10,"Courier New",238,.f.)
  * off := Font_codepage(10,"Fixedsys",238,.f.)
  * off := Font_codepage(10,"System",238,.f.)
  C_EDIT(TxtFile,,,100,20,,,,off) // baznex.dll
  *******************************************


RETURN NIL















/*
*---
Syntax
HexToStr( <cHexNumber> ) --> cByteString

Purpose
Converts a string coding a hex number to a string in binary format

Return
Returns a string with <cHexNumber> converted to bytes.

Description
Each two characters of <cHexString> are converted to one byte in the result string.
Only characters "0" - "9" and "A" - "F" are allowed in <cHexString>.
*---
Syntax
StrToHex( <cByteString> ) --> cHexNumber

Purpose
Converts a binary string to a string of hex numbers

Return
Returns a string of double length of <cByteString>.
Each character's Ascii code of <cByteString> is converted to two characters
in the result string which represents the corresponding hexadecimal number.
*---
*/
*************************************************************************
FUNCTION test_hex_latin_cyrilic()
*************************************************************************
* "OVA FUNKCIJA SLUI ZA TEST I ZA DOBIJANJE HEX I CHR KODOVA SLOVA
* "OVDE KAO POMO PROGRAMERU I NE KORISTI SE IZ POSLOVNIH APLIKACIJA


LOCAL GetList := {}, GetOptions, oDlg

/*
--------
VANO
--------

Serbian Latin slova
   ,,,,,,,,,
i Serbian yrilic slova:
   ,,,,,,,,,,Lj,Nj,D,lj,nj,d
imaji svoje ASC kodove i HEXADECIMALNE kodove u skupu ASC znakova
latinica 238/1250 i irilica 204/1251
koji se razlikuju od ASC i HEXADECIMALNIH kodova koje imaju ista slova
u unicode UTF8 skupu znakova,

na primer:
slovo M ima u svim skupovima znakova 1250 i 1251 i UTF8 kod 4D

slovo  ima u skupu znakova 1250 kod C8
slovo  ima u skupu znakova 1251 kod D7
slovo  ima u skupu znakova UTF8 kod C48C

Sva Ostala slova i brojevi i drugi znakovi imaju iste ASC i HEX kodove
u 1250 i 1251 i UTF8 skupu znakova


***************************
Heksadecimalni kodovi slova
***************************

------------
ASC 238/1250
------------
LATINICA
--------
=8A
=9A
=D0
=F0
=C8
=E8
=C6
=E6
=8E
=9E

------------
ASC 204/1251
------------
IRILICA
--------
=D8
=F8
=80
=90
=D7
=F7
=8E
=9E
=C6
=E6

LJ=8A
lj=9A
NJ=8C
nj=9C
D=8F
d=9F



----
UTF8
----

LATINICA
--------
=c5 a0
=c5 a1
=c4 90
=c4 91
=c4 8c
=c4 8d
=c4 86
=c4 87
=c5 bd
=c5 be

LJ=c7 88
lj=c7 89
NJ=c7 8b
nj=c7 8c
D=c7 85
d=c7 86

IRILICA
--------
=d0 a8
=d1 88
=d0 82
=d1 92
=d0 a7
=d1 87
=d0 8b
=d1 9b
=d0 96
=d0 b6

LJ=d0 89
lj=d1 99
NJ=d0 8a
nj=d1 9a
D=d0 8f
d=d1 9f



*/

* ovo je po defaultu za setup windowsa na Serbian Latin pa se
* tada ne mora (kao ovde) setovati font na codepage 238
* "LATIN SERBIAN (font object)
*--------------------------------
oFontl := XbpFont():new()
oFontl:familyName := 'Consolas' //'Arial'
oFontl:nominalPointSize := 14
oFontl:bold := .t.
//oFontl:italic := .t.
//oFontl:underScore := .t.
oFontl:codePage := 238 // CodePage Serbian latin=238/1250
oFontl:create()// L A T I N I C A


* da bi se videla irilica mora se setovati Cyrilic font objekta
* na codepage 204
* "CYRILIC SERBIAN (font object)
*--------------------------------
oFontc := XbpFont():new()
oFontc:familyName := 'Consolas' // 'Arial'
oFontc:nominalPointSize := 14
oFontc:bold := .t.
//oFontc:italic := .t.
//oFontc:underScore := .t.
oFontc:codePage := 204 // CodePage Serbian cyrilic=204/1251
oFontc:create() //  I R I L I C A


* Unicode M u hexa formatu
* string := HexToStr("4d") // "M" = 0x4d = "4d"
* stop(string,1) // "M"  ita ga ispravno
* Unicode  u hexa formatu
* cstring := HexToStr("c48c") // "" = 0xc4 0x8c = "c48c"
* stop(cstring,1) // "AS" ita ga neispravno


*--- latinica
/*
=8A
=9A
=D0
=F0
=C8
=E8
=C6
=E6
=8E
=9E
*/


* slova su upisana u kod preko Serbian Latin tastature
* i mogu se prikazati samo fontom ija je kodna strana 238
*--- velika
Vh1 := StrToHex("")
Vh2 := StrToHex("")
Vh3 := StrToHex("")
Vh4 := StrToHex("")
Vh5 := StrToHex("")

Mh1 := HexToStr("8A")
Mh2 := HexToStr("D0")
Mh3 := HexToStr("C8")
Mh4 := HexToStr("C6")
Mh5 := HexToStr("8E")

*---mala
Xh1 := StrToHex("")
Xh2 := StrToHex("")
Xh3 := StrToHex("")
Xh4 := StrToHex("")
Xh5 := StrToHex("")

Yh1 := HexToStr("9A")
Yh2 := HexToStr("F0")
Yh3 := HexToStr("E8")
Yh4 := HexToStr("E6")
Yh5 := HexToStr("9E")



*--- irilica
/*
=D8
=F8
=80
=90
=D7
=F7
=8E
=9E
=C6
=E6

Lj=8A
lj=9A
Nj=8C
nj=9C
D=8F
d=9F
*/


* slova su upisana u kod preko Serbian Cyrilic tastature
* i mogu se prikazati samo fontom ija je kodna strana 204
*---velika
Wh1 := StrToHex("")  // D8  
Wh2 := StrToHex("")  // 80  
Wh3 := StrToHex("")  // D7  
Wh4 := StrToHex("")  // 8E  
Wh5 := StrToHex("")  // C6  

Wh6 := StrToHex("")  // 8A  LJ
Wh7 := StrToHex("")  // 8C  NJ
Wh8 := StrToHex("")  // 8F  D


Qh1 := HexToStr("D8")
Qh2 := HexToStr("80")
Qh3 := HexToStr("D7")
Qh4 := HexToStr("8E")
Qh5 := HexToStr("C6")


Qh6 := HexToStr("8A")
Qh7 := HexToStr("8C")
Qh8 := HexToStr("8F")

*---mala

Ah1 := StrToHex("")  // F8  
Ah2 := StrToHex("")
		      // 90  
Ah3 := StrToHex("")  // F7  
Ah4 := StrToHex("")  // 9E  
Ah5 := StrToHex("")  // E6  

Ah6 := StrToHex("")  // 9A  lj
Ah7 := StrToHex("")  // 9C  nj
Ah8 := StrToHex("")  // 9F  d


Bh1 := HexToStr("F8")
Bh2 := HexToStr("90")
Bh3 := HexToStr("F7")
Bh4 := HexToStr("9E")
Bh5 := HexToStr("E6")

Bh6 := HexToStr("9A")
Bh7 := HexToStr("9C")
Bh8 := HexToStr("9F")


@ 0,2 DCSAY "HEKSADECIMALNI KOD I ODGOVARAJUI KARAKTER (STRING)" SAYSIZE 0

*--- latinica
@ 1,2 DCSAY  Vh1+" "+Mh1+" ---  "+Xh1+" "+Yh1	SAYSIZE 50 OBJECT oTxt1
@ 2,2 DCSAY  Vh2+" "+Mh2+" ---  "+Xh2+" "+Yh2	SAYSIZE 50 OBJECT oTxt2
@ 3,2 DCSAY  Vh3+" "+Mh3+" ---  "+Xh3+" "+Yh3	SAYSIZE 50 OBJECT oTxt3
@ 4,2 DCSAY  Vh4+" "+Mh4+" ---  "+Xh4+" "+Yh4	SAYSIZE 50 OBJECT oTxt4
@ 5,2 DCSAY  Vh5+" "+Mh5+" ---  "+Xh5+" "+Yh5	SAYSIZE 50 OBJECT oTxt5

*--- irilica
@ 7, 2 DCSAY  Wh1+" "+Qh1+" ---  "+Ah1+" "+Bh1	 SAYSIZE 50 OBJECT eTxt1
@ 8, 2 DCSAY  Wh2+" "+Qh2+" ---  "+Ah2+" "+Bh2	 SAYSIZE 50 OBJECT eTxt2
@ 9, 2 DCSAY  Wh3+" "+Qh3+" ---  "+Ah3+" "+Bh3	 SAYSIZE 50 OBJECT eTxt3
@ 10,2 DCSAY  Wh4+" "+Qh4+" ---  "+Ah4+" "+Bh4	 SAYSIZE 50 OBJECT eTxt4
@ 11,2 DCSAY  Wh5+" "+Qh5+" ---  "+Ah5+" "+Bh5	 SAYSIZE 50 OBJECT eTxt5


@ 13,2 DCSAY  Wh6+" "+Qh6+" ---  "+Ah6+" "+Bh6	 SAYSIZE 50 OBJECT eTxt6
@ 14,2 DCSAY  Wh7+" "+Qh7+" ---  "+Ah7+" "+Bh7	 SAYSIZE 50 OBJECT eTxt7
@ 15,2 DCSAY  Wh8+" "+Qh8+" ---  "+Ah8+" "+Bh8	 SAYSIZE 50 OBJECT eTxt8


@ 16,2 dcsay ""

DCGETOPTIONS ICON 1

DCREAD GUI OPTIONS GetOptions TITLE "LATINICA - IRILICA - LATINICA" ;
   FIT ;
   PARENT @oDlg ;
   EVAL {|o| SetAppWindow(o), ;
   oTxt1:setfont(oFontl), ;
   oTxt2:setfont(oFontl), ;
   oTxt3:setfont(oFontl), ;
   oTxt4:setfont(oFontl), ;
   oTxt5:setfont(oFontl), ;
   eTxt1:setfont(oFontc), ;
   eTxt2:setfont(oFontc), ;
   eTxt3:setfont(oFontc), ;
   eTxt4:setfont(oFontc), ;
   eTxt5:setfont(oFontc), ;
   eTxt6:setfont(oFontc), ;
   eTxt7:setfont(oFontc), ;
   eTxt8:setfont(oFontc)} ;
   MODAL



RETURN NIL





*************************************************************************
FUNCTION test_utf8_latin_cyrilic()
*************************************************************************
LOCAL GetList := {}, GetOptions, oDlg

* ovo je po defaultu za setup windowsa na Serbian Latin pa se
* tada ne mora (kao ovde) setovati font na codepage 238
* "LATIN SERBIAN (font object)
*--------------------------------
oFontl := XbpFont():new()
oFontl:familyName := 'Consolas' //'Arial'
oFontl:nominalPointSize := 14
oFontl:bold := .t.
//oFontl:italic := .t.
//oFontl:underScore := .t.
oFontl:codePage := 238 // CodePage Serbian latin=238/1250
oFontl:create()// L A T I N I C A


* da bi se videla irilica mora se setovati Cyrilic font objekta
* na codepage 204
* "CYRILIC SERBIAN (font object)
*--------------------------------
oFontc := XbpFont():new()
oFontc:familyName := 'Consolas' // 'Arial'
oFontc:nominalPointSize := 14
oFontc:bold := .t.
//oFontc:italic := .t.
//oFontc:underScore := .t.
oFontc:codePage := 204 // CodePage Serbian cyrilic=204/1251
oFontc:create() //  I R I L I C A


* Unicode M u hexa formatu
* string := HexToStr("4d") // "M" = 0x4d = "4d"
* stop(string,1) // "M"  ita ga ispravno
* Unicode  u hexa formatu
* cstring := HexToStr("c48c") // "" = 0xc4 0x8c = "c48c"
* stop(cstring,1) // "AS" ita ga neispravno


* Utf8Prezime := ConvToAnsiCP("IKOVI")  // utf8 string
* AnsiPrezime := ConvToAnsiCP("IKOVI")  // utf8 string


RETURN NIL
















***************************************************************************
FUNCTION  unicode__to_texteditor()
***************************************************************************

/*
//=============== start
// BOM SIGNATURA
//===============
// Mnogi text editori ne mogu da prikau UTF-8 karaktere
// (nema konverzije UTF8 u ANSI latinicu i irilicu)
// ako text fajl koji ih sadri nema oznaku: UTF8 BOM signature
// UTF8 BOM signature mora biti na poetku svakog text fajla.
//
// Da li text fajlova ima na svom poetku BOM signaturu:
   *  vTxt := tekst preuzet iz fajla cTxt u string vTxt
      vTxt := alltrim( MEMOREAD(cTxt) )
// nTxt := broj karaktera stringa
      nTxt := LEN(vTxt)
// UTF-8 BOM sugnatura
      BOM := Chr(0xEF) + Chr(0xBB) + Chr( 0xBF )
// mTxt = pozicija na kojoj poinje UTF8 BOM signatura u stringu vTxt
      mTxt := AT( BOM, vTxt )

IF mTxt>0

   BOM:=.T.// postoji BOM sugnatura
   c__poruka("U TXT FAJLU POSTOJI BOM SIGNATURA ZA UTF-8","BOM SIGNATURA ZA UTF-8",,"V")

// OBRII SVE DO BOM SIGNATURE IZ TXT FAJLA TAKO DA BOM BUDE PRVI ZNAK:
// oTxt := odseci poetak stringa sve do poetka UTF8 BOM
// pa sada korigovani string poinje sa UTF8 BOM
      oTxt := SUBSTR(vTxt,mTxt,nTxt)
// snimi korigovan string oTxt u fajl cTxt
// pa e fajl cTxt poinjati sa UTF8 BOM signaturom
      MEMOWRIT(cTxt,oTxt)

ELSE

   BOM:=.F.// ne postoji BOM signatura
   c__poruka("UPISANA JE U TXT FAJL BOM SIGNATURA ZA UTF-8","BOM SIGNATURA ZA UTF-8",,"V")

// UPII BOM SIGNATURU KAO PRVI ZNAK U TXT FAJL


    *  nHandle:=fopen(cTxt,FO_WRITE)
    *  pos:=fseek(nHandle,0,FS_SET)
    *  fwrite(nHandle,BOM)
    *  fclose(nHandle)
    *  ne radi kako treba - pojede prvi znak teksta ?

      vTxt := alltrim( MEMOREAD(cTxt) )
      vTxt := BOM+vTxt
      memowrit(cTxt,vTxt)


    * // kontrola upisane BOM signature
    *  vTxt := alltrim( MEMOREAD(cTxt) )
    *  mTxt := AT( BOM, vTxt )
    *  IF mTxt>0
    *	  c__poruka("OK")
    *  ELSE
    *	  c__poruka("NO")
    *  ENDIF
    *
ENDIF
//===============
// BOM SIGNATURA
//=============== end
*/


* unicode__to_cyrilic_help()

 * c:\utf__cyrilic_string.xpf - "QWERTZUIOPASDFGHJKLƎYXCVBNMqwertzuiopasdfghjklyxcvbnm" irilica
 * preuzeto iz UTF8 polja SQLite tabele
 * snimljeno u fajl: c:\utf__cyrilic_string.xpf
 * kao varijabla: utf_cyrilic_string

 RESTORE FROM utf__cyrilic_string.xpf ADDITIVE

 * dobijena varijabla je: utf_cyrilic_string

 UTF :=  utf_cyrilic_string

 * treba je poslati u tekst editor gde treba da se prikau ispravna slova:


 cTxt := "unicode_texteditor.txt"

 MEMOWRIT(cTxt,"NOTEPAD.EXE"+chr(13)+chr(10)+UTF)

 RUNSHELL("unicode_texteditor.txt","NOTEPAD.EXE") // prikazuje UTF-8 - nema instalaciju

if file("AKELPAD\AKELPAD.EXE")
   MEMOWRIT(cTxt,"AKELPAD.EXE"+chr(13)+chr(10)+UTF)
   RUNSHELL("unicode_texteditor.txt","AKELPAD\AKELPAD.EXE") // prikazuje UTF-8 - nema instalaciju
endif

if file("notepad++\notepad++.exe")
   MEMOWRIT(cTxt,"NOTEPAD++.EXE"+chr(13)+chr(10)+UTF)
   RUNSHELL(ctxt,"notepad++\notepad++.exe") // prikazuje UTF-8 // nema instalaciju
endif

if file("list.exe")
    MEMOWRIT(cTxt,"NOTEPAD2.EXE (LIST.EXE)"+chr(13)+chr(10)+UTF)
 * list.exe = notepad2.exe
   RUNSHELL(ctxt,"list.exe") // ne prikazuje UTF-8 - nema instalaciju
endif

RETURN NIL







#include "ot4xb.ch"
***************************************************************************
FUNCTION  test_alaska_unicode_function(nn)
***************************************************************************
LOCAL cr:=chr(13)+chr(10)
LOCAL cl:=chr(59)


  *unicodeslika := 3991
  unicodeslika := XbpBitmap():new():create()
  unicodeslika:Load("CSYSTEMSU.DLL",3991)

  *unicodeslika := 3992
  *unicodeslika := XbpBitmap():new():create()
  *unicodeslika:Load("CSYSTEMSU.DLL",3992)


  qq:= alertbox(,".                                                    .",{"  DA  ","  NE  "},,;
  "TEST KONVERZIJE ISTOG UNICODE STRINGA U FORMATU UTF-8 I U FORMATU UTF-16",,,unicodeslika,,)
  IF qq==0 .or. qq==2
     RETURN NIL
  ENDIF





*  Alaska Xbase++ ima funkcije za UTF-16 Little endian
*  ---------------------------------------------------
*  HexToStr( <cHexNumber> ) --> cByteString
*  StrToHex( <cByteString> ) --> cHexNumber
*
*  IsUnicode()
*  Str2Unicode()
*  Unicode2Str()


    *-------------------------------------------------------
    * kad se iz SQL polja preuzme unicode string:
    *-------------------------------------------------------

 //------ UTF-8

 // UTF-8 string "(UTF-8) Ǝ - QWXY --- ؀׎ - "   zadnjih 12 znakova su irilica
 // uzet iz SQL database i prekodiran u HEX kodove kako na nnjega ne bi imao uticaja editor teksta (koda)
 hexUTF8 := "285554462D382920C5A0C490C48CC486C5BD202D2051575859202D2D2D20D0A8D082D0A7D08BD096202D20D089D08AD08FD085"
    UTF8 := hextostr(hexUTF8) // vraanje UTF-8 stringa u unicode string

  * txt+UTF8 ili UTF8+txt daju string koji vie nije unicode ve cp238
  txt:="Prikaz u NOTEPAD.EXE editoru koji, podrava rad"     +cr+;
       "sa unicode karakter setom, stringa uzetog iz SQL"    +cr+;
       "baze podataka gde je upisan kao unicode UTF-8"       +cr+cr

  msgbox(txt,"UTF-8")
  memowrit("tekst.txt",UTF8)
  RunShell("tekst.txt","notepad.exe")  // prikaz u notepad.exe jer podrava rad sa unicode

 //------ UTF-8

 //------ UTF-16

 // UTF-16 string "(UTF16) Ǝ - QWXY --- ؀׎ - "   zadnjih 12 znakova su irilica
 // uzet iz SQL database i prekodiran u HEX kodove kako na nnjega ne bi imao uticaja editor teksta (koda)
 hexUTF16:= "2855544631362920C5A0C490C48CC486C5BD202D2051575859202D2D2D20D0A8D082D0A7D08BD096202D20D089D08AD08FD085202020"
    UTF16 := hextostr(hexUTF16) // vraanje UTF-16 stringa u unicode string

  * Note: UTF8+UTF16 daju string koji je utf-8 a UTF-16+UTF-8 daju string koji je utf-16
  txt:="Prikaz u NOTEPAD.EXE editoru koji podrava rad"  +cr+;
       "sa unicode karakter setom stringa uzetog iz SQL" +cr+;
       "baze podataka gde je upisan kao unicode UTF-16"  +cr+cr

  msgbox(txt,"UTF-16")
  memowrit("tekst.txt",UTF16)
  RunShell("tekst.txt","notepad.exe")  // prikaz u notepad.exe jer podrava rad sa unicode

 //------ UTF-16







********************
**** QUICK TEST ****
********************


  * U notepad.exe napisan je isti unicode tekst (sa slike) u tri formata UTF-8, UTF-16le(unicode), UTF-16be
  * svaki format teksta je uitan u hex editor, a iz hex editora uzet je hex string i upisan ovde:

  * UTF-8
  * EF BB BF 28 55 54 46 2D 38 29 20 C5 A0 C4 90 C4 8C C4 86 C5 BD 20 2D 20 51 57 58 59 20 2D 2D 2D 20 D0 A8 D0 82 D0 A7 D0 8B D0 96 20 2D 20 D0 89 D0 8A D0 8F D0 85
  * UTF-16 le
  * FF FE 28 00 55 00 54 00 46 00 2D 00 38 00 29 00 20 00 60 01 10 01 0C 01 06 01 7D 01 20 00 2D 00 20 00 51 00 57 00 58 00 59 00 20 00 2D 00 2D 00 2D 00 20 00 28 04 02 04 27 04 0B 04 16 04 20 00 2D 00 20 00 09 04 0A 04 0F 04 05 04
  * UTF-16 be
  * FE FF 00 28 00 55 00 54 00 46 00 2D 00 38 00 29 00 20 01 60 01 10 01 0C 01 06 01 7D 00 20 00 2D 00 20 00 51 00 57 00 58 00 59 00 20 00 2D 00 2D 00 2D 00 20 04 28 04 02 04 27 04 0B 04 16 00 20 00 2D 00 20 04 09 04 0A 04 0F 04 05


  hUTF8    := "285554462D382920C5A0C490C48CC486C5BD202D2051575859202D2D2D20D0A8D082D0A7D08BD096202D20D089D08AD08FD085"
  hUTF16le := "28005500540046002D00380029002000600110010C0106017D0120002D002000510057005800590020002D002D002D0020002804020427040B04160420002D00200009040A040F040504"
  hUTF16be := "0028005500540046002D00380029002001600110010C0106017D0020002D002000510057005800590020002D002D002D0020042804020427040B04160020002D00200409040A040F0405"



//-------------------- UTF-8 COBA FUNKCIJE

  *ISPRAVNO PREVEDE U LATINICU:
  *----------------------------
  msgbox("UTF-8: UTF8_TO__Latin1250(unicodestring)","COBA utf to latin function")
  unicodeString := hexTostr(hUTF8)
  asciString := UTF8_TO__Latin1250(unicodeString)
  memowrit("unicode_test_utf8.txt",unicodestring+cr+cr+asciString)
  RunShell("unicode_test_utf8.txt","notepad.exe")

  *ISPRAVNO PREVEDE U IRILICU
  *---------------------------
  msgbox("UTF-8: UTF8_TO__Cyrilic1251(unicodestring)","COBA utf to cyrilic function")
  unicodeString := hexTostr(hUTF8)
  asciString := UTF8_TO__Cyrilic1251(unicodeString)
  memowrit("unicode_test_utf8.txt",unicodestring+cr+cr+asciString)
  RunShell("unicode_test_utf8.txt","notepad.exe")

//-------------------- UTF-8 COBA FUNKCIJE



//-------------------- UTF-8 ot4xb.dll Pbalo Bottela

  * ISPRAVNO PREVEDE U LATINICU A U IRILICU ?????
  *------------------------------------------------
  msgbox("UTF-8: cUtf8ToAnsi(unicodestring)","Pablo Bottela function")
  unicodeString := hexTostr(hUTF8)
  asciString := cUtf8ToAnsi(unicodeString)
  memowrit("unicode_test_utf8.txt",unicodestring+cr+cr+asciString)
  RunShell("unicode_test_utf8.txt","notepad.exe")

//-------------------- UTF-8 ot4xb.dll Pbalo Bottela




//---------------------- UTF-16	le Xbase++ FUNKCIJE

  * ISPRAVNO PREVEDE U LATINICU A U IRILICU ?????
  *------------------------------------------------
  msgbox("UTF-16 litlle endian: UnicodeToStr(unicodestring)","Alasaka Xbase++ function")
  unicodeString := hexTostr(hUTF16le)
  asciString := Unicode2Str(unicodeString)
  memowrit("unicode_test_utf16le.txt",unicodestring+cr+cr+asciString)
  RunShell("unicode_test_utf16le.txt","notepad.exe")

//---------------------- UTF-16	le Xbase++ FUNKCIJE


//---------------------- UTF-16	le ot4xb.dll Pablo Bottela FUNKCIJE

  * ISPRAVNO PREVEDE U LATINICU A U IRILICU ?????
  *------------------------------------------------
  msgbox("UTF-16 litlle endian: cSzWide2Ansi(unicodestring)","Pablo Bottela ot4xb.dll function")
  unicodeString := hexTostr(hUTF16le)
  asciString := cSzWide2Ansi(unicodeString)
  memowrit("unicode_test_utf16le.txt",unicodestring+cr+cr+asciString)
  RunShell("unicode_test_utf16le.txt","notepad.exe")

//---------------------- UTF-16	le ot4xb.dll Pablo Bottela FUNKCIJE


//-------------------- UTF-16 le COBA FUNKCIJE ZA UTF-8

  * NE MOE DA PREVEDE - STRINGOVI OSTAJU KAO UTF
  *------------------------------------------------
  msgbox("UTF-16 litlle endian: UTF8_TO__Latin1250(unicodestring)","COBA utf to latin function")
  unicodeString := hexTostr(hUTF16le)
  asciString := UTF8_TO__Latin1250(unicodeString)
  memowrit("unicode_test_utf16le.txt",unicodestring+cr+cr+asciString)
  RunShell("unicode_test_utf16le.txt","notepad.exe")

//-------------------- UTF-16 le COBA FUNKCIJE ZA UTF-8


*/

//---------------------- UTF-16	be Xbase++ FUNKCIJE

  * NE MOE DA PREVEDE - DOBIJE SE STRING SA ?????
  *------------------------------------------------
  msgbox("UTF-16 big endian: UnicodeToStr(unicodestring)","Alasaka Xbase++ function")
  unicodeString := hexTostr(hUTF16be)
  asciString := Unicode2Str(unicodeString)
  memowrit("unicode_test_utf16be.txt",unicodestring+cr+cr+asciString)
  RunShell("unicode_test_utf16be.txt","notepad.exe")

//---------------------- UTF-16	be Xbase++ FUNKCIJE


//---------------------- UTF-16	be ot4xb.dll Pablo Bottela FUNKCIJE

  * NE MOE DA PREVEDE - DOBIJE SE STRING SA ?????
  *------------------------------------------------
  msgbox("UTF-16 big endian: cSzWide2Ansi(unicodestring)","Pablo Bottela ot4xb.dll function")
  unicodeString := hexTostr(hUTF16be)
  asciString := cSzWide2Ansi(unicodeString)
  memowrit("unicode_test_utf16be.txt",unicodestring+cr+cr+asciString)
  RunShell("unicode_test_utf16be.txt","notepad.exe")

//---------------------- UTF-16	be ot4xb.dll Pablo Bottela FUNKCIJE


//-------------------- UTF-16 be COBA FUNKCIJE ZA UTF-8

  * NE MOE DA PREVEDE - STRINGOVI OSTAJU KAO UTF
  *------------------------------------------------
  msgbox("UTF-16 big endian: UTF8_TO__Latin1250(unicodestring)","COBA utf to latin function")
  unicodeString := hexTostr(hUTF16be)
  asciString := UTF8_TO__Latin1250(unicodeString)
  memowrit("unicode_test_utf16le.txt",unicodestring+cr+cr+asciString)
  RunShell("unicode_test_utf16le.txt","notepad.exe")

//-------------------- UTF-16 be COBA FUNKCIJE ZA UTF-8





**** QUICK TEST ****






    *-------------------------------------------------------
    * kad se iz komande Xbase++ napravi unicode string:
    * kad se iz komandeot4xb.dll napravi unicode string:
    *-------------------------------------------------------

     ANSI := "(UTF16) Ǝ - QWXY --- ؀׎ - "

     UTF8  := hextostr(hUTF8)
     UTF16 := hextostr(hUTF16le)







IF C__NEDA("COBA KONVERZIJA         " +chr(59)+;
           "konverzija UTF-8 stringa" +chr(59)+;
           "------------------------" +chr(59)+;
           ANSI                       +chr(59)+;
           "u ANSI string i obrnuto " +chr(59)+;
           "","COBA KONVERZIJA",,"12.Consolas")==.T.

//-------------------------------------------------------------------------------------------
// UNICODE UTF-8 dobijen iz SQLite database table iz COBA KONVERZIJE
//-------------------------------------------------------------------------------------------

  c__procitaj(;
  "UTF8 string:"    +chr(59)+;
  " "                                             +chr(59)+;
  strtran(UTF8,chr(0))                            +chr(59)+;
  " "                                             +chr(59)+;
  "prevod u Serbian Latin cp238 po COBA konverzionoj tabli:" +chr(59)+;
  " "                                             +chr(59)+;
  strtran(UTF8_TO__Latin1250(UTF8),chr(0))        +chr(59)+;
  "","Coba UNICODE TO LATINICA",,"12.Consolas")


  c__procitaj(;
  "UTF8 string:"    +chr(59)+;
  " "                                             +chr(59)+;
  strtran(UTF8,chr(0))                            +chr(59)+;
  " "                                             +chr(59)+;
  "prevod u Serbian Cyrilic cp238 po COBA konverzionoj tabli:" +chr(59)+;
  " "                                             +chr(59)+;
  strtran(UTF8_TO__Cyrilic1251(UTF8),chr(0))      +chr(59)+;
  "","Coba UNICODE TO IRILICA",,"12.Consolas")


//-------------------------------------------------------------------------------------------
// UNICODE UTF-8 dobijen iz SQLite database table COBA KONVERZIJA
//-------------------------------------------------------------------------------------------
ENDIF






IF C__NEDA("Alaska Xbase KONVERZIJA " +chr(59)+;
           "za unicode UTF-16le     " +chr(59)+;
           "------------------------" +chr(59)+;
           ANSI                       +chr(59)+;
           "u ANSI string i obrnuto " +chr(59)+;
           "","XBASE KONVERZIJA",,"12.Consolas")==.T.
//-------------------------------------------------------------------------------------------
// UNICODE UTF-16 litlle endian dobijen iz ANSI stringa Alaska Xbase++ funkcijom
//-------------------------------------------------------------------------------------------


  UTF16 := Str2Unicode(ANSI) // ne ume da prevede irilicu



  txt:="Prikaz u NOTEPAD.EXE editoru koji podrava rad"  +cr+;
       "sa unicode karakter setom, UTF-16 stringa koji"  +cr+;
       "je dobijen iz funkcije:                       "  +cr+;
       "                         Str2Unucode()        "  +cr+;
       "a iz ANSI stringa:                            "  +cr+;
       "   "+ANSI                                        +cr+;
       " "
  msgbox(txt,"UTF-16")
  memowrit("tekst.txt",UTF16)
  RunShell("tekst.txt","notepad.exe")

 * Funkcija Str2Unicode () pretvara niz znakova ANSI u format Unicode.
 * Primarna upotreba Str2Unicode () je u kombinaciji s API-jem matine platforme.
 * Biljeka
 * Str2Unicode () vraa niz u UTF-16 Little Endian kodiranja, to je izvorno kodiranje
 * koje se koristi za Unicode nizove znakova na Windows platformi.

  txt:="Oito je da Alaska Xbase++ funkcija StrToUnicode()"   +cr+;
       "ne radi sa slovima Ǝ i sa slovima irilice"  +cr+;
       "jer ta slova nisu prevedena a prevedena su: QWXY "
  msgbox(txt,"UTF-16")

//----------------------------------------------------------------------------






  // strtran(UTF16,chr(0)) unicode UTF-16 string za prikaz u msgbox-u
  // koji ne radi sa unicode, ne ume da prikae unicode slova

  IF IsUnicode(UTF16)==.T.
     c__procitaj("string: "+chr(59)+;
            strtran(UTF16,chr(0))+chr(59)+;
            "je unicode UTF-16 string","IsUnicode()",,"12.Consolas")
  ELSE
     c__procitaj("string; "+chr(59)+;
            strtran(UTF16,chr(0))+chr(59)+;
            "nije unicode UTF-16 string","IsUnicode()",,"12.Consolas")
  ENDIF


  UTF16_ANSI := Unicode2Str(UTF16) // prevoenje unicode UTF-16 le natrag u ANSI string


  txt := ;
  " "                                             +chr(59)+;
  "ANSI string: "                                 +chr(59)+;
  " "                                             +chr(59)+;
  ANSI                                            +chr(59)+;
  " "                                             +chr(59)+;
  "sa StrToUnicode() preveden u UTF16 string:"    +chr(59)+;
  " "                                             +chr(59)+;
  strtran(UTF16,chr(0))                           +chr(59)+;
  " "                                             +chr(59)+;
  "UTF16 string:"                                 +chr(59)+;
  " "                                             +chr(59)+;
  strtran(UTF16,chr(0))                           +chr(59)+;
  " "                                             +chr(59)+;
  "sa UnicodeToStr() preveden u ANSI string:"     +chr(59)+;
  " "                                             +chr(59)+;
  UTF16_ANSI                                      +chr(59)+;
  " "                                             +chr(59)


  c__procitaj(txt, "Xbase++ func: Unicode2Str() - StrToUnicode()",,"12.Consolas")


 // prikaz u nitepad.exe koja podrava rad sa unicode
  memowrit("tekst.txt",strtran(txt,chr(59),chr(13)+chr(10)))
  RunShell("tekst.txt","notepad.exe")




  c__procitaj(;
  "UTF16 string:"    +chr(59)+;
  " "                                             +chr(59)+;
  strtran(UTF16,chr(0))                           +chr(59)+;
  " "                                             +chr(59)+;
  "Neuspeo prevod u Serbian Latin cp238 po COBA konverzionoj tabli:" +chr(59)+;
  " "                                             +chr(59)+;
  strtran(UTF8_TO__Latin1250(UTF16),chr(0))       +chr(59)+;
  "","Coba UNICODE TO LATINICA",,"12.Consolas")


  c__procitaj(;
  "UTF16 string:"    +chr(59)+;
  " "                                             +chr(59)+;
  strtran(UTF16,chr(0))                           +chr(59)+;
  " "                                             +chr(59)+;
  "Neuspeo prevod u Serbian Cyrilic cp238 po COBA konverzionoj tabli:" +chr(59)+;
  " "                                             +chr(59)+;
  strtran(UTF8_TO__Cyrilic1251(UTF16),chr(0))     +chr(59)+;
  "","Coba UNICODE TO IRILICA",,"12.Consolas")



//-------------------------------------------------------------------------------------------
// UNICODE UTF-16 litlle endian dobijen iz ANSI stringa Alaska Xbase++ funkcijom
//-------------------------------------------------------------------------------------------
ENDIF



RETURN NIL


/*

How can I make the same file readable in Xbase ? is this a code page issue where can it be set ?
not shure about arabic while i use chinese Sign ;)

your 2nd Picture show a normal DBU using some "local System" Font which does not "match".
so use some Code like this to change Font "on-fly" in a Browse.


Code:

   oBrowse:itemRbDown := {| aMousePos, aRowCol, oSelf | ;
                            ChangeFont(aRowCol, oSelf) }

PROCEDURE ChangeFont(aRowCol,oBrowse)
LOCAL oFontDlg
LOCAL oFnt
LOCAL nPosi  := aRowCol[2]
LOCAL OldFnt := oBrowse:GetColumn(nPosi):dataArea:setFont()

   oFontDlg := XbpFontDialog():new(oBrowse)  // Objekt erzeugen
   oFontDlg:familyName := OldFnt:familyName
   // Font-Dialog konfigurieren
   oFontDlg:create()                 // Dialog anfordern
   oFnt := oFontDlg:display()        // Dialog aktivieren
   IF oFnt <> NIL
      MSGBOX("Font :"+LTRIM(STR(oFnt:nominalPointSize))+"."+;
                      oFnt:compoundName+CHR(13)+" Codepage :"+;
                      LTRIM(STR(oFnt:codePage)) )

      oBrowse:GetColumn(nPosi):dataArea:setFont(oFnt)
      oBrowse:refreshall()
   ENDIF
   oFontDlg:destroy()
RETURN
Note : every Column use a Font Object which have to setup before.

for more Informationen see Alaska Newsgroup
public.xbase++.generic
Mixing ANSI/ASCII and Unicode
Philip Jackson
21. Mai 2011

_________________
greetings by OHR
Jimmy





pierredaou wrote:
Hi Jimmy, thank you and sorry for my late reply.

Still at point 0. Again, how can you invoke the FontDialog inside you PRG ( in a DCget for example ) "using all the installed fonts you have inside Windows".
sorry im not a Express++ User so i cant say about DC* Function.

i use Xbase++ itemRbDown Slot in XbpBrowse

with :getColumn( <nColPos> ) --> oXbpColumn.
after this i call Fontdialog and set it to oXbpColumn.

you have to "set-up" Font to every Columne after :addColumn()
Code:
   imax    := FCount()
   aStruct := DbStruct()
   FOR i:=1 TO imax
      IF .NOT. aStruct[i,2] $ "BOVTXY"
         oBrowse:addColumn( FieldBlockTrimmed(aStruct[i,1], aStruct[i,2]), , aStruct[i,1] )
      ENDIF
   NEXT

   i := 0
   FOR i := 1 TO imax
      DO CASE
         CASE i = 1
            oBrowse:GetColumn( 1 ) :dataArea:setFont( oFnt1  )

         CASE i = 2
            IF ID_CHINA
               oBrowse:GetColumn( 2 ) :dataArea:setFont( oFnt2 )  // second font
            ELSE
               oBrowse:GetColumn( 2 ) :dataArea:setFont( oFnt1  )
            ENDIF

         CASE i = 3
            oBrowse:GetColumn( 3 ) :dataArea:setFont( oFnt1  )

         CASE i = 4
            IF ID_CHINA
               oBrowse:GetColumn( 4 ) :dataArea:setFont( oFnt1  )
            ELSE
               oBrowse:GetColumn( 4 ) :dataArea:setFont( oFnt2 )  // second font
            ENDIF
      ENDCASE
   NEXT
oFnt1 / oFnt2 are XbpFont() Object (chinese / german) which are "set-up" before.

now you can use itemRbDown Slot this Way
Code:
...
   oBrowse:itemRbDown := {| aMousePos, aRowCol, oSelf | ;
                            ChangeFont(aRowCol, oSelf) }
...

PROCEDURE ChangeFont(aRowCol,oBrowse)
LOCAL oFontDlg
LOCAL oFnt
LOCAL nPosi  := aRowCol[2]
LOCAL OldFnt
LOCAL bSaveError := ERRORBLOCK( { | oError | BREAK( oError ) } )

   //
   // if no Font have been set before, it will CRASH here !!!
   //
   BEGIN SEQUENCE
      OldFnt := oBrowse:GetColumn(nPosi):dataArea:setFont()
   RECOVER USING oError
      ERRORBLOCK( bSaveError )
      msgbox("not FONT Object set to Columne before","Error old Font")
      RETURN
   END SEQUENCE
   ERRORBLOCK( bSaveError )

   oFontDlg := XbpFontDialog():new(oBrowse)  // Objekt erzeugen
   oFontDlg:familyName := OldFnt:familyName

   // Font-Dialog konfigurieren
   oFontDlg:create()                 // Dialog anfordern
   oFnt := oFontDlg:display()        // Dialog aktivieren

   IF oFnt <> NIL
      MSGBOX("Font :"+LTRIM(STR(oFnt:nominalPointSize))+"."+;
                      oFnt:compoundName+CHR(13)+" Codepage :"+;
                      LTRIM(STR(oFnt:codePage)) )

      oBrowse:GetColumn(nPosi):dataArea:setFont(oFnt)
      oBrowse:refreshall()
   ENDIF

   oFontDlg:destroy()

RETURN

_________________
greetings by OHR
Jimmy


*/



***************************************************************************
FUNCTION unicode_u_browseru()
***************************************************************************
LOCAL radno:=SELECT()
LOCAL  GetList := {}, oDlg, GetOptions, oBrowse

LOCAL astructure := {;
{"ID_"           ,"N", 3    ,0},;  // INTEGER
{"CNAME_"        ,"C", 40   ,0}}
DbCreate( "UNICODE", aStructure, "DBFNTX" )


USE UNICODE NEW EXCLUSIVE VIA "DBFNTX"
APPEND BLANK
REPLACE ID_ WITH 1 CNAME_ WITH "Ǝ - QWXY - ؀׎ - "
APPEND BLANK
REPLACE ID_ WITH 2 CNAME_ WITH "Slobodan Stanojevi"
APPEND BLANK
REPLACE ID_ WITH 3 CNAME_ WITH "Latinica irilica"
APPEND BLANK
REPLACE ID_ WITH 4 CNAME_ WITH " "
APPEND BLANK
REPLACE ID_ WITH 5 CNAME_ WITH "Latinica "
USE

of3 := Fo_lat(11,"Consolas") // CSYSTEMSU.DLL
hor:=60
ver:=12

USE UNICODE NEW EXCLUSIVE VIA "DBFNTX" alias "UNICODE"

PUBLIC RC := NIL

 @ 01,01 DCBROWSE oBrowse ALIAS "UNICODE" ; // FIT ;
         SIZE HOR,VER ;  //         CURSORMODE XBPBRW_CURSOR_CELL;
         ITEMMARKED {|aRowCol, uNIL2, oself| RC := aRowCol } ;
         ITEMSELECTED{|uNIL1, uNIL2, oself| ChangeFont(RC, oSelf), DC_GetRefresh(GetList)}


        * EVAL {|o|o:setfont(of3)}

        * ITEMMARKED {|aRowCol, uNIL2, oself| aRowCol:=aRowCol } ;
        * EDIT xbeBRW_ItemSelected

  DCBROWSECOL FIELD UNICODE->ID_ WIDTH 3  PARENT oBrowse FONT "13.Verdana"
  DCBROWSECOL FIELD UNICODE->CNAME_ WIDTH 40 PARENT oBrowse FONT "11.Consolas"


DCGETOPTIONS NORESIZE
DCREAD GUI TITLE "Test" FIT ;
   OPTIONS GetOptions ;
   MODAL ;
   PARENT @oDlg ;
   SETFOCUS @oBrowse ;
   EVAL {|o| SetAppWindow(o)}

USE
SELECT(radno)
RETURN NIL


*********************************************
FUNCTION ChangeFont(aRowCol,oBrowse)
*********************************************
LOCAL oFontDlg
LOCAL oFnt
LOCAL nPosi
LOCAL OldFnt
LOCAL bSaveError

* stop(aRowCol,1)
IF aRowCol==NIL
   RETURN NIL
ENDIF

nPosi  := aRowCol[2]
bSaveError := ERRORBLOCK( { | oError | BREAK( oError ) } )
   //
   // if no Font have been set before, it will CRASH here !!!
   //
   BEGIN SEQUENCE
      OldFnt := oBrowse:GetColumn(nPosi):dataArea:setFont()
      STOP( OldFnt:familyName, 1)
   RECOVER USING oError
      ERRORBLOCK( bSaveError )
      msgbox("not FONT Object set to Columne before","Error old Font")
      RETURN
   END SEQUENCE
   ERRORBLOCK( bSaveError )

   oFontDlg := XbpFontDialog():new(oBrowse)  // Objekt erzeugen
   oFontDlg:familyName := OldFnt:familyName

   // Font-Dialog konfigurieren
   oFontDlg:create()                 // Dialog anfordern
   oFnt := oFontDlg:display()        // Dialog aktivieren

   IF oFnt <> NIL
      MSGBOX("Font :"+LTRIM(STR(oFnt:nominalPointSize))+"."+;
                      oFnt:compoundName+CHR(13)+" Codepage :"+;
                      LTRIM(STR(oFnt:codePage)) )

      oBrowse:GetColumn(nPosi):dataArea:setFont(oFnt)
      oBrowse:refreshall()
   ENDIF

   oFontDlg:destroy()

RETURN NIL






* 23-11-2019
***********************************************************************
FUNCTION coba_rtf_trans() // rtf translacija latin/cyrilic
***********************************************************************
* dobijanje source coda za translacionu tabelu latinice i irilice:

  niz1 := "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
  niz2 := "abcdefghijklmnopqrstuvwxyz"
  niz3 := "Ǝ"
  niz4 := ""

* niz5 := "ABVGDEZIKLMNOPRSTUFHCȊJ LJ NJ  D Y"  // irilica

  niz5 := "؀"          // irilica

  niz6 := ""

* niz:=niz1+niz2+niz3+niz4+niz5+niz6

set printer to "niz.txt"
set print on
set console off
? "********************************************************"
? "FUNCTION RTF_coba_latin_cyrilic(nCHR)"
? "********************************************************"
? "* COBA Systems Software, www.cobasystems.com, 23.11.2019"
? "* TABLA ZA KONVERZIJU LATINICE I IRILICE ZA RTF TEKST"
? "* Konverzija se vri iz CHR koda u HEX kod znaka (slova)"
? "* parametar: nCHR = chr kod znaka (slova)"
? "* return   : cHEX = hex kod znaka (slova)"
? " "
? "LOCAL aTr[250]  // do 248 "
? "LOCAL i, cHEX, xx, yy, cc, cccc, ff "
? "AFILL( aTr, chr(42) )   // u svaki lan upii *"
? " "
? "* Eng.Latin cp238/1250 VELIKA SLOVA"
? " "
for i=1 to len(niz1)

    xx:=substr(niz1,i,1)
    yy:=asc(xx)
    cc:=var2char(yy)
    cccc := strtohex(xx)
    ff:= "aTr["  +cc+  "] " + ":= " + '"\'  +  "'"  + cccc + '"' + "    // " + xx

    ? ff

next i
? " "
? "* Eng.Latin cp238/1250 MALA SLOVA"
? " "
for i=1 to len(niz2)

    xx:=substr(niz2,i,1)
    yy:=asc(xx)
    cc:=var2char(yy)
    cccc := strtohex(xx)
    ff:= "aTr["  +cc+  "] " + ":= " + '"\'  +  "'"  + cccc + '"' + "    // " + xx

    ? ff

next i
? " "
? "* Serbian Latin cp238/1250"
? "* Extended character set - VELIKA I MALA SLOVA"
? " "
niz := niz3+niz4
for i=1 to len(niz)

    xx:=substr(niz,i,1)
    yy:=asc(xx)
    cc:=var2char(yy)
    cccc := strtohex(xx)
    ff:= "aTr["  +cc+  "] " + ":= " + '"\'  +  "'"  + cccc + '"' + "    // " + xx

    ? ff

next i

? " "
? "* Serbian Cyrilic cp204/1251 VELIKA SLOVA"
? " "
for i=1 to len(niz5)

    xx:=substr(niz5,i,1)
    yy:=asc(xx)
    cc:=var2char(yy)
    cccc := strtohex(xx)
    ff:= "aTr["  +cc+  "] " + ":= " + '"\'  +  "'"  + cccc + '"' + "    // " + xx +;
         " = " + Cyrilic1251_TO_Latin1250(xx)

    ? ff

next i

? " "
? "* Serbian Cyrilic cp204/1251 MALA SLOVA"
? " "
for i=1 to len(niz6)

    xx:=substr(niz6,i,1)
    yy:=asc(xx)
    cc:=var2char(yy)
    cccc := strtohex(xx)
    ff:= "aTr["  +cc+  "] " + ":= " + '"\'  +  "'"  + cccc + '"' + "    // " + xx + ;
         " = " + Cyrilic1251_TO_Latin1250(xx)

    ? ff

next i



? " "
? "* ::aTr := aTr     // code for class function "
? "* RETURN Self      // code for class function "
? " "
? "  cHEX := aTr[nCHR]"
? " "
? "RETURN cHEX"
? "********* END FUNCTION RTF_coba_latin_cyrilic() *******"
set printer to
set print off
set console on

runshell("niz.txt","notepad.exe")
return nil

